// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/aiplatform/v1/specialist_pool_service.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2faiplatform_2fv1_2fspecialist_5fpool_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2faiplatform_2fv1_2fspecialist_5fpool_5fservice_2eproto__INCLUDED

#include "google/cloud/aiplatform/v1/specialist_pool_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace aiplatform {
namespace v1 {

// A service for creating and managing Customer SpecialistPools.
// When customers start Data Labeling jobs, they can reuse/create Specialist
// Pools to bring their own Specialists to label the data.
// Customers can add/remove Managers for the Specialist Pool on Cloud console,
// then Managers will get email notifications to manage Specialists and tasks on
// CrowdCompute console.
class SpecialistPoolService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.aiplatform.v1.SpecialistPoolService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a SpecialistPool.
    virtual ::grpc::Status CreateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateSpecialistPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateSpecialistPoolRaw(context, request, cq));
    }
    // Gets a SpecialistPool.
    virtual ::grpc::Status GetSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest& request, ::google::cloud::aiplatform::v1::SpecialistPool* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::SpecialistPool>> AsyncGetSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::SpecialistPool>>(AsyncGetSpecialistPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::SpecialistPool>> PrepareAsyncGetSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::SpecialistPool>>(PrepareAsyncGetSpecialistPoolRaw(context, request, cq));
    }
    // Lists SpecialistPools in a Location.
    virtual ::grpc::Status ListSpecialistPools(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest& request, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse>> AsyncListSpecialistPools(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse>>(AsyncListSpecialistPoolsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse>> PrepareAsyncListSpecialistPools(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse>>(PrepareAsyncListSpecialistPoolsRaw(context, request, cq));
    }
    // Deletes a SpecialistPool as well as all Specialists in the pool.
    virtual ::grpc::Status DeleteSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteSpecialistPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteSpecialistPoolRaw(context, request, cq));
    }
    // Updates a SpecialistPool.
    virtual ::grpc::Status UpdateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateSpecialistPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateSpecialistPoolRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a SpecialistPool.
      virtual void CreateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a SpecialistPool.
      virtual void GetSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest* request, ::google::cloud::aiplatform::v1::SpecialistPool* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest* request, ::google::cloud::aiplatform::v1::SpecialistPool* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists SpecialistPools in a Location.
      virtual void ListSpecialistPools(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest* request, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSpecialistPools(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest* request, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a SpecialistPool as well as all Specialists in the pool.
      virtual void DeleteSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a SpecialistPool.
      virtual void UpdateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateSpecialistPoolRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateSpecialistPoolRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::SpecialistPool>* AsyncGetSpecialistPoolRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::SpecialistPool>* PrepareAsyncGetSpecialistPoolRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse>* AsyncListSpecialistPoolsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse>* PrepareAsyncListSpecialistPoolsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteSpecialistPoolRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteSpecialistPoolRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateSpecialistPoolRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateSpecialistPoolRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateSpecialistPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateSpecialistPoolRaw(context, request, cq));
    }
    ::grpc::Status GetSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest& request, ::google::cloud::aiplatform::v1::SpecialistPool* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::SpecialistPool>> AsyncGetSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::SpecialistPool>>(AsyncGetSpecialistPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::SpecialistPool>> PrepareAsyncGetSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::SpecialistPool>>(PrepareAsyncGetSpecialistPoolRaw(context, request, cq));
    }
    ::grpc::Status ListSpecialistPools(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest& request, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse>> AsyncListSpecialistPools(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse>>(AsyncListSpecialistPoolsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse>> PrepareAsyncListSpecialistPools(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse>>(PrepareAsyncListSpecialistPoolsRaw(context, request, cq));
    }
    ::grpc::Status DeleteSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteSpecialistPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteSpecialistPoolRaw(context, request, cq));
    }
    ::grpc::Status UpdateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateSpecialistPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateSpecialistPoolRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest* request, ::google::cloud::aiplatform::v1::SpecialistPool* response, std::function<void(::grpc::Status)>) override;
      void GetSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest* request, ::google::cloud::aiplatform::v1::SpecialistPool* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListSpecialistPools(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest* request, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSpecialistPools(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest* request, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateSpecialistPool(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateSpecialistPoolRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateSpecialistPoolRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::SpecialistPool>* AsyncGetSpecialistPoolRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::SpecialistPool>* PrepareAsyncGetSpecialistPoolRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse>* AsyncListSpecialistPoolsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse>* PrepareAsyncListSpecialistPoolsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteSpecialistPoolRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteSpecialistPoolRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateSpecialistPoolRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateSpecialistPoolRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateSpecialistPool_;
    const ::grpc::internal::RpcMethod rpcmethod_GetSpecialistPool_;
    const ::grpc::internal::RpcMethod rpcmethod_ListSpecialistPools_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteSpecialistPool_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateSpecialistPool_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a SpecialistPool.
    virtual ::grpc::Status CreateSpecialistPool(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest* request, ::google::longrunning::Operation* response);
    // Gets a SpecialistPool.
    virtual ::grpc::Status GetSpecialistPool(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest* request, ::google::cloud::aiplatform::v1::SpecialistPool* response);
    // Lists SpecialistPools in a Location.
    virtual ::grpc::Status ListSpecialistPools(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest* request, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse* response);
    // Deletes a SpecialistPool as well as all Specialists in the pool.
    virtual ::grpc::Status DeleteSpecialistPool(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest* request, ::google::longrunning::Operation* response);
    // Updates a SpecialistPool.
    virtual ::grpc::Status UpdateSpecialistPool(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateSpecialistPool() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSpecialistPool(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetSpecialistPool() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest* /*request*/, ::google::cloud::aiplatform::v1::SpecialistPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSpecialistPool(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::SpecialistPool>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSpecialistPools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSpecialistPools() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ListSpecialistPools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSpecialistPools(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSpecialistPools(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteSpecialistPool() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSpecialistPool(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateSpecialistPool() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_UpdateSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSpecialistPool(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateSpecialistPool<WithAsyncMethod_GetSpecialistPool<WithAsyncMethod_ListSpecialistPools<WithAsyncMethod_DeleteSpecialistPool<WithAsyncMethod_UpdateSpecialistPool<Service > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateSpecialistPool() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest* request, ::google::longrunning::Operation* response) { return this->CreateSpecialistPool(context, request, response); }));}
    void SetMessageAllocatorFor_CreateSpecialistPool(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSpecialistPool(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetSpecialistPool() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest, ::google::cloud::aiplatform::v1::SpecialistPool>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest* request, ::google::cloud::aiplatform::v1::SpecialistPool* response) { return this->GetSpecialistPool(context, request, response); }));}
    void SetMessageAllocatorFor_GetSpecialistPool(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest, ::google::cloud::aiplatform::v1::SpecialistPool>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest, ::google::cloud::aiplatform::v1::SpecialistPool>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest* /*request*/, ::google::cloud::aiplatform::v1::SpecialistPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSpecialistPool(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest* /*request*/, ::google::cloud::aiplatform::v1::SpecialistPool* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListSpecialistPools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSpecialistPools() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest* request, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse* response) { return this->ListSpecialistPools(context, request, response); }));}
    void SetMessageAllocatorFor_ListSpecialistPools(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSpecialistPools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSpecialistPools(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSpecialistPools(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteSpecialistPool() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest* request, ::google::longrunning::Operation* response) { return this->DeleteSpecialistPool(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteSpecialistPool(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSpecialistPool(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateSpecialistPool() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest* request, ::google::longrunning::Operation* response) { return this->UpdateSpecialistPool(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateSpecialistPool(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSpecialistPool(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateSpecialistPool<WithCallbackMethod_GetSpecialistPool<WithCallbackMethod_ListSpecialistPools<WithCallbackMethod_DeleteSpecialistPool<WithCallbackMethod_UpdateSpecialistPool<Service > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateSpecialistPool() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetSpecialistPool() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest* /*request*/, ::google::cloud::aiplatform::v1::SpecialistPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListSpecialistPools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSpecialistPools() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ListSpecialistPools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSpecialistPools(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteSpecialistPool() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateSpecialistPool() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_UpdateSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateSpecialistPool() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSpecialistPool(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetSpecialistPool() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest* /*request*/, ::google::cloud::aiplatform::v1::SpecialistPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSpecialistPool(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSpecialistPools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSpecialistPools() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ListSpecialistPools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSpecialistPools(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSpecialistPools(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteSpecialistPool() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSpecialistPool(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateSpecialistPool() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_UpdateSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSpecialistPool(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateSpecialistPool() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateSpecialistPool(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSpecialistPool(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetSpecialistPool() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetSpecialistPool(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest* /*request*/, ::google::cloud::aiplatform::v1::SpecialistPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSpecialistPool(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSpecialistPools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSpecialistPools() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSpecialistPools(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSpecialistPools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSpecialistPools(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSpecialistPools(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteSpecialistPool() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteSpecialistPool(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSpecialistPool(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateSpecialistPool() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateSpecialistPool(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSpecialistPool(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateSpecialistPool() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateSpecialistPool(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateSpecialistPool(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::CreateSpecialistPoolRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetSpecialistPool() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest, ::google::cloud::aiplatform::v1::SpecialistPool>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest, ::google::cloud::aiplatform::v1::SpecialistPool>* streamer) {
                       return this->StreamedGetSpecialistPool(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest* /*request*/, ::google::cloud::aiplatform::v1::SpecialistPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetSpecialistPool(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::GetSpecialistPoolRequest,::google::cloud::aiplatform::v1::SpecialistPool>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSpecialistPools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSpecialistPools() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse>* streamer) {
                       return this->StreamedListSpecialistPools(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSpecialistPools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSpecialistPools(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSpecialistPools(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::ListSpecialistPoolsRequest,::google::cloud::aiplatform::v1::ListSpecialistPoolsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteSpecialistPool() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteSpecialistPool(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteSpecialistPool(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateSpecialistPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateSpecialistPool() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateSpecialistPool(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateSpecialistPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateSpecialistPool(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateSpecialistPool(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateSpecialistPool<WithStreamedUnaryMethod_GetSpecialistPool<WithStreamedUnaryMethod_ListSpecialistPools<WithStreamedUnaryMethod_DeleteSpecialistPool<WithStreamedUnaryMethod_UpdateSpecialistPool<Service > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateSpecialistPool<WithStreamedUnaryMethod_GetSpecialistPool<WithStreamedUnaryMethod_ListSpecialistPools<WithStreamedUnaryMethod_DeleteSpecialistPool<WithStreamedUnaryMethod_UpdateSpecialistPool<Service > > > > > StreamedService;
};

}  // namespace v1
}  // namespace aiplatform
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2faiplatform_2fv1_2fspecialist_5fpool_5fservice_2eproto__INCLUDED
