// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/global_addresses/v1/global_addresses.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_GLOBAL_ADDRESSES_V1_GLOBAL_ADDRESSES_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_GLOBAL_ADDRESSES_V1_GLOBAL_ADDRESSES_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/global_addresses/v1/global_addresses.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_global_addresses_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class GlobalAddressesConnectionIdempotencyPolicy {
 public:
  virtual ~GlobalAddressesConnectionIdempotencyPolicy();

  /// Create a new copy of this object.
  virtual std::unique_ptr<GlobalAddressesConnectionIdempotencyPolicy> clone()
      const;

  virtual google::cloud::Idempotency DeleteAddress(
      google::cloud::cpp::compute::global_addresses::v1::
          DeleteAddressRequest const& request);

  virtual google::cloud::Idempotency GetAddress(
      google::cloud::cpp::compute::global_addresses::v1::
          GetAddressRequest const& request);

  virtual google::cloud::Idempotency InsertAddress(
      google::cloud::cpp::compute::global_addresses::v1::
          InsertAddressRequest const& request);

  virtual google::cloud::Idempotency ListGlobalAddresses(
      google::cloud::cpp::compute::global_addresses::v1::
          ListGlobalAddressesRequest request);

  virtual google::cloud::Idempotency Move(
      google::cloud::cpp::compute::global_addresses::v1::MoveRequest const&
          request);

  virtual google::cloud::Idempotency SetLabels(
      google::cloud::cpp::compute::global_addresses::v1::SetLabelsRequest const&
          request);
};

std::unique_ptr<GlobalAddressesConnectionIdempotencyPolicy>
MakeDefaultGlobalAddressesConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_global_addresses_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_GLOBAL_ADDRESSES_V1_GLOBAL_ADDRESSES_CONNECTION_IDEMPOTENCY_POLICY_H
