// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/vpn_gateways/v1/vpn_gateways.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_VPN_GATEWAYS_V1_VPN_GATEWAYS_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_VPN_GATEWAYS_V1_VPN_GATEWAYS_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/vpn_gateways/v1/vpn_gateways.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_vpn_gateways_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class VpnGatewaysConnectionIdempotencyPolicy {
 public:
  virtual ~VpnGatewaysConnectionIdempotencyPolicy();

  /// Create a new copy of this object.
  virtual std::unique_ptr<VpnGatewaysConnectionIdempotencyPolicy> clone() const;

  virtual google::cloud::Idempotency AggregatedListVpnGateways(
      google::cloud::cpp::compute::vpn_gateways::v1::
          AggregatedListVpnGatewaysRequest request);

  virtual google::cloud::Idempotency DeleteVpnGateway(
      google::cloud::cpp::compute::vpn_gateways::v1::
          DeleteVpnGatewayRequest const& request);

  virtual google::cloud::Idempotency GetVpnGateway(
      google::cloud::cpp::compute::vpn_gateways::v1::GetVpnGatewayRequest const&
          request);

  virtual google::cloud::Idempotency GetStatus(
      google::cloud::cpp::compute::vpn_gateways::v1::GetStatusRequest const&
          request);

  virtual google::cloud::Idempotency InsertVpnGateway(
      google::cloud::cpp::compute::vpn_gateways::v1::
          InsertVpnGatewayRequest const& request);

  virtual google::cloud::Idempotency ListVpnGateways(
      google::cloud::cpp::compute::vpn_gateways::v1::ListVpnGatewaysRequest
          request);

  virtual google::cloud::Idempotency SetLabels(
      google::cloud::cpp::compute::vpn_gateways::v1::SetLabelsRequest const&
          request);

  virtual google::cloud::Idempotency TestIamPermissions(
      google::cloud::cpp::compute::vpn_gateways::v1::
          TestIamPermissionsRequest const& request);
};

std::unique_ptr<VpnGatewaysConnectionIdempotencyPolicy>
MakeDefaultVpnGatewaysConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_vpn_gateways_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_VPN_GATEWAYS_V1_VPN_GATEWAYS_CONNECTION_IDEMPOTENCY_POLICY_H
