// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/dataproc/v1/jobs.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fdataproc_2fv1_2fjobs_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdataproc_2fv1_2fjobs_2eproto__INCLUDED

#include "google/cloud/dataproc/v1/jobs.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace dataproc {
namespace v1 {

// The JobController provides methods to manage jobs.
class JobController final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.dataproc.v1.JobController";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Submits a job to a cluster.
    virtual ::grpc::Status SubmitJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::google::cloud::dataproc::v1::Job* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>> AsyncSubmitJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>>(AsyncSubmitJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>> PrepareAsyncSubmitJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>>(PrepareAsyncSubmitJobRaw(context, request, cq));
    }
    // Submits job to a cluster.
    virtual ::grpc::Status SubmitJobAsOperation(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncSubmitJobAsOperation(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncSubmitJobAsOperationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncSubmitJobAsOperation(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncSubmitJobAsOperationRaw(context, request, cq));
    }
    // Gets the resource representation for a job in a project.
    virtual ::grpc::Status GetJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetJobRequest& request, ::google::cloud::dataproc::v1::Job* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>> AsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>>(AsyncGetJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>> PrepareAsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>>(PrepareAsyncGetJobRaw(context, request, cq));
    }
    // Lists regions/{region}/jobs in a project.
    virtual ::grpc::Status ListJobs(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListJobsRequest& request, ::google::cloud::dataproc::v1::ListJobsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListJobsResponse>> AsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListJobsResponse>>(AsyncListJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListJobsResponse>> PrepareAsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListJobsResponse>>(PrepareAsyncListJobsRaw(context, request, cq));
    }
    // Updates a job in a project.
    virtual ::grpc::Status UpdateJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateJobRequest& request, ::google::cloud::dataproc::v1::Job* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>> AsyncUpdateJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>>(AsyncUpdateJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>> PrepareAsyncUpdateJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>>(PrepareAsyncUpdateJobRaw(context, request, cq));
    }
    // Starts a job cancellation request. To access the job resource
    // after cancellation, call
    // [regions/{region}/jobs.list](https://cloud.google.com/dataproc/docs/reference/rest/v1/projects.regions.jobs/list)
    // or
    // [regions/{region}/jobs.get](https://cloud.google.com/dataproc/docs/reference/rest/v1/projects.regions.jobs/get).
    virtual ::grpc::Status CancelJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CancelJobRequest& request, ::google::cloud::dataproc::v1::Job* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>> AsyncCancelJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CancelJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>>(AsyncCancelJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>> PrepareAsyncCancelJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CancelJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>>(PrepareAsyncCancelJobRaw(context, request, cq));
    }
    // Deletes the job from the project. If the job is active, the delete fails,
    // and the response returns `FAILED_PRECONDITION`.
    virtual ::grpc::Status DeleteJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteJobRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteJobRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Submits a job to a cluster.
      virtual void SubmitJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest* request, ::google::cloud::dataproc::v1::Job* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SubmitJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest* request, ::google::cloud::dataproc::v1::Job* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Submits job to a cluster.
      virtual void SubmitJobAsOperation(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SubmitJobAsOperation(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the resource representation for a job in a project.
      virtual void GetJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetJobRequest* request, ::google::cloud::dataproc::v1::Job* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetJobRequest* request, ::google::cloud::dataproc::v1::Job* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists regions/{region}/jobs in a project.
      virtual void ListJobs(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListJobsRequest* request, ::google::cloud::dataproc::v1::ListJobsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListJobs(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListJobsRequest* request, ::google::cloud::dataproc::v1::ListJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a job in a project.
      virtual void UpdateJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateJobRequest* request, ::google::cloud::dataproc::v1::Job* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateJobRequest* request, ::google::cloud::dataproc::v1::Job* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Starts a job cancellation request. To access the job resource
      // after cancellation, call
      // [regions/{region}/jobs.list](https://cloud.google.com/dataproc/docs/reference/rest/v1/projects.regions.jobs/list)
      // or
      // [regions/{region}/jobs.get](https://cloud.google.com/dataproc/docs/reference/rest/v1/projects.regions.jobs/get).
      virtual void CancelJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CancelJobRequest* request, ::google::cloud::dataproc::v1::Job* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CancelJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CancelJobRequest* request, ::google::cloud::dataproc::v1::Job* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the job from the project. If the job is active, the delete fails,
      // and the response returns `FAILED_PRECONDITION`.
      virtual void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>* AsyncSubmitJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>* PrepareAsyncSubmitJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncSubmitJobAsOperationRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncSubmitJobAsOperationRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>* AsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>* PrepareAsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListJobsResponse>* AsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListJobsResponse>* PrepareAsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>* AsyncUpdateJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>* PrepareAsyncUpdateJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>* AsyncCancelJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CancelJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::Job>* PrepareAsyncCancelJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CancelJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status SubmitJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::google::cloud::dataproc::v1::Job* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>> AsyncSubmitJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>>(AsyncSubmitJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>> PrepareAsyncSubmitJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>>(PrepareAsyncSubmitJobRaw(context, request, cq));
    }
    ::grpc::Status SubmitJobAsOperation(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncSubmitJobAsOperation(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncSubmitJobAsOperationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncSubmitJobAsOperation(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncSubmitJobAsOperationRaw(context, request, cq));
    }
    ::grpc::Status GetJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetJobRequest& request, ::google::cloud::dataproc::v1::Job* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>> AsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>>(AsyncGetJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>> PrepareAsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>>(PrepareAsyncGetJobRaw(context, request, cq));
    }
    ::grpc::Status ListJobs(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListJobsRequest& request, ::google::cloud::dataproc::v1::ListJobsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListJobsResponse>> AsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListJobsResponse>>(AsyncListJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListJobsResponse>> PrepareAsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListJobsResponse>>(PrepareAsyncListJobsRaw(context, request, cq));
    }
    ::grpc::Status UpdateJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateJobRequest& request, ::google::cloud::dataproc::v1::Job* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>> AsyncUpdateJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>>(AsyncUpdateJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>> PrepareAsyncUpdateJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>>(PrepareAsyncUpdateJobRaw(context, request, cq));
    }
    ::grpc::Status CancelJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CancelJobRequest& request, ::google::cloud::dataproc::v1::Job* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>> AsyncCancelJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CancelJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>>(AsyncCancelJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>> PrepareAsyncCancelJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CancelJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>>(PrepareAsyncCancelJobRaw(context, request, cq));
    }
    ::grpc::Status DeleteJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteJobRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteJobRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void SubmitJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest* request, ::google::cloud::dataproc::v1::Job* response, std::function<void(::grpc::Status)>) override;
      void SubmitJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest* request, ::google::cloud::dataproc::v1::Job* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SubmitJobAsOperation(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void SubmitJobAsOperation(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetJobRequest* request, ::google::cloud::dataproc::v1::Job* response, std::function<void(::grpc::Status)>) override;
      void GetJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetJobRequest* request, ::google::cloud::dataproc::v1::Job* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListJobs(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListJobsRequest* request, ::google::cloud::dataproc::v1::ListJobsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListJobs(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListJobsRequest* request, ::google::cloud::dataproc::v1::ListJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateJobRequest* request, ::google::cloud::dataproc::v1::Job* response, std::function<void(::grpc::Status)>) override;
      void UpdateJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateJobRequest* request, ::google::cloud::dataproc::v1::Job* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CancelJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CancelJobRequest* request, ::google::cloud::dataproc::v1::Job* response, std::function<void(::grpc::Status)>) override;
      void CancelJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CancelJobRequest* request, ::google::cloud::dataproc::v1::Job* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>* AsyncSubmitJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>* PrepareAsyncSubmitJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncSubmitJobAsOperationRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncSubmitJobAsOperationRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>* AsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>* PrepareAsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListJobsResponse>* AsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListJobsResponse>* PrepareAsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>* AsyncUpdateJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>* PrepareAsyncUpdateJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>* AsyncCancelJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CancelJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::Job>* PrepareAsyncCancelJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CancelJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_SubmitJob_;
    const ::grpc::internal::RpcMethod rpcmethod_SubmitJobAsOperation_;
    const ::grpc::internal::RpcMethod rpcmethod_GetJob_;
    const ::grpc::internal::RpcMethod rpcmethod_ListJobs_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateJob_;
    const ::grpc::internal::RpcMethod rpcmethod_CancelJob_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteJob_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Submits a job to a cluster.
    virtual ::grpc::Status SubmitJob(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest* request, ::google::cloud::dataproc::v1::Job* response);
    // Submits job to a cluster.
    virtual ::grpc::Status SubmitJobAsOperation(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest* request, ::google::longrunning::Operation* response);
    // Gets the resource representation for a job in a project.
    virtual ::grpc::Status GetJob(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::GetJobRequest* request, ::google::cloud::dataproc::v1::Job* response);
    // Lists regions/{region}/jobs in a project.
    virtual ::grpc::Status ListJobs(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::ListJobsRequest* request, ::google::cloud::dataproc::v1::ListJobsResponse* response);
    // Updates a job in a project.
    virtual ::grpc::Status UpdateJob(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::UpdateJobRequest* request, ::google::cloud::dataproc::v1::Job* response);
    // Starts a job cancellation request. To access the job resource
    // after cancellation, call
    // [regions/{region}/jobs.list](https://cloud.google.com/dataproc/docs/reference/rest/v1/projects.regions.jobs/list)
    // or
    // [regions/{region}/jobs.get](https://cloud.google.com/dataproc/docs/reference/rest/v1/projects.regions.jobs/get).
    virtual ::grpc::Status CancelJob(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::CancelJobRequest* request, ::google::cloud::dataproc::v1::Job* response);
    // Deletes the job from the project. If the job is active, the delete fails,
    // and the response returns `FAILED_PRECONDITION`.
    virtual ::grpc::Status DeleteJob(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::DeleteJobRequest* request, ::google::protobuf::Empty* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_SubmitJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SubmitJob() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_SubmitJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::SubmitJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSubmitJob(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::SubmitJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataproc::v1::Job>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SubmitJobAsOperation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SubmitJobAsOperation() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_SubmitJobAsOperation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitJobAsOperation(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::SubmitJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSubmitJobAsOperation(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::SubmitJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetJob() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJob(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::GetJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataproc::v1::Job>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListJobs() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListJobsRequest* /*request*/, ::google::cloud::dataproc::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobs(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::ListJobsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataproc::v1::ListJobsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateJob() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_UpdateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateJob(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::UpdateJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataproc::v1::Job>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CancelJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CancelJob() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_CancelJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CancelJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelJob(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::CancelJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataproc::v1::Job>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteJob() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteJob(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::DeleteJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_SubmitJob<WithAsyncMethod_SubmitJobAsOperation<WithAsyncMethod_GetJob<WithAsyncMethod_ListJobs<WithAsyncMethod_UpdateJob<WithAsyncMethod_CancelJob<WithAsyncMethod_DeleteJob<Service > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_SubmitJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SubmitJob() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::SubmitJobRequest, ::google::cloud::dataproc::v1::Job>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest* request, ::google::cloud::dataproc::v1::Job* response) { return this->SubmitJob(context, request, response); }));}
    void SetMessageAllocatorFor_SubmitJob(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::SubmitJobRequest, ::google::cloud::dataproc::v1::Job>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::SubmitJobRequest, ::google::cloud::dataproc::v1::Job>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SubmitJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::SubmitJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SubmitJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::SubmitJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SubmitJobAsOperation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SubmitJobAsOperation() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::SubmitJobRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::SubmitJobRequest* request, ::google::longrunning::Operation* response) { return this->SubmitJobAsOperation(context, request, response); }));}
    void SetMessageAllocatorFor_SubmitJobAsOperation(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::SubmitJobRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::SubmitJobRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SubmitJobAsOperation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitJobAsOperation(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::SubmitJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SubmitJobAsOperation(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::SubmitJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetJob() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::GetJobRequest, ::google::cloud::dataproc::v1::Job>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::GetJobRequest* request, ::google::cloud::dataproc::v1::Job* response) { return this->GetJob(context, request, response); }));}
    void SetMessageAllocatorFor_GetJob(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::GetJobRequest, ::google::cloud::dataproc::v1::Job>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::GetJobRequest, ::google::cloud::dataproc::v1::Job>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListJobs() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::ListJobsRequest, ::google::cloud::dataproc::v1::ListJobsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::ListJobsRequest* request, ::google::cloud::dataproc::v1::ListJobsResponse* response) { return this->ListJobs(context, request, response); }));}
    void SetMessageAllocatorFor_ListJobs(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::ListJobsRequest, ::google::cloud::dataproc::v1::ListJobsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::ListJobsRequest, ::google::cloud::dataproc::v1::ListJobsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListJobsRequest* /*request*/, ::google::cloud::dataproc::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListJobsRequest* /*request*/, ::google::cloud::dataproc::v1::ListJobsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateJob() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::UpdateJobRequest, ::google::cloud::dataproc::v1::Job>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::UpdateJobRequest* request, ::google::cloud::dataproc::v1::Job* response) { return this->UpdateJob(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateJob(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::UpdateJobRequest, ::google::cloud::dataproc::v1::Job>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::UpdateJobRequest, ::google::cloud::dataproc::v1::Job>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CancelJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CancelJob() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::CancelJobRequest, ::google::cloud::dataproc::v1::Job>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::CancelJobRequest* request, ::google::cloud::dataproc::v1::Job* response) { return this->CancelJob(context, request, response); }));}
    void SetMessageAllocatorFor_CancelJob(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::CancelJobRequest, ::google::cloud::dataproc::v1::Job>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::CancelJobRequest, ::google::cloud::dataproc::v1::Job>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CancelJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CancelJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::CancelJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteJob() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::DeleteJobRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::DeleteJobRequest* request, ::google::protobuf::Empty* response) { return this->DeleteJob(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteJob(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::DeleteJobRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::DeleteJobRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_SubmitJob<WithCallbackMethod_SubmitJobAsOperation<WithCallbackMethod_GetJob<WithCallbackMethod_ListJobs<WithCallbackMethod_UpdateJob<WithCallbackMethod_CancelJob<WithCallbackMethod_DeleteJob<Service > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_SubmitJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SubmitJob() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_SubmitJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::SubmitJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SubmitJobAsOperation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SubmitJobAsOperation() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_SubmitJobAsOperation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitJobAsOperation(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::SubmitJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetJob() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListJobs() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListJobsRequest* /*request*/, ::google::cloud::dataproc::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateJob() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_UpdateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CancelJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CancelJob() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_CancelJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CancelJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteJob() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_SubmitJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SubmitJob() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_SubmitJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::SubmitJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSubmitJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SubmitJobAsOperation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SubmitJobAsOperation() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_SubmitJobAsOperation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitJobAsOperation(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::SubmitJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSubmitJobAsOperation(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetJob() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListJobs() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListJobsRequest* /*request*/, ::google::cloud::dataproc::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateJob() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_UpdateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CancelJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CancelJob() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_CancelJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CancelJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteJob() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SubmitJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SubmitJob() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SubmitJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_SubmitJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::SubmitJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SubmitJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SubmitJobAsOperation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SubmitJobAsOperation() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SubmitJobAsOperation(context, request, response); }));
    }
    ~WithRawCallbackMethod_SubmitJobAsOperation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitJobAsOperation(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::SubmitJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SubmitJobAsOperation(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetJob() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListJobs() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListJobs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListJobsRequest* /*request*/, ::google::cloud::dataproc::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateJob() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CancelJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CancelJob() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CancelJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_CancelJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CancelJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteJob() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SubmitJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SubmitJob() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::SubmitJobRequest, ::google::cloud::dataproc::v1::Job>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::SubmitJobRequest, ::google::cloud::dataproc::v1::Job>* streamer) {
                       return this->StreamedSubmitJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SubmitJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SubmitJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::SubmitJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSubmitJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::SubmitJobRequest,::google::cloud::dataproc::v1::Job>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SubmitJobAsOperation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SubmitJobAsOperation() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::SubmitJobRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::SubmitJobRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedSubmitJobAsOperation(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SubmitJobAsOperation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SubmitJobAsOperation(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::SubmitJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSubmitJobAsOperation(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::SubmitJobRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetJob() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::GetJobRequest, ::google::cloud::dataproc::v1::Job>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::GetJobRequest, ::google::cloud::dataproc::v1::Job>* streamer) {
                       return this->StreamedGetJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::GetJobRequest,::google::cloud::dataproc::v1::Job>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListJobs() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::ListJobsRequest, ::google::cloud::dataproc::v1::ListJobsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::ListJobsRequest, ::google::cloud::dataproc::v1::ListJobsResponse>* streamer) {
                       return this->StreamedListJobs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListJobsRequest* /*request*/, ::google::cloud::dataproc::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListJobs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::ListJobsRequest,::google::cloud::dataproc::v1::ListJobsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateJob() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::UpdateJobRequest, ::google::cloud::dataproc::v1::Job>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::UpdateJobRequest, ::google::cloud::dataproc::v1::Job>* streamer) {
                       return this->StreamedUpdateJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::UpdateJobRequest,::google::cloud::dataproc::v1::Job>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CancelJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CancelJob() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::CancelJobRequest, ::google::cloud::dataproc::v1::Job>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::CancelJobRequest, ::google::cloud::dataproc::v1::Job>* streamer) {
                       return this->StreamedCancelJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CancelJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CancelJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CancelJobRequest* /*request*/, ::google::cloud::dataproc::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCancelJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::CancelJobRequest,::google::cloud::dataproc::v1::Job>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteJob() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::DeleteJobRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::DeleteJobRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::DeleteJobRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_SubmitJob<WithStreamedUnaryMethod_SubmitJobAsOperation<WithStreamedUnaryMethod_GetJob<WithStreamedUnaryMethod_ListJobs<WithStreamedUnaryMethod_UpdateJob<WithStreamedUnaryMethod_CancelJob<WithStreamedUnaryMethod_DeleteJob<Service > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_SubmitJob<WithStreamedUnaryMethod_SubmitJobAsOperation<WithStreamedUnaryMethod_GetJob<WithStreamedUnaryMethod_ListJobs<WithStreamedUnaryMethod_UpdateJob<WithStreamedUnaryMethod_CancelJob<WithStreamedUnaryMethod_DeleteJob<Service > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace dataproc
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fdataproc_2fv1_2fjobs_2eproto__INCLUDED
