// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/domains/v1/domains.proto
// Original file comments:
// Copyright 2021 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fdomains_2fv1_2fdomains_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdomains_2fv1_2fdomains_2eproto__INCLUDED

#include "google/cloud/domains/v1/domains.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace domains {
namespace v1 {

// The Cloud Domains API enables management and configuration of domain names.
class Domains final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.domains.v1.Domains";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Searches for available domain names similar to the provided query.
    //
    // Availability results from this method are approximate; call
    // `RetrieveRegisterParameters` on a domain before registering to confirm
    // availability.
    virtual ::grpc::Status SearchDomains(::grpc::ClientContext* context, const ::google::cloud::domains::v1::SearchDomainsRequest& request, ::google::cloud::domains::v1::SearchDomainsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::SearchDomainsResponse>> AsyncSearchDomains(::grpc::ClientContext* context, const ::google::cloud::domains::v1::SearchDomainsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::SearchDomainsResponse>>(AsyncSearchDomainsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::SearchDomainsResponse>> PrepareAsyncSearchDomains(::grpc::ClientContext* context, const ::google::cloud::domains::v1::SearchDomainsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::SearchDomainsResponse>>(PrepareAsyncSearchDomainsRaw(context, request, cq));
    }
    // Gets parameters needed to register a new domain name, including price and
    // up-to-date availability. Use the returned values to call `RegisterDomain`.
    virtual ::grpc::Status RetrieveRegisterParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest& request, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::RetrieveRegisterParametersResponse>> AsyncRetrieveRegisterParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::RetrieveRegisterParametersResponse>>(AsyncRetrieveRegisterParametersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::RetrieveRegisterParametersResponse>> PrepareAsyncRetrieveRegisterParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::RetrieveRegisterParametersResponse>>(PrepareAsyncRetrieveRegisterParametersRaw(context, request, cq));
    }
    // Registers a new domain name and creates a corresponding `Registration`
    // resource.
    //
    // Call `RetrieveRegisterParameters` first to check availability of the domain
    // name and determine parameters like price that are needed to build a call to
    // this method.
    //
    // A successful call creates a `Registration` resource in state
    // `REGISTRATION_PENDING`, which resolves to `ACTIVE` within 1-2
    // minutes, indicating that the domain was successfully registered. If the
    // resource ends up in state `REGISTRATION_FAILED`, it indicates that the
    // domain was not registered successfully, and you can safely delete the
    // resource and retry registration.
    virtual ::grpc::Status RegisterDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RegisterDomainRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncRegisterDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RegisterDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncRegisterDomainRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncRegisterDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RegisterDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncRegisterDomainRaw(context, request, cq));
    }
    // Gets parameters needed to transfer a domain name from another registrar to
    // Cloud Domains. For domains managed by Google Domains, transferring to Cloud
    // Domains is not supported.
    //
    //
    // Use the returned values to call `TransferDomain`.
    virtual ::grpc::Status RetrieveTransferParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest& request, ::google::cloud::domains::v1::RetrieveTransferParametersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::RetrieveTransferParametersResponse>> AsyncRetrieveTransferParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::RetrieveTransferParametersResponse>>(AsyncRetrieveTransferParametersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::RetrieveTransferParametersResponse>> PrepareAsyncRetrieveTransferParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::RetrieveTransferParametersResponse>>(PrepareAsyncRetrieveTransferParametersRaw(context, request, cq));
    }
    // Transfers a domain name from another registrar to Cloud Domains.  For
    // domains managed by Google Domains, transferring to Cloud Domains is not
    // supported.
    //
    //
    // Before calling this method, go to the domain's current registrar to unlock
    // the domain for transfer and retrieve the domain's transfer authorization
    // code. Then call `RetrieveTransferParameters` to confirm that the domain is
    // unlocked and to get values needed to build a call to this method.
    //
    // A successful call creates a `Registration` resource in state
    // `TRANSFER_PENDING`. It can take several days to complete the transfer
    // process. The registrant can often speed up this process by approving the
    // transfer through the current registrar, either by clicking a link in an
    // email from the registrar or by visiting the registrar's website.
    //
    // A few minutes after transfer approval, the resource transitions to state
    // `ACTIVE`, indicating that the transfer was successful. If the transfer is
    // rejected or the request expires without being approved, the resource can
    // end up in state `TRANSFER_FAILED`. If transfer fails, you can safely delete
    // the resource and retry the transfer.
    virtual ::grpc::Status TransferDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::TransferDomainRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncTransferDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::TransferDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncTransferDomainRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncTransferDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::TransferDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncTransferDomainRaw(context, request, cq));
    }
    // Lists the `Registration` resources in a project.
    virtual ::grpc::Status ListRegistrations(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ListRegistrationsRequest& request, ::google::cloud::domains::v1::ListRegistrationsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::ListRegistrationsResponse>> AsyncListRegistrations(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ListRegistrationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::ListRegistrationsResponse>>(AsyncListRegistrationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::ListRegistrationsResponse>> PrepareAsyncListRegistrations(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ListRegistrationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::ListRegistrationsResponse>>(PrepareAsyncListRegistrationsRaw(context, request, cq));
    }
    // Gets the details of a `Registration` resource.
    virtual ::grpc::Status GetRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::GetRegistrationRequest& request, ::google::cloud::domains::v1::Registration* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::Registration>> AsyncGetRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::GetRegistrationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::Registration>>(AsyncGetRegistrationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::Registration>> PrepareAsyncGetRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::GetRegistrationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::Registration>>(PrepareAsyncGetRegistrationRaw(context, request, cq));
    }
    // Updates select fields of a `Registration` resource, notably `labels`. To
    // update other fields, use the appropriate custom update method:
    //
    // * To update management settings, see `ConfigureManagementSettings`
    // * To update DNS configuration, see `ConfigureDnsSettings`
    // * To update contact information, see `ConfigureContactSettings`
    virtual ::grpc::Status UpdateRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::UpdateRegistrationRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::UpdateRegistrationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateRegistrationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::UpdateRegistrationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateRegistrationRaw(context, request, cq));
    }
    // Updates a `Registration`'s management settings.
    virtual ::grpc::Status ConfigureManagementSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncConfigureManagementSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncConfigureManagementSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncConfigureManagementSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncConfigureManagementSettingsRaw(context, request, cq));
    }
    // Updates a `Registration`'s DNS settings.
    virtual ::grpc::Status ConfigureDnsSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncConfigureDnsSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncConfigureDnsSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncConfigureDnsSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncConfigureDnsSettingsRaw(context, request, cq));
    }
    // Updates a `Registration`'s contact settings. Some changes require
    // confirmation by the domain's registrant contact .
    virtual ::grpc::Status ConfigureContactSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncConfigureContactSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncConfigureContactSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncConfigureContactSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncConfigureContactSettingsRaw(context, request, cq));
    }
    // Exports a `Registration` resource, such that it is no longer managed by
    // Cloud Domains.
    //
    // When an active domain is successfully exported, you can continue to use the
    // domain in [Google Domains](https://domains.google/) until it expires. The
    // calling user becomes the domain's sole owner in Google Domains, and
    // permissions for the domain are subsequently managed there. The domain does
    // not renew automatically unless the new owner sets up billing in Google
    // Domains.
    virtual ::grpc::Status ExportRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ExportRegistrationRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncExportRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ExportRegistrationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncExportRegistrationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncExportRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ExportRegistrationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncExportRegistrationRaw(context, request, cq));
    }
    // Deletes a `Registration` resource.
    //
    // This method works on any `Registration` resource using [Subscription or
    // Commitment billing](/domains/pricing#billing-models), provided that the
    // resource was created at least 1 day in the past.
    //
    // For `Registration` resources using
    // [Monthly billing](/domains/pricing#billing-models), this method works if:
    //
    // * `state` is `EXPORTED` with `expire_time` in the past
    // * `state` is `REGISTRATION_FAILED`
    // * `state` is `TRANSFER_FAILED`
    //
    // When an active registration is successfully deleted, you can continue to
    // use the domain in [Google Domains](https://domains.google/) until it
    // expires. The calling user becomes the domain's sole owner in Google
    // Domains, and permissions for the domain are subsequently managed there. The
    // domain does not renew automatically unless the new owner sets up billing in
    // Google Domains.
    virtual ::grpc::Status DeleteRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::DeleteRegistrationRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::DeleteRegistrationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteRegistrationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::DeleteRegistrationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteRegistrationRaw(context, request, cq));
    }
    // Gets the authorization code of the `Registration` for the purpose of
    // transferring the domain to another registrar.
    //
    // You can call this method only after 60 days have elapsed since the initial
    // domain registration.
    virtual ::grpc::Status RetrieveAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest& request, ::google::cloud::domains::v1::AuthorizationCode* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::AuthorizationCode>> AsyncRetrieveAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::AuthorizationCode>>(AsyncRetrieveAuthorizationCodeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::AuthorizationCode>> PrepareAsyncRetrieveAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::AuthorizationCode>>(PrepareAsyncRetrieveAuthorizationCodeRaw(context, request, cq));
    }
    // Resets the authorization code of the `Registration` to a new random string.
    //
    // You can call this method only after 60 days have elapsed since the initial
    // domain registration.
    virtual ::grpc::Status ResetAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest& request, ::google::cloud::domains::v1::AuthorizationCode* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::AuthorizationCode>> AsyncResetAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::AuthorizationCode>>(AsyncResetAuthorizationCodeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::AuthorizationCode>> PrepareAsyncResetAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::AuthorizationCode>>(PrepareAsyncResetAuthorizationCodeRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Searches for available domain names similar to the provided query.
      //
      // Availability results from this method are approximate; call
      // `RetrieveRegisterParameters` on a domain before registering to confirm
      // availability.
      virtual void SearchDomains(::grpc::ClientContext* context, const ::google::cloud::domains::v1::SearchDomainsRequest* request, ::google::cloud::domains::v1::SearchDomainsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchDomains(::grpc::ClientContext* context, const ::google::cloud::domains::v1::SearchDomainsRequest* request, ::google::cloud::domains::v1::SearchDomainsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets parameters needed to register a new domain name, including price and
      // up-to-date availability. Use the returned values to call `RegisterDomain`.
      virtual void RetrieveRegisterParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest* request, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RetrieveRegisterParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest* request, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Registers a new domain name and creates a corresponding `Registration`
      // resource.
      //
      // Call `RetrieveRegisterParameters` first to check availability of the domain
      // name and determine parameters like price that are needed to build a call to
      // this method.
      //
      // A successful call creates a `Registration` resource in state
      // `REGISTRATION_PENDING`, which resolves to `ACTIVE` within 1-2
      // minutes, indicating that the domain was successfully registered. If the
      // resource ends up in state `REGISTRATION_FAILED`, it indicates that the
      // domain was not registered successfully, and you can safely delete the
      // resource and retry registration.
      virtual void RegisterDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RegisterDomainRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RegisterDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RegisterDomainRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets parameters needed to transfer a domain name from another registrar to
      // Cloud Domains. For domains managed by Google Domains, transferring to Cloud
      // Domains is not supported.
      //
      //
      // Use the returned values to call `TransferDomain`.
      virtual void RetrieveTransferParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest* request, ::google::cloud::domains::v1::RetrieveTransferParametersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RetrieveTransferParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest* request, ::google::cloud::domains::v1::RetrieveTransferParametersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Transfers a domain name from another registrar to Cloud Domains.  For
      // domains managed by Google Domains, transferring to Cloud Domains is not
      // supported.
      //
      //
      // Before calling this method, go to the domain's current registrar to unlock
      // the domain for transfer and retrieve the domain's transfer authorization
      // code. Then call `RetrieveTransferParameters` to confirm that the domain is
      // unlocked and to get values needed to build a call to this method.
      //
      // A successful call creates a `Registration` resource in state
      // `TRANSFER_PENDING`. It can take several days to complete the transfer
      // process. The registrant can often speed up this process by approving the
      // transfer through the current registrar, either by clicking a link in an
      // email from the registrar or by visiting the registrar's website.
      //
      // A few minutes after transfer approval, the resource transitions to state
      // `ACTIVE`, indicating that the transfer was successful. If the transfer is
      // rejected or the request expires without being approved, the resource can
      // end up in state `TRANSFER_FAILED`. If transfer fails, you can safely delete
      // the resource and retry the transfer.
      virtual void TransferDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::TransferDomainRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TransferDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::TransferDomainRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the `Registration` resources in a project.
      virtual void ListRegistrations(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ListRegistrationsRequest* request, ::google::cloud::domains::v1::ListRegistrationsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListRegistrations(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ListRegistrationsRequest* request, ::google::cloud::domains::v1::ListRegistrationsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the details of a `Registration` resource.
      virtual void GetRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::GetRegistrationRequest* request, ::google::cloud::domains::v1::Registration* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::GetRegistrationRequest* request, ::google::cloud::domains::v1::Registration* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates select fields of a `Registration` resource, notably `labels`. To
      // update other fields, use the appropriate custom update method:
      //
      // * To update management settings, see `ConfigureManagementSettings`
      // * To update DNS configuration, see `ConfigureDnsSettings`
      // * To update contact information, see `ConfigureContactSettings`
      virtual void UpdateRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::UpdateRegistrationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::UpdateRegistrationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a `Registration`'s management settings.
      virtual void ConfigureManagementSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ConfigureManagementSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a `Registration`'s DNS settings.
      virtual void ConfigureDnsSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ConfigureDnsSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a `Registration`'s contact settings. Some changes require
      // confirmation by the domain's registrant contact .
      virtual void ConfigureContactSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ConfigureContactSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Exports a `Registration` resource, such that it is no longer managed by
      // Cloud Domains.
      //
      // When an active domain is successfully exported, you can continue to use the
      // domain in [Google Domains](https://domains.google/) until it expires. The
      // calling user becomes the domain's sole owner in Google Domains, and
      // permissions for the domain are subsequently managed there. The domain does
      // not renew automatically unless the new owner sets up billing in Google
      // Domains.
      virtual void ExportRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ExportRegistrationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ExportRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ExportRegistrationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a `Registration` resource.
      //
      // This method works on any `Registration` resource using [Subscription or
      // Commitment billing](/domains/pricing#billing-models), provided that the
      // resource was created at least 1 day in the past.
      //
      // For `Registration` resources using
      // [Monthly billing](/domains/pricing#billing-models), this method works if:
      //
      // * `state` is `EXPORTED` with `expire_time` in the past
      // * `state` is `REGISTRATION_FAILED`
      // * `state` is `TRANSFER_FAILED`
      //
      // When an active registration is successfully deleted, you can continue to
      // use the domain in [Google Domains](https://domains.google/) until it
      // expires. The calling user becomes the domain's sole owner in Google
      // Domains, and permissions for the domain are subsequently managed there. The
      // domain does not renew automatically unless the new owner sets up billing in
      // Google Domains.
      virtual void DeleteRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::DeleteRegistrationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::DeleteRegistrationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the authorization code of the `Registration` for the purpose of
      // transferring the domain to another registrar.
      //
      // You can call this method only after 60 days have elapsed since the initial
      // domain registration.
      virtual void RetrieveAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest* request, ::google::cloud::domains::v1::AuthorizationCode* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RetrieveAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest* request, ::google::cloud::domains::v1::AuthorizationCode* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Resets the authorization code of the `Registration` to a new random string.
      //
      // You can call this method only after 60 days have elapsed since the initial
      // domain registration.
      virtual void ResetAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest* request, ::google::cloud::domains::v1::AuthorizationCode* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ResetAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest* request, ::google::cloud::domains::v1::AuthorizationCode* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::SearchDomainsResponse>* AsyncSearchDomainsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::SearchDomainsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::SearchDomainsResponse>* PrepareAsyncSearchDomainsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::SearchDomainsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::RetrieveRegisterParametersResponse>* AsyncRetrieveRegisterParametersRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::RetrieveRegisterParametersResponse>* PrepareAsyncRetrieveRegisterParametersRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncRegisterDomainRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RegisterDomainRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncRegisterDomainRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RegisterDomainRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::RetrieveTransferParametersResponse>* AsyncRetrieveTransferParametersRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::RetrieveTransferParametersResponse>* PrepareAsyncRetrieveTransferParametersRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncTransferDomainRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::TransferDomainRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncTransferDomainRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::TransferDomainRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::ListRegistrationsResponse>* AsyncListRegistrationsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ListRegistrationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::ListRegistrationsResponse>* PrepareAsyncListRegistrationsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ListRegistrationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::Registration>* AsyncGetRegistrationRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::GetRegistrationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::Registration>* PrepareAsyncGetRegistrationRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::GetRegistrationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateRegistrationRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::UpdateRegistrationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateRegistrationRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::UpdateRegistrationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncConfigureManagementSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncConfigureManagementSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncConfigureDnsSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncConfigureDnsSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncConfigureContactSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncConfigureContactSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncExportRegistrationRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ExportRegistrationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncExportRegistrationRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ExportRegistrationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteRegistrationRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::DeleteRegistrationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteRegistrationRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::DeleteRegistrationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::AuthorizationCode>* AsyncRetrieveAuthorizationCodeRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::AuthorizationCode>* PrepareAsyncRetrieveAuthorizationCodeRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::AuthorizationCode>* AsyncResetAuthorizationCodeRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::domains::v1::AuthorizationCode>* PrepareAsyncResetAuthorizationCodeRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status SearchDomains(::grpc::ClientContext* context, const ::google::cloud::domains::v1::SearchDomainsRequest& request, ::google::cloud::domains::v1::SearchDomainsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::SearchDomainsResponse>> AsyncSearchDomains(::grpc::ClientContext* context, const ::google::cloud::domains::v1::SearchDomainsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::SearchDomainsResponse>>(AsyncSearchDomainsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::SearchDomainsResponse>> PrepareAsyncSearchDomains(::grpc::ClientContext* context, const ::google::cloud::domains::v1::SearchDomainsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::SearchDomainsResponse>>(PrepareAsyncSearchDomainsRaw(context, request, cq));
    }
    ::grpc::Status RetrieveRegisterParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest& request, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::RetrieveRegisterParametersResponse>> AsyncRetrieveRegisterParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::RetrieveRegisterParametersResponse>>(AsyncRetrieveRegisterParametersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::RetrieveRegisterParametersResponse>> PrepareAsyncRetrieveRegisterParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::RetrieveRegisterParametersResponse>>(PrepareAsyncRetrieveRegisterParametersRaw(context, request, cq));
    }
    ::grpc::Status RegisterDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RegisterDomainRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncRegisterDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RegisterDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncRegisterDomainRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncRegisterDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RegisterDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncRegisterDomainRaw(context, request, cq));
    }
    ::grpc::Status RetrieveTransferParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest& request, ::google::cloud::domains::v1::RetrieveTransferParametersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::RetrieveTransferParametersResponse>> AsyncRetrieveTransferParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::RetrieveTransferParametersResponse>>(AsyncRetrieveTransferParametersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::RetrieveTransferParametersResponse>> PrepareAsyncRetrieveTransferParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::RetrieveTransferParametersResponse>>(PrepareAsyncRetrieveTransferParametersRaw(context, request, cq));
    }
    ::grpc::Status TransferDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::TransferDomainRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncTransferDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::TransferDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncTransferDomainRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncTransferDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::TransferDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncTransferDomainRaw(context, request, cq));
    }
    ::grpc::Status ListRegistrations(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ListRegistrationsRequest& request, ::google::cloud::domains::v1::ListRegistrationsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::ListRegistrationsResponse>> AsyncListRegistrations(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ListRegistrationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::ListRegistrationsResponse>>(AsyncListRegistrationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::ListRegistrationsResponse>> PrepareAsyncListRegistrations(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ListRegistrationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::ListRegistrationsResponse>>(PrepareAsyncListRegistrationsRaw(context, request, cq));
    }
    ::grpc::Status GetRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::GetRegistrationRequest& request, ::google::cloud::domains::v1::Registration* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::Registration>> AsyncGetRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::GetRegistrationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::Registration>>(AsyncGetRegistrationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::Registration>> PrepareAsyncGetRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::GetRegistrationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::Registration>>(PrepareAsyncGetRegistrationRaw(context, request, cq));
    }
    ::grpc::Status UpdateRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::UpdateRegistrationRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::UpdateRegistrationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateRegistrationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::UpdateRegistrationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateRegistrationRaw(context, request, cq));
    }
    ::grpc::Status ConfigureManagementSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncConfigureManagementSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncConfigureManagementSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncConfigureManagementSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncConfigureManagementSettingsRaw(context, request, cq));
    }
    ::grpc::Status ConfigureDnsSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncConfigureDnsSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncConfigureDnsSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncConfigureDnsSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncConfigureDnsSettingsRaw(context, request, cq));
    }
    ::grpc::Status ConfigureContactSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncConfigureContactSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncConfigureContactSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncConfigureContactSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncConfigureContactSettingsRaw(context, request, cq));
    }
    ::grpc::Status ExportRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ExportRegistrationRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncExportRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ExportRegistrationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncExportRegistrationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncExportRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ExportRegistrationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncExportRegistrationRaw(context, request, cq));
    }
    ::grpc::Status DeleteRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::DeleteRegistrationRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::DeleteRegistrationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteRegistrationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::DeleteRegistrationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteRegistrationRaw(context, request, cq));
    }
    ::grpc::Status RetrieveAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest& request, ::google::cloud::domains::v1::AuthorizationCode* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::AuthorizationCode>> AsyncRetrieveAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::AuthorizationCode>>(AsyncRetrieveAuthorizationCodeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::AuthorizationCode>> PrepareAsyncRetrieveAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::AuthorizationCode>>(PrepareAsyncRetrieveAuthorizationCodeRaw(context, request, cq));
    }
    ::grpc::Status ResetAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest& request, ::google::cloud::domains::v1::AuthorizationCode* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::AuthorizationCode>> AsyncResetAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::AuthorizationCode>>(AsyncResetAuthorizationCodeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::AuthorizationCode>> PrepareAsyncResetAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::AuthorizationCode>>(PrepareAsyncResetAuthorizationCodeRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void SearchDomains(::grpc::ClientContext* context, const ::google::cloud::domains::v1::SearchDomainsRequest* request, ::google::cloud::domains::v1::SearchDomainsResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchDomains(::grpc::ClientContext* context, const ::google::cloud::domains::v1::SearchDomainsRequest* request, ::google::cloud::domains::v1::SearchDomainsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RetrieveRegisterParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest* request, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse* response, std::function<void(::grpc::Status)>) override;
      void RetrieveRegisterParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest* request, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RegisterDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RegisterDomainRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RegisterDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RegisterDomainRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RetrieveTransferParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest* request, ::google::cloud::domains::v1::RetrieveTransferParametersResponse* response, std::function<void(::grpc::Status)>) override;
      void RetrieveTransferParameters(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest* request, ::google::cloud::domains::v1::RetrieveTransferParametersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void TransferDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::TransferDomainRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void TransferDomain(::grpc::ClientContext* context, const ::google::cloud::domains::v1::TransferDomainRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListRegistrations(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ListRegistrationsRequest* request, ::google::cloud::domains::v1::ListRegistrationsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListRegistrations(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ListRegistrationsRequest* request, ::google::cloud::domains::v1::ListRegistrationsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::GetRegistrationRequest* request, ::google::cloud::domains::v1::Registration* response, std::function<void(::grpc::Status)>) override;
      void GetRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::GetRegistrationRequest* request, ::google::cloud::domains::v1::Registration* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::UpdateRegistrationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::UpdateRegistrationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ConfigureManagementSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ConfigureManagementSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ConfigureDnsSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ConfigureDnsSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ConfigureContactSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ConfigureContactSettings(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ExportRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ExportRegistrationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ExportRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ExportRegistrationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::DeleteRegistrationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteRegistration(::grpc::ClientContext* context, const ::google::cloud::domains::v1::DeleteRegistrationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RetrieveAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest* request, ::google::cloud::domains::v1::AuthorizationCode* response, std::function<void(::grpc::Status)>) override;
      void RetrieveAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest* request, ::google::cloud::domains::v1::AuthorizationCode* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ResetAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest* request, ::google::cloud::domains::v1::AuthorizationCode* response, std::function<void(::grpc::Status)>) override;
      void ResetAuthorizationCode(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest* request, ::google::cloud::domains::v1::AuthorizationCode* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::SearchDomainsResponse>* AsyncSearchDomainsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::SearchDomainsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::SearchDomainsResponse>* PrepareAsyncSearchDomainsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::SearchDomainsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::RetrieveRegisterParametersResponse>* AsyncRetrieveRegisterParametersRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::RetrieveRegisterParametersResponse>* PrepareAsyncRetrieveRegisterParametersRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncRegisterDomainRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RegisterDomainRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncRegisterDomainRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RegisterDomainRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::RetrieveTransferParametersResponse>* AsyncRetrieveTransferParametersRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::RetrieveTransferParametersResponse>* PrepareAsyncRetrieveTransferParametersRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncTransferDomainRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::TransferDomainRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncTransferDomainRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::TransferDomainRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::ListRegistrationsResponse>* AsyncListRegistrationsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ListRegistrationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::ListRegistrationsResponse>* PrepareAsyncListRegistrationsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ListRegistrationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::Registration>* AsyncGetRegistrationRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::GetRegistrationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::Registration>* PrepareAsyncGetRegistrationRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::GetRegistrationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateRegistrationRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::UpdateRegistrationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateRegistrationRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::UpdateRegistrationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncConfigureManagementSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncConfigureManagementSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncConfigureDnsSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncConfigureDnsSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncConfigureContactSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncConfigureContactSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncExportRegistrationRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ExportRegistrationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncExportRegistrationRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ExportRegistrationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteRegistrationRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::DeleteRegistrationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteRegistrationRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::DeleteRegistrationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::AuthorizationCode>* AsyncRetrieveAuthorizationCodeRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::AuthorizationCode>* PrepareAsyncRetrieveAuthorizationCodeRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::AuthorizationCode>* AsyncResetAuthorizationCodeRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::domains::v1::AuthorizationCode>* PrepareAsyncResetAuthorizationCodeRaw(::grpc::ClientContext* context, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_SearchDomains_;
    const ::grpc::internal::RpcMethod rpcmethod_RetrieveRegisterParameters_;
    const ::grpc::internal::RpcMethod rpcmethod_RegisterDomain_;
    const ::grpc::internal::RpcMethod rpcmethod_RetrieveTransferParameters_;
    const ::grpc::internal::RpcMethod rpcmethod_TransferDomain_;
    const ::grpc::internal::RpcMethod rpcmethod_ListRegistrations_;
    const ::grpc::internal::RpcMethod rpcmethod_GetRegistration_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateRegistration_;
    const ::grpc::internal::RpcMethod rpcmethod_ConfigureManagementSettings_;
    const ::grpc::internal::RpcMethod rpcmethod_ConfigureDnsSettings_;
    const ::grpc::internal::RpcMethod rpcmethod_ConfigureContactSettings_;
    const ::grpc::internal::RpcMethod rpcmethod_ExportRegistration_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteRegistration_;
    const ::grpc::internal::RpcMethod rpcmethod_RetrieveAuthorizationCode_;
    const ::grpc::internal::RpcMethod rpcmethod_ResetAuthorizationCode_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Searches for available domain names similar to the provided query.
    //
    // Availability results from this method are approximate; call
    // `RetrieveRegisterParameters` on a domain before registering to confirm
    // availability.
    virtual ::grpc::Status SearchDomains(::grpc::ServerContext* context, const ::google::cloud::domains::v1::SearchDomainsRequest* request, ::google::cloud::domains::v1::SearchDomainsResponse* response);
    // Gets parameters needed to register a new domain name, including price and
    // up-to-date availability. Use the returned values to call `RegisterDomain`.
    virtual ::grpc::Status RetrieveRegisterParameters(::grpc::ServerContext* context, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest* request, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse* response);
    // Registers a new domain name and creates a corresponding `Registration`
    // resource.
    //
    // Call `RetrieveRegisterParameters` first to check availability of the domain
    // name and determine parameters like price that are needed to build a call to
    // this method.
    //
    // A successful call creates a `Registration` resource in state
    // `REGISTRATION_PENDING`, which resolves to `ACTIVE` within 1-2
    // minutes, indicating that the domain was successfully registered. If the
    // resource ends up in state `REGISTRATION_FAILED`, it indicates that the
    // domain was not registered successfully, and you can safely delete the
    // resource and retry registration.
    virtual ::grpc::Status RegisterDomain(::grpc::ServerContext* context, const ::google::cloud::domains::v1::RegisterDomainRequest* request, ::google::longrunning::Operation* response);
    // Gets parameters needed to transfer a domain name from another registrar to
    // Cloud Domains. For domains managed by Google Domains, transferring to Cloud
    // Domains is not supported.
    //
    //
    // Use the returned values to call `TransferDomain`.
    virtual ::grpc::Status RetrieveTransferParameters(::grpc::ServerContext* context, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest* request, ::google::cloud::domains::v1::RetrieveTransferParametersResponse* response);
    // Transfers a domain name from another registrar to Cloud Domains.  For
    // domains managed by Google Domains, transferring to Cloud Domains is not
    // supported.
    //
    //
    // Before calling this method, go to the domain's current registrar to unlock
    // the domain for transfer and retrieve the domain's transfer authorization
    // code. Then call `RetrieveTransferParameters` to confirm that the domain is
    // unlocked and to get values needed to build a call to this method.
    //
    // A successful call creates a `Registration` resource in state
    // `TRANSFER_PENDING`. It can take several days to complete the transfer
    // process. The registrant can often speed up this process by approving the
    // transfer through the current registrar, either by clicking a link in an
    // email from the registrar or by visiting the registrar's website.
    //
    // A few minutes after transfer approval, the resource transitions to state
    // `ACTIVE`, indicating that the transfer was successful. If the transfer is
    // rejected or the request expires without being approved, the resource can
    // end up in state `TRANSFER_FAILED`. If transfer fails, you can safely delete
    // the resource and retry the transfer.
    virtual ::grpc::Status TransferDomain(::grpc::ServerContext* context, const ::google::cloud::domains::v1::TransferDomainRequest* request, ::google::longrunning::Operation* response);
    // Lists the `Registration` resources in a project.
    virtual ::grpc::Status ListRegistrations(::grpc::ServerContext* context, const ::google::cloud::domains::v1::ListRegistrationsRequest* request, ::google::cloud::domains::v1::ListRegistrationsResponse* response);
    // Gets the details of a `Registration` resource.
    virtual ::grpc::Status GetRegistration(::grpc::ServerContext* context, const ::google::cloud::domains::v1::GetRegistrationRequest* request, ::google::cloud::domains::v1::Registration* response);
    // Updates select fields of a `Registration` resource, notably `labels`. To
    // update other fields, use the appropriate custom update method:
    //
    // * To update management settings, see `ConfigureManagementSettings`
    // * To update DNS configuration, see `ConfigureDnsSettings`
    // * To update contact information, see `ConfigureContactSettings`
    virtual ::grpc::Status UpdateRegistration(::grpc::ServerContext* context, const ::google::cloud::domains::v1::UpdateRegistrationRequest* request, ::google::longrunning::Operation* response);
    // Updates a `Registration`'s management settings.
    virtual ::grpc::Status ConfigureManagementSettings(::grpc::ServerContext* context, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest* request, ::google::longrunning::Operation* response);
    // Updates a `Registration`'s DNS settings.
    virtual ::grpc::Status ConfigureDnsSettings(::grpc::ServerContext* context, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest* request, ::google::longrunning::Operation* response);
    // Updates a `Registration`'s contact settings. Some changes require
    // confirmation by the domain's registrant contact .
    virtual ::grpc::Status ConfigureContactSettings(::grpc::ServerContext* context, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest* request, ::google::longrunning::Operation* response);
    // Exports a `Registration` resource, such that it is no longer managed by
    // Cloud Domains.
    //
    // When an active domain is successfully exported, you can continue to use the
    // domain in [Google Domains](https://domains.google/) until it expires. The
    // calling user becomes the domain's sole owner in Google Domains, and
    // permissions for the domain are subsequently managed there. The domain does
    // not renew automatically unless the new owner sets up billing in Google
    // Domains.
    virtual ::grpc::Status ExportRegistration(::grpc::ServerContext* context, const ::google::cloud::domains::v1::ExportRegistrationRequest* request, ::google::longrunning::Operation* response);
    // Deletes a `Registration` resource.
    //
    // This method works on any `Registration` resource using [Subscription or
    // Commitment billing](/domains/pricing#billing-models), provided that the
    // resource was created at least 1 day in the past.
    //
    // For `Registration` resources using
    // [Monthly billing](/domains/pricing#billing-models), this method works if:
    //
    // * `state` is `EXPORTED` with `expire_time` in the past
    // * `state` is `REGISTRATION_FAILED`
    // * `state` is `TRANSFER_FAILED`
    //
    // When an active registration is successfully deleted, you can continue to
    // use the domain in [Google Domains](https://domains.google/) until it
    // expires. The calling user becomes the domain's sole owner in Google
    // Domains, and permissions for the domain are subsequently managed there. The
    // domain does not renew automatically unless the new owner sets up billing in
    // Google Domains.
    virtual ::grpc::Status DeleteRegistration(::grpc::ServerContext* context, const ::google::cloud::domains::v1::DeleteRegistrationRequest* request, ::google::longrunning::Operation* response);
    // Gets the authorization code of the `Registration` for the purpose of
    // transferring the domain to another registrar.
    //
    // You can call this method only after 60 days have elapsed since the initial
    // domain registration.
    virtual ::grpc::Status RetrieveAuthorizationCode(::grpc::ServerContext* context, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest* request, ::google::cloud::domains::v1::AuthorizationCode* response);
    // Resets the authorization code of the `Registration` to a new random string.
    //
    // You can call this method only after 60 days have elapsed since the initial
    // domain registration.
    virtual ::grpc::Status ResetAuthorizationCode(::grpc::ServerContext* context, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest* request, ::google::cloud::domains::v1::AuthorizationCode* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchDomains : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchDomains() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_SearchDomains() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchDomains(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::SearchDomainsRequest* /*request*/, ::google::cloud::domains::v1::SearchDomainsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchDomains(::grpc::ServerContext* context, ::google::cloud::domains::v1::SearchDomainsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::domains::v1::SearchDomainsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RetrieveRegisterParameters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RetrieveRegisterParameters() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_RetrieveRegisterParameters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetrieveRegisterParameters(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest* /*request*/, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRetrieveRegisterParameters(::grpc::ServerContext* context, ::google::cloud::domains::v1::RetrieveRegisterParametersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::domains::v1::RetrieveRegisterParametersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RegisterDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RegisterDomain() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_RegisterDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RegisterDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RegisterDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRegisterDomain(::grpc::ServerContext* context, ::google::cloud::domains::v1::RegisterDomainRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RetrieveTransferParameters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RetrieveTransferParameters() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_RetrieveTransferParameters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetrieveTransferParameters(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest* /*request*/, ::google::cloud::domains::v1::RetrieveTransferParametersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRetrieveTransferParameters(::grpc::ServerContext* context, ::google::cloud::domains::v1::RetrieveTransferParametersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::domains::v1::RetrieveTransferParametersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TransferDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TransferDomain() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_TransferDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TransferDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::TransferDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTransferDomain(::grpc::ServerContext* context, ::google::cloud::domains::v1::TransferDomainRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListRegistrations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListRegistrations() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListRegistrations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRegistrations(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ListRegistrationsRequest* /*request*/, ::google::cloud::domains::v1::ListRegistrationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRegistrations(::grpc::ServerContext* context, ::google::cloud::domains::v1::ListRegistrationsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::domains::v1::ListRegistrationsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetRegistration() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GetRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::GetRegistrationRequest* /*request*/, ::google::cloud::domains::v1::Registration* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRegistration(::grpc::ServerContext* context, ::google::cloud::domains::v1::GetRegistrationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::domains::v1::Registration>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateRegistration() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_UpdateRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::UpdateRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateRegistration(::grpc::ServerContext* context, ::google::cloud::domains::v1::UpdateRegistrationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ConfigureManagementSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ConfigureManagementSettings() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_ConfigureManagementSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ConfigureManagementSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestConfigureManagementSettings(::grpc::ServerContext* context, ::google::cloud::domains::v1::ConfigureManagementSettingsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ConfigureDnsSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ConfigureDnsSettings() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_ConfigureDnsSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ConfigureDnsSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestConfigureDnsSettings(::grpc::ServerContext* context, ::google::cloud::domains::v1::ConfigureDnsSettingsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ConfigureContactSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ConfigureContactSettings() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_ConfigureContactSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ConfigureContactSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestConfigureContactSettings(::grpc::ServerContext* context, ::google::cloud::domains::v1::ConfigureContactSettingsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ExportRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ExportRegistration() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_ExportRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ExportRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportRegistration(::grpc::ServerContext* context, ::google::cloud::domains::v1::ExportRegistrationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteRegistration() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_DeleteRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::DeleteRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteRegistration(::grpc::ServerContext* context, ::google::cloud::domains::v1::DeleteRegistrationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RetrieveAuthorizationCode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RetrieveAuthorizationCode() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_RetrieveAuthorizationCode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetrieveAuthorizationCode(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest* /*request*/, ::google::cloud::domains::v1::AuthorizationCode* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRetrieveAuthorizationCode(::grpc::ServerContext* context, ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::domains::v1::AuthorizationCode>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ResetAuthorizationCode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ResetAuthorizationCode() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_ResetAuthorizationCode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetAuthorizationCode(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest* /*request*/, ::google::cloud::domains::v1::AuthorizationCode* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetAuthorizationCode(::grpc::ServerContext* context, ::google::cloud::domains::v1::ResetAuthorizationCodeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::domains::v1::AuthorizationCode>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_SearchDomains<WithAsyncMethod_RetrieveRegisterParameters<WithAsyncMethod_RegisterDomain<WithAsyncMethod_RetrieveTransferParameters<WithAsyncMethod_TransferDomain<WithAsyncMethod_ListRegistrations<WithAsyncMethod_GetRegistration<WithAsyncMethod_UpdateRegistration<WithAsyncMethod_ConfigureManagementSettings<WithAsyncMethod_ConfigureDnsSettings<WithAsyncMethod_ConfigureContactSettings<WithAsyncMethod_ExportRegistration<WithAsyncMethod_DeleteRegistration<WithAsyncMethod_RetrieveAuthorizationCode<WithAsyncMethod_ResetAuthorizationCode<Service > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_SearchDomains : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchDomains() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::SearchDomainsRequest, ::google::cloud::domains::v1::SearchDomainsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::domains::v1::SearchDomainsRequest* request, ::google::cloud::domains::v1::SearchDomainsResponse* response) { return this->SearchDomains(context, request, response); }));}
    void SetMessageAllocatorFor_SearchDomains(
        ::grpc::MessageAllocator< ::google::cloud::domains::v1::SearchDomainsRequest, ::google::cloud::domains::v1::SearchDomainsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::SearchDomainsRequest, ::google::cloud::domains::v1::SearchDomainsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchDomains() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchDomains(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::SearchDomainsRequest* /*request*/, ::google::cloud::domains::v1::SearchDomainsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchDomains(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::domains::v1::SearchDomainsRequest* /*request*/, ::google::cloud::domains::v1::SearchDomainsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RetrieveRegisterParameters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RetrieveRegisterParameters() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::RetrieveRegisterParametersRequest, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest* request, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse* response) { return this->RetrieveRegisterParameters(context, request, response); }));}
    void SetMessageAllocatorFor_RetrieveRegisterParameters(
        ::grpc::MessageAllocator< ::google::cloud::domains::v1::RetrieveRegisterParametersRequest, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::RetrieveRegisterParametersRequest, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RetrieveRegisterParameters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetrieveRegisterParameters(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest* /*request*/, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RetrieveRegisterParameters(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest* /*request*/, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RegisterDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RegisterDomain() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::RegisterDomainRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::domains::v1::RegisterDomainRequest* request, ::google::longrunning::Operation* response) { return this->RegisterDomain(context, request, response); }));}
    void SetMessageAllocatorFor_RegisterDomain(
        ::grpc::MessageAllocator< ::google::cloud::domains::v1::RegisterDomainRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::RegisterDomainRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RegisterDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RegisterDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RegisterDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RegisterDomain(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::domains::v1::RegisterDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RetrieveTransferParameters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RetrieveTransferParameters() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::RetrieveTransferParametersRequest, ::google::cloud::domains::v1::RetrieveTransferParametersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest* request, ::google::cloud::domains::v1::RetrieveTransferParametersResponse* response) { return this->RetrieveTransferParameters(context, request, response); }));}
    void SetMessageAllocatorFor_RetrieveTransferParameters(
        ::grpc::MessageAllocator< ::google::cloud::domains::v1::RetrieveTransferParametersRequest, ::google::cloud::domains::v1::RetrieveTransferParametersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::RetrieveTransferParametersRequest, ::google::cloud::domains::v1::RetrieveTransferParametersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RetrieveTransferParameters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetrieveTransferParameters(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest* /*request*/, ::google::cloud::domains::v1::RetrieveTransferParametersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RetrieveTransferParameters(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest* /*request*/, ::google::cloud::domains::v1::RetrieveTransferParametersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_TransferDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_TransferDomain() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::TransferDomainRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::domains::v1::TransferDomainRequest* request, ::google::longrunning::Operation* response) { return this->TransferDomain(context, request, response); }));}
    void SetMessageAllocatorFor_TransferDomain(
        ::grpc::MessageAllocator< ::google::cloud::domains::v1::TransferDomainRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::TransferDomainRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_TransferDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TransferDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::TransferDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TransferDomain(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::domains::v1::TransferDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListRegistrations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListRegistrations() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::ListRegistrationsRequest, ::google::cloud::domains::v1::ListRegistrationsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::domains::v1::ListRegistrationsRequest* request, ::google::cloud::domains::v1::ListRegistrationsResponse* response) { return this->ListRegistrations(context, request, response); }));}
    void SetMessageAllocatorFor_ListRegistrations(
        ::grpc::MessageAllocator< ::google::cloud::domains::v1::ListRegistrationsRequest, ::google::cloud::domains::v1::ListRegistrationsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::ListRegistrationsRequest, ::google::cloud::domains::v1::ListRegistrationsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListRegistrations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRegistrations(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ListRegistrationsRequest* /*request*/, ::google::cloud::domains::v1::ListRegistrationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRegistrations(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::domains::v1::ListRegistrationsRequest* /*request*/, ::google::cloud::domains::v1::ListRegistrationsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetRegistration() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::GetRegistrationRequest, ::google::cloud::domains::v1::Registration>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::domains::v1::GetRegistrationRequest* request, ::google::cloud::domains::v1::Registration* response) { return this->GetRegistration(context, request, response); }));}
    void SetMessageAllocatorFor_GetRegistration(
        ::grpc::MessageAllocator< ::google::cloud::domains::v1::GetRegistrationRequest, ::google::cloud::domains::v1::Registration>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::GetRegistrationRequest, ::google::cloud::domains::v1::Registration>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::GetRegistrationRequest* /*request*/, ::google::cloud::domains::v1::Registration* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRegistration(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::domains::v1::GetRegistrationRequest* /*request*/, ::google::cloud::domains::v1::Registration* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateRegistration() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::UpdateRegistrationRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::domains::v1::UpdateRegistrationRequest* request, ::google::longrunning::Operation* response) { return this->UpdateRegistration(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateRegistration(
        ::grpc::MessageAllocator< ::google::cloud::domains::v1::UpdateRegistrationRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::UpdateRegistrationRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::UpdateRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateRegistration(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::domains::v1::UpdateRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ConfigureManagementSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ConfigureManagementSettings() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::ConfigureManagementSettingsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest* request, ::google::longrunning::Operation* response) { return this->ConfigureManagementSettings(context, request, response); }));}
    void SetMessageAllocatorFor_ConfigureManagementSettings(
        ::grpc::MessageAllocator< ::google::cloud::domains::v1::ConfigureManagementSettingsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::ConfigureManagementSettingsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ConfigureManagementSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ConfigureManagementSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ConfigureManagementSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ConfigureDnsSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ConfigureDnsSettings() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::ConfigureDnsSettingsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest* request, ::google::longrunning::Operation* response) { return this->ConfigureDnsSettings(context, request, response); }));}
    void SetMessageAllocatorFor_ConfigureDnsSettings(
        ::grpc::MessageAllocator< ::google::cloud::domains::v1::ConfigureDnsSettingsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::ConfigureDnsSettingsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ConfigureDnsSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ConfigureDnsSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ConfigureDnsSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ConfigureContactSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ConfigureContactSettings() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::ConfigureContactSettingsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest* request, ::google::longrunning::Operation* response) { return this->ConfigureContactSettings(context, request, response); }));}
    void SetMessageAllocatorFor_ConfigureContactSettings(
        ::grpc::MessageAllocator< ::google::cloud::domains::v1::ConfigureContactSettingsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::ConfigureContactSettingsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ConfigureContactSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ConfigureContactSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ConfigureContactSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ExportRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ExportRegistration() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::ExportRegistrationRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::domains::v1::ExportRegistrationRequest* request, ::google::longrunning::Operation* response) { return this->ExportRegistration(context, request, response); }));}
    void SetMessageAllocatorFor_ExportRegistration(
        ::grpc::MessageAllocator< ::google::cloud::domains::v1::ExportRegistrationRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::ExportRegistrationRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ExportRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ExportRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ExportRegistration(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::domains::v1::ExportRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteRegistration() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::DeleteRegistrationRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::domains::v1::DeleteRegistrationRequest* request, ::google::longrunning::Operation* response) { return this->DeleteRegistration(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteRegistration(
        ::grpc::MessageAllocator< ::google::cloud::domains::v1::DeleteRegistrationRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::DeleteRegistrationRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::DeleteRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteRegistration(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::domains::v1::DeleteRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RetrieveAuthorizationCode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RetrieveAuthorizationCode() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest, ::google::cloud::domains::v1::AuthorizationCode>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest* request, ::google::cloud::domains::v1::AuthorizationCode* response) { return this->RetrieveAuthorizationCode(context, request, response); }));}
    void SetMessageAllocatorFor_RetrieveAuthorizationCode(
        ::grpc::MessageAllocator< ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest, ::google::cloud::domains::v1::AuthorizationCode>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest, ::google::cloud::domains::v1::AuthorizationCode>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RetrieveAuthorizationCode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetrieveAuthorizationCode(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest* /*request*/, ::google::cloud::domains::v1::AuthorizationCode* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RetrieveAuthorizationCode(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest* /*request*/, ::google::cloud::domains::v1::AuthorizationCode* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ResetAuthorizationCode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ResetAuthorizationCode() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::ResetAuthorizationCodeRequest, ::google::cloud::domains::v1::AuthorizationCode>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest* request, ::google::cloud::domains::v1::AuthorizationCode* response) { return this->ResetAuthorizationCode(context, request, response); }));}
    void SetMessageAllocatorFor_ResetAuthorizationCode(
        ::grpc::MessageAllocator< ::google::cloud::domains::v1::ResetAuthorizationCodeRequest, ::google::cloud::domains::v1::AuthorizationCode>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::domains::v1::ResetAuthorizationCodeRequest, ::google::cloud::domains::v1::AuthorizationCode>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ResetAuthorizationCode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetAuthorizationCode(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest* /*request*/, ::google::cloud::domains::v1::AuthorizationCode* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetAuthorizationCode(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest* /*request*/, ::google::cloud::domains::v1::AuthorizationCode* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_SearchDomains<WithCallbackMethod_RetrieveRegisterParameters<WithCallbackMethod_RegisterDomain<WithCallbackMethod_RetrieveTransferParameters<WithCallbackMethod_TransferDomain<WithCallbackMethod_ListRegistrations<WithCallbackMethod_GetRegistration<WithCallbackMethod_UpdateRegistration<WithCallbackMethod_ConfigureManagementSettings<WithCallbackMethod_ConfigureDnsSettings<WithCallbackMethod_ConfigureContactSettings<WithCallbackMethod_ExportRegistration<WithCallbackMethod_DeleteRegistration<WithCallbackMethod_RetrieveAuthorizationCode<WithCallbackMethod_ResetAuthorizationCode<Service > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_SearchDomains : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchDomains() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_SearchDomains() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchDomains(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::SearchDomainsRequest* /*request*/, ::google::cloud::domains::v1::SearchDomainsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RetrieveRegisterParameters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RetrieveRegisterParameters() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_RetrieveRegisterParameters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetrieveRegisterParameters(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest* /*request*/, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RegisterDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RegisterDomain() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_RegisterDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RegisterDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RegisterDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RetrieveTransferParameters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RetrieveTransferParameters() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_RetrieveTransferParameters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetrieveTransferParameters(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest* /*request*/, ::google::cloud::domains::v1::RetrieveTransferParametersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TransferDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TransferDomain() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_TransferDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TransferDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::TransferDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListRegistrations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListRegistrations() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListRegistrations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRegistrations(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ListRegistrationsRequest* /*request*/, ::google::cloud::domains::v1::ListRegistrationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetRegistration() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GetRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::GetRegistrationRequest* /*request*/, ::google::cloud::domains::v1::Registration* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateRegistration() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_UpdateRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::UpdateRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ConfigureManagementSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ConfigureManagementSettings() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_ConfigureManagementSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ConfigureManagementSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ConfigureDnsSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ConfigureDnsSettings() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_ConfigureDnsSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ConfigureDnsSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ConfigureContactSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ConfigureContactSettings() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_ConfigureContactSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ConfigureContactSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ExportRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ExportRegistration() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_ExportRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ExportRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteRegistration() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_DeleteRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::DeleteRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RetrieveAuthorizationCode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RetrieveAuthorizationCode() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_RetrieveAuthorizationCode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetrieveAuthorizationCode(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest* /*request*/, ::google::cloud::domains::v1::AuthorizationCode* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ResetAuthorizationCode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ResetAuthorizationCode() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_ResetAuthorizationCode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetAuthorizationCode(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest* /*request*/, ::google::cloud::domains::v1::AuthorizationCode* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchDomains : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchDomains() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_SearchDomains() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchDomains(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::SearchDomainsRequest* /*request*/, ::google::cloud::domains::v1::SearchDomainsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchDomains(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RetrieveRegisterParameters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RetrieveRegisterParameters() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_RetrieveRegisterParameters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetrieveRegisterParameters(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest* /*request*/, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRetrieveRegisterParameters(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RegisterDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RegisterDomain() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_RegisterDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RegisterDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RegisterDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRegisterDomain(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RetrieveTransferParameters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RetrieveTransferParameters() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_RetrieveTransferParameters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetrieveTransferParameters(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest* /*request*/, ::google::cloud::domains::v1::RetrieveTransferParametersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRetrieveTransferParameters(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TransferDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TransferDomain() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_TransferDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TransferDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::TransferDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTransferDomain(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListRegistrations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListRegistrations() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListRegistrations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRegistrations(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ListRegistrationsRequest* /*request*/, ::google::cloud::domains::v1::ListRegistrationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRegistrations(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetRegistration() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GetRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::GetRegistrationRequest* /*request*/, ::google::cloud::domains::v1::Registration* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRegistration(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateRegistration() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_UpdateRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::UpdateRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateRegistration(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ConfigureManagementSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ConfigureManagementSettings() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_ConfigureManagementSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ConfigureManagementSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestConfigureManagementSettings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ConfigureDnsSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ConfigureDnsSettings() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_ConfigureDnsSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ConfigureDnsSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestConfigureDnsSettings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ConfigureContactSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ConfigureContactSettings() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_ConfigureContactSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ConfigureContactSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestConfigureContactSettings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ExportRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ExportRegistration() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_ExportRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ExportRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportRegistration(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteRegistration() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_DeleteRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::DeleteRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteRegistration(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RetrieveAuthorizationCode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RetrieveAuthorizationCode() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_RetrieveAuthorizationCode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetrieveAuthorizationCode(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest* /*request*/, ::google::cloud::domains::v1::AuthorizationCode* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRetrieveAuthorizationCode(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ResetAuthorizationCode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ResetAuthorizationCode() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_ResetAuthorizationCode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetAuthorizationCode(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest* /*request*/, ::google::cloud::domains::v1::AuthorizationCode* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetAuthorizationCode(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchDomains : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchDomains() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchDomains(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchDomains() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchDomains(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::SearchDomainsRequest* /*request*/, ::google::cloud::domains::v1::SearchDomainsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchDomains(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RetrieveRegisterParameters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RetrieveRegisterParameters() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RetrieveRegisterParameters(context, request, response); }));
    }
    ~WithRawCallbackMethod_RetrieveRegisterParameters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetrieveRegisterParameters(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest* /*request*/, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RetrieveRegisterParameters(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RegisterDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RegisterDomain() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RegisterDomain(context, request, response); }));
    }
    ~WithRawCallbackMethod_RegisterDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RegisterDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RegisterDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RegisterDomain(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RetrieveTransferParameters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RetrieveTransferParameters() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RetrieveTransferParameters(context, request, response); }));
    }
    ~WithRawCallbackMethod_RetrieveTransferParameters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetrieveTransferParameters(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest* /*request*/, ::google::cloud::domains::v1::RetrieveTransferParametersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RetrieveTransferParameters(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_TransferDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_TransferDomain() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->TransferDomain(context, request, response); }));
    }
    ~WithRawCallbackMethod_TransferDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TransferDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::TransferDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TransferDomain(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListRegistrations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListRegistrations() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListRegistrations(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListRegistrations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRegistrations(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ListRegistrationsRequest* /*request*/, ::google::cloud::domains::v1::ListRegistrationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRegistrations(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetRegistration() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetRegistration(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::GetRegistrationRequest* /*request*/, ::google::cloud::domains::v1::Registration* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRegistration(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateRegistration() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateRegistration(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::UpdateRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateRegistration(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ConfigureManagementSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ConfigureManagementSettings() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ConfigureManagementSettings(context, request, response); }));
    }
    ~WithRawCallbackMethod_ConfigureManagementSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ConfigureManagementSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ConfigureManagementSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ConfigureDnsSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ConfigureDnsSettings() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ConfigureDnsSettings(context, request, response); }));
    }
    ~WithRawCallbackMethod_ConfigureDnsSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ConfigureDnsSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ConfigureDnsSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ConfigureContactSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ConfigureContactSettings() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ConfigureContactSettings(context, request, response); }));
    }
    ~WithRawCallbackMethod_ConfigureContactSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ConfigureContactSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ConfigureContactSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ExportRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ExportRegistration() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ExportRegistration(context, request, response); }));
    }
    ~WithRawCallbackMethod_ExportRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ExportRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ExportRegistration(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteRegistration() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteRegistration(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::DeleteRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteRegistration(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RetrieveAuthorizationCode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RetrieveAuthorizationCode() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RetrieveAuthorizationCode(context, request, response); }));
    }
    ~WithRawCallbackMethod_RetrieveAuthorizationCode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetrieveAuthorizationCode(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest* /*request*/, ::google::cloud::domains::v1::AuthorizationCode* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RetrieveAuthorizationCode(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ResetAuthorizationCode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ResetAuthorizationCode() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ResetAuthorizationCode(context, request, response); }));
    }
    ~WithRawCallbackMethod_ResetAuthorizationCode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetAuthorizationCode(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest* /*request*/, ::google::cloud::domains::v1::AuthorizationCode* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetAuthorizationCode(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchDomains : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchDomains() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::domains::v1::SearchDomainsRequest, ::google::cloud::domains::v1::SearchDomainsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::domains::v1::SearchDomainsRequest, ::google::cloud::domains::v1::SearchDomainsResponse>* streamer) {
                       return this->StreamedSearchDomains(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchDomains() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchDomains(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::SearchDomainsRequest* /*request*/, ::google::cloud::domains::v1::SearchDomainsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchDomains(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::domains::v1::SearchDomainsRequest,::google::cloud::domains::v1::SearchDomainsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RetrieveRegisterParameters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RetrieveRegisterParameters() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::domains::v1::RetrieveRegisterParametersRequest, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::domains::v1::RetrieveRegisterParametersRequest, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse>* streamer) {
                       return this->StreamedRetrieveRegisterParameters(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RetrieveRegisterParameters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RetrieveRegisterParameters(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveRegisterParametersRequest* /*request*/, ::google::cloud::domains::v1::RetrieveRegisterParametersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRetrieveRegisterParameters(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::domains::v1::RetrieveRegisterParametersRequest,::google::cloud::domains::v1::RetrieveRegisterParametersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RegisterDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RegisterDomain() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::domains::v1::RegisterDomainRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::domains::v1::RegisterDomainRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedRegisterDomain(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RegisterDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RegisterDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RegisterDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRegisterDomain(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::domains::v1::RegisterDomainRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RetrieveTransferParameters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RetrieveTransferParameters() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::domains::v1::RetrieveTransferParametersRequest, ::google::cloud::domains::v1::RetrieveTransferParametersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::domains::v1::RetrieveTransferParametersRequest, ::google::cloud::domains::v1::RetrieveTransferParametersResponse>* streamer) {
                       return this->StreamedRetrieveTransferParameters(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RetrieveTransferParameters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RetrieveTransferParameters(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveTransferParametersRequest* /*request*/, ::google::cloud::domains::v1::RetrieveTransferParametersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRetrieveTransferParameters(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::domains::v1::RetrieveTransferParametersRequest,::google::cloud::domains::v1::RetrieveTransferParametersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TransferDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TransferDomain() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::domains::v1::TransferDomainRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::domains::v1::TransferDomainRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedTransferDomain(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_TransferDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TransferDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::TransferDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTransferDomain(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::domains::v1::TransferDomainRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListRegistrations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListRegistrations() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::domains::v1::ListRegistrationsRequest, ::google::cloud::domains::v1::ListRegistrationsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::domains::v1::ListRegistrationsRequest, ::google::cloud::domains::v1::ListRegistrationsResponse>* streamer) {
                       return this->StreamedListRegistrations(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListRegistrations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListRegistrations(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ListRegistrationsRequest* /*request*/, ::google::cloud::domains::v1::ListRegistrationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListRegistrations(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::domains::v1::ListRegistrationsRequest,::google::cloud::domains::v1::ListRegistrationsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetRegistration() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::domains::v1::GetRegistrationRequest, ::google::cloud::domains::v1::Registration>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::domains::v1::GetRegistrationRequest, ::google::cloud::domains::v1::Registration>* streamer) {
                       return this->StreamedGetRegistration(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::GetRegistrationRequest* /*request*/, ::google::cloud::domains::v1::Registration* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetRegistration(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::domains::v1::GetRegistrationRequest,::google::cloud::domains::v1::Registration>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateRegistration() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::domains::v1::UpdateRegistrationRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::domains::v1::UpdateRegistrationRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateRegistration(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::UpdateRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateRegistration(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::domains::v1::UpdateRegistrationRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ConfigureManagementSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ConfigureManagementSettings() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::domains::v1::ConfigureManagementSettingsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::domains::v1::ConfigureManagementSettingsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedConfigureManagementSettings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ConfigureManagementSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ConfigureManagementSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureManagementSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedConfigureManagementSettings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::domains::v1::ConfigureManagementSettingsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ConfigureDnsSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ConfigureDnsSettings() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::domains::v1::ConfigureDnsSettingsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::domains::v1::ConfigureDnsSettingsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedConfigureDnsSettings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ConfigureDnsSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ConfigureDnsSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureDnsSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedConfigureDnsSettings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::domains::v1::ConfigureDnsSettingsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ConfigureContactSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ConfigureContactSettings() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::domains::v1::ConfigureContactSettingsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::domains::v1::ConfigureContactSettingsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedConfigureContactSettings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ConfigureContactSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ConfigureContactSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ConfigureContactSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedConfigureContactSettings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::domains::v1::ConfigureContactSettingsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ExportRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ExportRegistration() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::domains::v1::ExportRegistrationRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::domains::v1::ExportRegistrationRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedExportRegistration(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ExportRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ExportRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ExportRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedExportRegistration(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::domains::v1::ExportRegistrationRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteRegistration : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteRegistration() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::domains::v1::DeleteRegistrationRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::domains::v1::DeleteRegistrationRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteRegistration(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteRegistration() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteRegistration(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::DeleteRegistrationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteRegistration(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::domains::v1::DeleteRegistrationRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RetrieveAuthorizationCode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RetrieveAuthorizationCode() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest, ::google::cloud::domains::v1::AuthorizationCode>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest, ::google::cloud::domains::v1::AuthorizationCode>* streamer) {
                       return this->StreamedRetrieveAuthorizationCode(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RetrieveAuthorizationCode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RetrieveAuthorizationCode(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest* /*request*/, ::google::cloud::domains::v1::AuthorizationCode* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRetrieveAuthorizationCode(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::domains::v1::RetrieveAuthorizationCodeRequest,::google::cloud::domains::v1::AuthorizationCode>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ResetAuthorizationCode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ResetAuthorizationCode() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::domains::v1::ResetAuthorizationCodeRequest, ::google::cloud::domains::v1::AuthorizationCode>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::domains::v1::ResetAuthorizationCodeRequest, ::google::cloud::domains::v1::AuthorizationCode>* streamer) {
                       return this->StreamedResetAuthorizationCode(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ResetAuthorizationCode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ResetAuthorizationCode(::grpc::ServerContext* /*context*/, const ::google::cloud::domains::v1::ResetAuthorizationCodeRequest* /*request*/, ::google::cloud::domains::v1::AuthorizationCode* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedResetAuthorizationCode(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::domains::v1::ResetAuthorizationCodeRequest,::google::cloud::domains::v1::AuthorizationCode>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_SearchDomains<WithStreamedUnaryMethod_RetrieveRegisterParameters<WithStreamedUnaryMethod_RegisterDomain<WithStreamedUnaryMethod_RetrieveTransferParameters<WithStreamedUnaryMethod_TransferDomain<WithStreamedUnaryMethod_ListRegistrations<WithStreamedUnaryMethod_GetRegistration<WithStreamedUnaryMethod_UpdateRegistration<WithStreamedUnaryMethod_ConfigureManagementSettings<WithStreamedUnaryMethod_ConfigureDnsSettings<WithStreamedUnaryMethod_ConfigureContactSettings<WithStreamedUnaryMethod_ExportRegistration<WithStreamedUnaryMethod_DeleteRegistration<WithStreamedUnaryMethod_RetrieveAuthorizationCode<WithStreamedUnaryMethod_ResetAuthorizationCode<Service > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_SearchDomains<WithStreamedUnaryMethod_RetrieveRegisterParameters<WithStreamedUnaryMethod_RegisterDomain<WithStreamedUnaryMethod_RetrieveTransferParameters<WithStreamedUnaryMethod_TransferDomain<WithStreamedUnaryMethod_ListRegistrations<WithStreamedUnaryMethod_GetRegistration<WithStreamedUnaryMethod_UpdateRegistration<WithStreamedUnaryMethod_ConfigureManagementSettings<WithStreamedUnaryMethod_ConfigureDnsSettings<WithStreamedUnaryMethod_ConfigureContactSettings<WithStreamedUnaryMethod_ExportRegistration<WithStreamedUnaryMethod_DeleteRegistration<WithStreamedUnaryMethod_RetrieveAuthorizationCode<WithStreamedUnaryMethod_ResetAuthorizationCode<Service > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace domains
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fdomains_2fv1_2fdomains_2eproto__INCLUDED
