// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/kms/v1/ekm_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_KMS_V1_MOCKS_MOCK_EKM_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_KMS_V1_MOCKS_MOCK_EKM_CONNECTION_H

#include "google/cloud/kms/v1/ekm_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace kms_v1_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `EkmServiceConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `EkmServiceClient`. To do so,
 * construct an object of type `EkmServiceClient` with an instance of this
 * class. Then use the Google Test framework functions to program the behavior
 * of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockEkmServiceConnection : public kms_v1::EkmServiceConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD((StreamRange<google::cloud::kms::v1::EkmConnection>),
              ListEkmConnections,
              (google::cloud::kms::v1::ListEkmConnectionsRequest request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::kms::v1::EkmConnection>, GetEkmConnection,
              (google::cloud::kms::v1::GetEkmConnectionRequest const& request),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::kms::v1::EkmConnection>, CreateEkmConnection,
      (google::cloud::kms::v1::CreateEkmConnectionRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::kms::v1::EkmConnection>, UpdateEkmConnection,
      (google::cloud::kms::v1::UpdateEkmConnectionRequest const& request),
      (override));

  MOCK_METHOD(StatusOr<google::cloud::kms::v1::EkmConfig>, GetEkmConfig,
              (google::cloud::kms::v1::GetEkmConfigRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::kms::v1::EkmConfig>, UpdateEkmConfig,
              (google::cloud::kms::v1::UpdateEkmConfigRequest const& request),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::kms::v1::VerifyConnectivityResponse>,
      VerifyConnectivity,
      (google::cloud::kms::v1::VerifyConnectivityRequest const& request),
      (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace kms_v1_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_KMS_V1_MOCKS_MOCK_EKM_CONNECTION_H
