// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/language/v2/language_service.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2flanguage_2fv2_2flanguage_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2flanguage_2fv2_2flanguage_5fservice_2eproto__INCLUDED

#include "google/cloud/language/v2/language_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace language {
namespace v2 {

// Provides text analysis operations such as sentiment analysis and entity
// recognition.
class LanguageService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.language.v2.LanguageService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Analyzes the sentiment of the provided text.
    virtual ::grpc::Status AnalyzeSentiment(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeSentimentRequest& request, ::google::cloud::language::v2::AnalyzeSentimentResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::AnalyzeSentimentResponse>> AsyncAnalyzeSentiment(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeSentimentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::AnalyzeSentimentResponse>>(AsyncAnalyzeSentimentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::AnalyzeSentimentResponse>> PrepareAsyncAnalyzeSentiment(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeSentimentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::AnalyzeSentimentResponse>>(PrepareAsyncAnalyzeSentimentRaw(context, request, cq));
    }
    // Finds named entities (currently proper names and common nouns) in the text
    // along with entity types, probability, mentions for each entity, and
    // other properties.
    virtual ::grpc::Status AnalyzeEntities(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeEntitiesRequest& request, ::google::cloud::language::v2::AnalyzeEntitiesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::AnalyzeEntitiesResponse>> AsyncAnalyzeEntities(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::AnalyzeEntitiesResponse>>(AsyncAnalyzeEntitiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::AnalyzeEntitiesResponse>> PrepareAsyncAnalyzeEntities(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::AnalyzeEntitiesResponse>>(PrepareAsyncAnalyzeEntitiesRaw(context, request, cq));
    }
    // Classifies a document into categories.
    virtual ::grpc::Status ClassifyText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ClassifyTextRequest& request, ::google::cloud::language::v2::ClassifyTextResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::ClassifyTextResponse>> AsyncClassifyText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ClassifyTextRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::ClassifyTextResponse>>(AsyncClassifyTextRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::ClassifyTextResponse>> PrepareAsyncClassifyText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ClassifyTextRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::ClassifyTextResponse>>(PrepareAsyncClassifyTextRaw(context, request, cq));
    }
    // Moderates a document for harmful and sensitive categories.
    virtual ::grpc::Status ModerateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ModerateTextRequest& request, ::google::cloud::language::v2::ModerateTextResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::ModerateTextResponse>> AsyncModerateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ModerateTextRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::ModerateTextResponse>>(AsyncModerateTextRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::ModerateTextResponse>> PrepareAsyncModerateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ModerateTextRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::ModerateTextResponse>>(PrepareAsyncModerateTextRaw(context, request, cq));
    }
    // A convenience method that provides all features in one call.
    virtual ::grpc::Status AnnotateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnnotateTextRequest& request, ::google::cloud::language::v2::AnnotateTextResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::AnnotateTextResponse>> AsyncAnnotateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnnotateTextRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::AnnotateTextResponse>>(AsyncAnnotateTextRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::AnnotateTextResponse>> PrepareAsyncAnnotateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnnotateTextRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::AnnotateTextResponse>>(PrepareAsyncAnnotateTextRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Analyzes the sentiment of the provided text.
      virtual void AnalyzeSentiment(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeSentimentRequest* request, ::google::cloud::language::v2::AnalyzeSentimentResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AnalyzeSentiment(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeSentimentRequest* request, ::google::cloud::language::v2::AnalyzeSentimentResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Finds named entities (currently proper names and common nouns) in the text
      // along with entity types, probability, mentions for each entity, and
      // other properties.
      virtual void AnalyzeEntities(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeEntitiesRequest* request, ::google::cloud::language::v2::AnalyzeEntitiesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AnalyzeEntities(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeEntitiesRequest* request, ::google::cloud::language::v2::AnalyzeEntitiesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Classifies a document into categories.
      virtual void ClassifyText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ClassifyTextRequest* request, ::google::cloud::language::v2::ClassifyTextResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ClassifyText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ClassifyTextRequest* request, ::google::cloud::language::v2::ClassifyTextResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Moderates a document for harmful and sensitive categories.
      virtual void ModerateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ModerateTextRequest* request, ::google::cloud::language::v2::ModerateTextResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ModerateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ModerateTextRequest* request, ::google::cloud::language::v2::ModerateTextResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // A convenience method that provides all features in one call.
      virtual void AnnotateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnnotateTextRequest* request, ::google::cloud::language::v2::AnnotateTextResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AnnotateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnnotateTextRequest* request, ::google::cloud::language::v2::AnnotateTextResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::AnalyzeSentimentResponse>* AsyncAnalyzeSentimentRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeSentimentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::AnalyzeSentimentResponse>* PrepareAsyncAnalyzeSentimentRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeSentimentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::AnalyzeEntitiesResponse>* AsyncAnalyzeEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeEntitiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::AnalyzeEntitiesResponse>* PrepareAsyncAnalyzeEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeEntitiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::ClassifyTextResponse>* AsyncClassifyTextRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::ClassifyTextRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::ClassifyTextResponse>* PrepareAsyncClassifyTextRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::ClassifyTextRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::ModerateTextResponse>* AsyncModerateTextRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::ModerateTextRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::ModerateTextResponse>* PrepareAsyncModerateTextRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::ModerateTextRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::AnnotateTextResponse>* AsyncAnnotateTextRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnnotateTextRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::language::v2::AnnotateTextResponse>* PrepareAsyncAnnotateTextRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnnotateTextRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status AnalyzeSentiment(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeSentimentRequest& request, ::google::cloud::language::v2::AnalyzeSentimentResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::AnalyzeSentimentResponse>> AsyncAnalyzeSentiment(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeSentimentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::AnalyzeSentimentResponse>>(AsyncAnalyzeSentimentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::AnalyzeSentimentResponse>> PrepareAsyncAnalyzeSentiment(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeSentimentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::AnalyzeSentimentResponse>>(PrepareAsyncAnalyzeSentimentRaw(context, request, cq));
    }
    ::grpc::Status AnalyzeEntities(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeEntitiesRequest& request, ::google::cloud::language::v2::AnalyzeEntitiesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::AnalyzeEntitiesResponse>> AsyncAnalyzeEntities(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::AnalyzeEntitiesResponse>>(AsyncAnalyzeEntitiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::AnalyzeEntitiesResponse>> PrepareAsyncAnalyzeEntities(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::AnalyzeEntitiesResponse>>(PrepareAsyncAnalyzeEntitiesRaw(context, request, cq));
    }
    ::grpc::Status ClassifyText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ClassifyTextRequest& request, ::google::cloud::language::v2::ClassifyTextResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::ClassifyTextResponse>> AsyncClassifyText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ClassifyTextRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::ClassifyTextResponse>>(AsyncClassifyTextRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::ClassifyTextResponse>> PrepareAsyncClassifyText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ClassifyTextRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::ClassifyTextResponse>>(PrepareAsyncClassifyTextRaw(context, request, cq));
    }
    ::grpc::Status ModerateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ModerateTextRequest& request, ::google::cloud::language::v2::ModerateTextResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::ModerateTextResponse>> AsyncModerateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ModerateTextRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::ModerateTextResponse>>(AsyncModerateTextRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::ModerateTextResponse>> PrepareAsyncModerateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ModerateTextRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::ModerateTextResponse>>(PrepareAsyncModerateTextRaw(context, request, cq));
    }
    ::grpc::Status AnnotateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnnotateTextRequest& request, ::google::cloud::language::v2::AnnotateTextResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::AnnotateTextResponse>> AsyncAnnotateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnnotateTextRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::AnnotateTextResponse>>(AsyncAnnotateTextRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::AnnotateTextResponse>> PrepareAsyncAnnotateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnnotateTextRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::AnnotateTextResponse>>(PrepareAsyncAnnotateTextRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void AnalyzeSentiment(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeSentimentRequest* request, ::google::cloud::language::v2::AnalyzeSentimentResponse* response, std::function<void(::grpc::Status)>) override;
      void AnalyzeSentiment(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeSentimentRequest* request, ::google::cloud::language::v2::AnalyzeSentimentResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AnalyzeEntities(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeEntitiesRequest* request, ::google::cloud::language::v2::AnalyzeEntitiesResponse* response, std::function<void(::grpc::Status)>) override;
      void AnalyzeEntities(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeEntitiesRequest* request, ::google::cloud::language::v2::AnalyzeEntitiesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ClassifyText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ClassifyTextRequest* request, ::google::cloud::language::v2::ClassifyTextResponse* response, std::function<void(::grpc::Status)>) override;
      void ClassifyText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ClassifyTextRequest* request, ::google::cloud::language::v2::ClassifyTextResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ModerateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ModerateTextRequest* request, ::google::cloud::language::v2::ModerateTextResponse* response, std::function<void(::grpc::Status)>) override;
      void ModerateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::ModerateTextRequest* request, ::google::cloud::language::v2::ModerateTextResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AnnotateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnnotateTextRequest* request, ::google::cloud::language::v2::AnnotateTextResponse* response, std::function<void(::grpc::Status)>) override;
      void AnnotateText(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnnotateTextRequest* request, ::google::cloud::language::v2::AnnotateTextResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::AnalyzeSentimentResponse>* AsyncAnalyzeSentimentRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeSentimentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::AnalyzeSentimentResponse>* PrepareAsyncAnalyzeSentimentRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeSentimentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::AnalyzeEntitiesResponse>* AsyncAnalyzeEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeEntitiesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::AnalyzeEntitiesResponse>* PrepareAsyncAnalyzeEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnalyzeEntitiesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::ClassifyTextResponse>* AsyncClassifyTextRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::ClassifyTextRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::ClassifyTextResponse>* PrepareAsyncClassifyTextRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::ClassifyTextRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::ModerateTextResponse>* AsyncModerateTextRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::ModerateTextRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::ModerateTextResponse>* PrepareAsyncModerateTextRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::ModerateTextRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::AnnotateTextResponse>* AsyncAnnotateTextRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnnotateTextRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::language::v2::AnnotateTextResponse>* PrepareAsyncAnnotateTextRaw(::grpc::ClientContext* context, const ::google::cloud::language::v2::AnnotateTextRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_AnalyzeSentiment_;
    const ::grpc::internal::RpcMethod rpcmethod_AnalyzeEntities_;
    const ::grpc::internal::RpcMethod rpcmethod_ClassifyText_;
    const ::grpc::internal::RpcMethod rpcmethod_ModerateText_;
    const ::grpc::internal::RpcMethod rpcmethod_AnnotateText_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Analyzes the sentiment of the provided text.
    virtual ::grpc::Status AnalyzeSentiment(::grpc::ServerContext* context, const ::google::cloud::language::v2::AnalyzeSentimentRequest* request, ::google::cloud::language::v2::AnalyzeSentimentResponse* response);
    // Finds named entities (currently proper names and common nouns) in the text
    // along with entity types, probability, mentions for each entity, and
    // other properties.
    virtual ::grpc::Status AnalyzeEntities(::grpc::ServerContext* context, const ::google::cloud::language::v2::AnalyzeEntitiesRequest* request, ::google::cloud::language::v2::AnalyzeEntitiesResponse* response);
    // Classifies a document into categories.
    virtual ::grpc::Status ClassifyText(::grpc::ServerContext* context, const ::google::cloud::language::v2::ClassifyTextRequest* request, ::google::cloud::language::v2::ClassifyTextResponse* response);
    // Moderates a document for harmful and sensitive categories.
    virtual ::grpc::Status ModerateText(::grpc::ServerContext* context, const ::google::cloud::language::v2::ModerateTextRequest* request, ::google::cloud::language::v2::ModerateTextResponse* response);
    // A convenience method that provides all features in one call.
    virtual ::grpc::Status AnnotateText(::grpc::ServerContext* context, const ::google::cloud::language::v2::AnnotateTextRequest* request, ::google::cloud::language::v2::AnnotateTextResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_AnalyzeSentiment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AnalyzeSentiment() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_AnalyzeSentiment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeSentiment(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::AnalyzeSentimentRequest* /*request*/, ::google::cloud::language::v2::AnalyzeSentimentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAnalyzeSentiment(::grpc::ServerContext* context, ::google::cloud::language::v2::AnalyzeSentimentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::language::v2::AnalyzeSentimentResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AnalyzeEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AnalyzeEntities() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_AnalyzeEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::AnalyzeEntitiesRequest* /*request*/, ::google::cloud::language::v2::AnalyzeEntitiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAnalyzeEntities(::grpc::ServerContext* context, ::google::cloud::language::v2::AnalyzeEntitiesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::language::v2::AnalyzeEntitiesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ClassifyText : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ClassifyText() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ClassifyText() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ClassifyText(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::ClassifyTextRequest* /*request*/, ::google::cloud::language::v2::ClassifyTextResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestClassifyText(::grpc::ServerContext* context, ::google::cloud::language::v2::ClassifyTextRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::language::v2::ClassifyTextResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ModerateText : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ModerateText() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ModerateText() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModerateText(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::ModerateTextRequest* /*request*/, ::google::cloud::language::v2::ModerateTextResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestModerateText(::grpc::ServerContext* context, ::google::cloud::language::v2::ModerateTextRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::language::v2::ModerateTextResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AnnotateText : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AnnotateText() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_AnnotateText() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnnotateText(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::AnnotateTextRequest* /*request*/, ::google::cloud::language::v2::AnnotateTextResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAnnotateText(::grpc::ServerContext* context, ::google::cloud::language::v2::AnnotateTextRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::language::v2::AnnotateTextResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_AnalyzeSentiment<WithAsyncMethod_AnalyzeEntities<WithAsyncMethod_ClassifyText<WithAsyncMethod_ModerateText<WithAsyncMethod_AnnotateText<Service > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_AnalyzeSentiment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AnalyzeSentiment() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::language::v2::AnalyzeSentimentRequest, ::google::cloud::language::v2::AnalyzeSentimentResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::language::v2::AnalyzeSentimentRequest* request, ::google::cloud::language::v2::AnalyzeSentimentResponse* response) { return this->AnalyzeSentiment(context, request, response); }));}
    void SetMessageAllocatorFor_AnalyzeSentiment(
        ::grpc::MessageAllocator< ::google::cloud::language::v2::AnalyzeSentimentRequest, ::google::cloud::language::v2::AnalyzeSentimentResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::language::v2::AnalyzeSentimentRequest, ::google::cloud::language::v2::AnalyzeSentimentResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AnalyzeSentiment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeSentiment(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::AnalyzeSentimentRequest* /*request*/, ::google::cloud::language::v2::AnalyzeSentimentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AnalyzeSentiment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::language::v2::AnalyzeSentimentRequest* /*request*/, ::google::cloud::language::v2::AnalyzeSentimentResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AnalyzeEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AnalyzeEntities() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::language::v2::AnalyzeEntitiesRequest, ::google::cloud::language::v2::AnalyzeEntitiesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::language::v2::AnalyzeEntitiesRequest* request, ::google::cloud::language::v2::AnalyzeEntitiesResponse* response) { return this->AnalyzeEntities(context, request, response); }));}
    void SetMessageAllocatorFor_AnalyzeEntities(
        ::grpc::MessageAllocator< ::google::cloud::language::v2::AnalyzeEntitiesRequest, ::google::cloud::language::v2::AnalyzeEntitiesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::language::v2::AnalyzeEntitiesRequest, ::google::cloud::language::v2::AnalyzeEntitiesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AnalyzeEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::AnalyzeEntitiesRequest* /*request*/, ::google::cloud::language::v2::AnalyzeEntitiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AnalyzeEntities(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::language::v2::AnalyzeEntitiesRequest* /*request*/, ::google::cloud::language::v2::AnalyzeEntitiesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ClassifyText : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ClassifyText() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::language::v2::ClassifyTextRequest, ::google::cloud::language::v2::ClassifyTextResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::language::v2::ClassifyTextRequest* request, ::google::cloud::language::v2::ClassifyTextResponse* response) { return this->ClassifyText(context, request, response); }));}
    void SetMessageAllocatorFor_ClassifyText(
        ::grpc::MessageAllocator< ::google::cloud::language::v2::ClassifyTextRequest, ::google::cloud::language::v2::ClassifyTextResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::language::v2::ClassifyTextRequest, ::google::cloud::language::v2::ClassifyTextResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ClassifyText() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ClassifyText(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::ClassifyTextRequest* /*request*/, ::google::cloud::language::v2::ClassifyTextResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ClassifyText(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::language::v2::ClassifyTextRequest* /*request*/, ::google::cloud::language::v2::ClassifyTextResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ModerateText : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ModerateText() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::language::v2::ModerateTextRequest, ::google::cloud::language::v2::ModerateTextResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::language::v2::ModerateTextRequest* request, ::google::cloud::language::v2::ModerateTextResponse* response) { return this->ModerateText(context, request, response); }));}
    void SetMessageAllocatorFor_ModerateText(
        ::grpc::MessageAllocator< ::google::cloud::language::v2::ModerateTextRequest, ::google::cloud::language::v2::ModerateTextResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::language::v2::ModerateTextRequest, ::google::cloud::language::v2::ModerateTextResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ModerateText() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModerateText(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::ModerateTextRequest* /*request*/, ::google::cloud::language::v2::ModerateTextResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ModerateText(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::language::v2::ModerateTextRequest* /*request*/, ::google::cloud::language::v2::ModerateTextResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AnnotateText : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AnnotateText() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::language::v2::AnnotateTextRequest, ::google::cloud::language::v2::AnnotateTextResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::language::v2::AnnotateTextRequest* request, ::google::cloud::language::v2::AnnotateTextResponse* response) { return this->AnnotateText(context, request, response); }));}
    void SetMessageAllocatorFor_AnnotateText(
        ::grpc::MessageAllocator< ::google::cloud::language::v2::AnnotateTextRequest, ::google::cloud::language::v2::AnnotateTextResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::language::v2::AnnotateTextRequest, ::google::cloud::language::v2::AnnotateTextResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AnnotateText() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnnotateText(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::AnnotateTextRequest* /*request*/, ::google::cloud::language::v2::AnnotateTextResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AnnotateText(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::language::v2::AnnotateTextRequest* /*request*/, ::google::cloud::language::v2::AnnotateTextResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_AnalyzeSentiment<WithCallbackMethod_AnalyzeEntities<WithCallbackMethod_ClassifyText<WithCallbackMethod_ModerateText<WithCallbackMethod_AnnotateText<Service > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_AnalyzeSentiment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AnalyzeSentiment() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_AnalyzeSentiment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeSentiment(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::AnalyzeSentimentRequest* /*request*/, ::google::cloud::language::v2::AnalyzeSentimentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AnalyzeEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AnalyzeEntities() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_AnalyzeEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::AnalyzeEntitiesRequest* /*request*/, ::google::cloud::language::v2::AnalyzeEntitiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ClassifyText : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ClassifyText() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ClassifyText() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ClassifyText(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::ClassifyTextRequest* /*request*/, ::google::cloud::language::v2::ClassifyTextResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ModerateText : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ModerateText() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ModerateText() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModerateText(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::ModerateTextRequest* /*request*/, ::google::cloud::language::v2::ModerateTextResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AnnotateText : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AnnotateText() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_AnnotateText() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnnotateText(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::AnnotateTextRequest* /*request*/, ::google::cloud::language::v2::AnnotateTextResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_AnalyzeSentiment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AnalyzeSentiment() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_AnalyzeSentiment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeSentiment(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::AnalyzeSentimentRequest* /*request*/, ::google::cloud::language::v2::AnalyzeSentimentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAnalyzeSentiment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AnalyzeEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AnalyzeEntities() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_AnalyzeEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::AnalyzeEntitiesRequest* /*request*/, ::google::cloud::language::v2::AnalyzeEntitiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAnalyzeEntities(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ClassifyText : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ClassifyText() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ClassifyText() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ClassifyText(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::ClassifyTextRequest* /*request*/, ::google::cloud::language::v2::ClassifyTextResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestClassifyText(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ModerateText : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ModerateText() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ModerateText() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModerateText(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::ModerateTextRequest* /*request*/, ::google::cloud::language::v2::ModerateTextResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestModerateText(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AnnotateText : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AnnotateText() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_AnnotateText() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnnotateText(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::AnnotateTextRequest* /*request*/, ::google::cloud::language::v2::AnnotateTextResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAnnotateText(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AnalyzeSentiment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AnalyzeSentiment() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AnalyzeSentiment(context, request, response); }));
    }
    ~WithRawCallbackMethod_AnalyzeSentiment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeSentiment(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::AnalyzeSentimentRequest* /*request*/, ::google::cloud::language::v2::AnalyzeSentimentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AnalyzeSentiment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AnalyzeEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AnalyzeEntities() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AnalyzeEntities(context, request, response); }));
    }
    ~WithRawCallbackMethod_AnalyzeEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::AnalyzeEntitiesRequest* /*request*/, ::google::cloud::language::v2::AnalyzeEntitiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AnalyzeEntities(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ClassifyText : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ClassifyText() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ClassifyText(context, request, response); }));
    }
    ~WithRawCallbackMethod_ClassifyText() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ClassifyText(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::ClassifyTextRequest* /*request*/, ::google::cloud::language::v2::ClassifyTextResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ClassifyText(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ModerateText : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ModerateText() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ModerateText(context, request, response); }));
    }
    ~WithRawCallbackMethod_ModerateText() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModerateText(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::ModerateTextRequest* /*request*/, ::google::cloud::language::v2::ModerateTextResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ModerateText(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AnnotateText : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AnnotateText() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AnnotateText(context, request, response); }));
    }
    ~WithRawCallbackMethod_AnnotateText() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnnotateText(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::AnnotateTextRequest* /*request*/, ::google::cloud::language::v2::AnnotateTextResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AnnotateText(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AnalyzeSentiment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AnalyzeSentiment() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::language::v2::AnalyzeSentimentRequest, ::google::cloud::language::v2::AnalyzeSentimentResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::language::v2::AnalyzeSentimentRequest, ::google::cloud::language::v2::AnalyzeSentimentResponse>* streamer) {
                       return this->StreamedAnalyzeSentiment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AnalyzeSentiment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AnalyzeSentiment(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::AnalyzeSentimentRequest* /*request*/, ::google::cloud::language::v2::AnalyzeSentimentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAnalyzeSentiment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::language::v2::AnalyzeSentimentRequest,::google::cloud::language::v2::AnalyzeSentimentResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AnalyzeEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AnalyzeEntities() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::language::v2::AnalyzeEntitiesRequest, ::google::cloud::language::v2::AnalyzeEntitiesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::language::v2::AnalyzeEntitiesRequest, ::google::cloud::language::v2::AnalyzeEntitiesResponse>* streamer) {
                       return this->StreamedAnalyzeEntities(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AnalyzeEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AnalyzeEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::AnalyzeEntitiesRequest* /*request*/, ::google::cloud::language::v2::AnalyzeEntitiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAnalyzeEntities(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::language::v2::AnalyzeEntitiesRequest,::google::cloud::language::v2::AnalyzeEntitiesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ClassifyText : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ClassifyText() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::language::v2::ClassifyTextRequest, ::google::cloud::language::v2::ClassifyTextResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::language::v2::ClassifyTextRequest, ::google::cloud::language::v2::ClassifyTextResponse>* streamer) {
                       return this->StreamedClassifyText(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ClassifyText() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ClassifyText(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::ClassifyTextRequest* /*request*/, ::google::cloud::language::v2::ClassifyTextResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedClassifyText(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::language::v2::ClassifyTextRequest,::google::cloud::language::v2::ClassifyTextResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ModerateText : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ModerateText() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::language::v2::ModerateTextRequest, ::google::cloud::language::v2::ModerateTextResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::language::v2::ModerateTextRequest, ::google::cloud::language::v2::ModerateTextResponse>* streamer) {
                       return this->StreamedModerateText(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ModerateText() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ModerateText(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::ModerateTextRequest* /*request*/, ::google::cloud::language::v2::ModerateTextResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedModerateText(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::language::v2::ModerateTextRequest,::google::cloud::language::v2::ModerateTextResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AnnotateText : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AnnotateText() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::language::v2::AnnotateTextRequest, ::google::cloud::language::v2::AnnotateTextResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::language::v2::AnnotateTextRequest, ::google::cloud::language::v2::AnnotateTextResponse>* streamer) {
                       return this->StreamedAnnotateText(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AnnotateText() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AnnotateText(::grpc::ServerContext* /*context*/, const ::google::cloud::language::v2::AnnotateTextRequest* /*request*/, ::google::cloud::language::v2::AnnotateTextResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAnnotateText(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::language::v2::AnnotateTextRequest,::google::cloud::language::v2::AnnotateTextResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_AnalyzeSentiment<WithStreamedUnaryMethod_AnalyzeEntities<WithStreamedUnaryMethod_ClassifyText<WithStreamedUnaryMethod_ModerateText<WithStreamedUnaryMethod_AnnotateText<Service > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_AnalyzeSentiment<WithStreamedUnaryMethod_AnalyzeEntities<WithStreamedUnaryMethod_ClassifyText<WithStreamedUnaryMethod_ModerateText<WithStreamedUnaryMethod_AnnotateText<Service > > > > > StreamedService;
};

}  // namespace v2
}  // namespace language
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2flanguage_2fv2_2flanguage_5fservice_2eproto__INCLUDED
