// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/metastore/v1/metastore_federation.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_METASTORE_V1_DATAPROC_METASTORE_FEDERATION_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_METASTORE_V1_DATAPROC_METASTORE_FEDERATION_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/version.h"
#include <google/cloud/metastore/v1/metastore_federation.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace metastore_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class DataprocMetastoreFederationConnectionIdempotencyPolicy {
 public:
  virtual ~DataprocMetastoreFederationConnectionIdempotencyPolicy();

  /// Create a new copy of this object.
  virtual std::unique_ptr<
      DataprocMetastoreFederationConnectionIdempotencyPolicy>
  clone() const;

  virtual google::cloud::Idempotency ListFederations(
      google::cloud::metastore::v1::ListFederationsRequest request);

  virtual google::cloud::Idempotency GetFederation(
      google::cloud::metastore::v1::GetFederationRequest const& request);

  virtual google::cloud::Idempotency CreateFederation(
      google::cloud::metastore::v1::CreateFederationRequest const& request);

  virtual google::cloud::Idempotency UpdateFederation(
      google::cloud::metastore::v1::UpdateFederationRequest const& request);

  virtual google::cloud::Idempotency DeleteFederation(
      google::cloud::metastore::v1::DeleteFederationRequest const& request);
};

std::unique_ptr<DataprocMetastoreFederationConnectionIdempotencyPolicy>
MakeDefaultDataprocMetastoreFederationConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace metastore_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_METASTORE_V1_DATAPROC_METASTORE_FEDERATION_CONNECTION_IDEMPOTENCY_POLICY_H
