// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/optimization/v1/fleet_routing.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2foptimization_2fv1_2ffleet_5frouting_2eproto__INCLUDED
#define GRPC_google_2fcloud_2foptimization_2fv1_2ffleet_5frouting_2eproto__INCLUDED

#include "google/cloud/optimization/v1/fleet_routing.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace optimization {
namespace v1 {

// A service for optimizing vehicle tours.
//
// Validity of certain types of fields:
//
//   * `google.protobuf.Timestamp`
//     * Times are in Unix time: seconds since 1970-01-01T00:00:00+00:00.
//     * seconds must be in [0, 253402300799],
//       i.e. in [1970-01-01T00:00:00+00:00, 9999-12-31T23:59:59+00:00].
//     * nanos must be unset or set to 0.
//   * `google.protobuf.Duration`
//     * seconds must be in [0, 253402300799],
//       i.e. in [1970-01-01T00:00:00+00:00, 9999-12-31T23:59:59+00:00].
//     * nanos must be unset or set to 0.
//   * `google.type.LatLng`
//     * latitude must be in [-90.0, 90.0].
//     * longitude must be in [-180.0, 180.0].
//     * at least one of latitude and longitude must be non-zero.
class FleetRouting final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.optimization.v1.FleetRouting";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Sends an `OptimizeToursRequest` containing a `ShipmentModel` and returns an
    // `OptimizeToursResponse` containing `ShipmentRoute`s, which are a set of
    // routes to be performed by vehicles minimizing the overall cost.
    //
    // A `ShipmentModel` model consists mainly of `Shipment`s that need to be
    // carried out and `Vehicle`s that can be used to transport the `Shipment`s.
    // The `ShipmentRoute`s assign `Shipment`s to `Vehicle`s. More specifically,
    // they assign a series of `Visit`s to each vehicle, where a `Visit`
    // corresponds to a `VisitRequest`, which is a pickup or delivery for a
    // `Shipment`.
    //
    // The goal is to provide an assignment of `ShipmentRoute`s to `Vehicle`s that
    // minimizes the total cost where cost has many components defined in the
    // `ShipmentModel`.
    virtual ::grpc::Status OptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::OptimizeToursRequest& request, ::google::cloud::optimization::v1::OptimizeToursResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::optimization::v1::OptimizeToursResponse>> AsyncOptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::OptimizeToursRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::optimization::v1::OptimizeToursResponse>>(AsyncOptimizeToursRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::optimization::v1::OptimizeToursResponse>> PrepareAsyncOptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::OptimizeToursRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::optimization::v1::OptimizeToursResponse>>(PrepareAsyncOptimizeToursRaw(context, request, cq));
    }
    // Optimizes vehicle tours for one or more `OptimizeToursRequest`
    // messages as a batch.
    //
    // This method is a Long Running Operation (LRO). The inputs for optimization
    // (`OptimizeToursRequest` messages) and outputs (`OptimizeToursResponse`
    // messages) are read/written from/to Cloud Storage in user-specified
    // format. Like the `OptimizeTours` method, each `OptimizeToursRequest`
    // contains a `ShipmentModel` and returns an `OptimizeToursResponse`
    // containing `ShipmentRoute`s, which are a set of routes to be performed by
    // vehicles minimizing the overall cost.
    virtual ::grpc::Status BatchOptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchOptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchOptimizeToursRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchOptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchOptimizeToursRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Sends an `OptimizeToursRequest` containing a `ShipmentModel` and returns an
      // `OptimizeToursResponse` containing `ShipmentRoute`s, which are a set of
      // routes to be performed by vehicles minimizing the overall cost.
      //
      // A `ShipmentModel` model consists mainly of `Shipment`s that need to be
      // carried out and `Vehicle`s that can be used to transport the `Shipment`s.
      // The `ShipmentRoute`s assign `Shipment`s to `Vehicle`s. More specifically,
      // they assign a series of `Visit`s to each vehicle, where a `Visit`
      // corresponds to a `VisitRequest`, which is a pickup or delivery for a
      // `Shipment`.
      //
      // The goal is to provide an assignment of `ShipmentRoute`s to `Vehicle`s that
      // minimizes the total cost where cost has many components defined in the
      // `ShipmentModel`.
      virtual void OptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::OptimizeToursRequest* request, ::google::cloud::optimization::v1::OptimizeToursResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void OptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::OptimizeToursRequest* request, ::google::cloud::optimization::v1::OptimizeToursResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Optimizes vehicle tours for one or more `OptimizeToursRequest`
      // messages as a batch.
      //
      // This method is a Long Running Operation (LRO). The inputs for optimization
      // (`OptimizeToursRequest` messages) and outputs (`OptimizeToursResponse`
      // messages) are read/written from/to Cloud Storage in user-specified
      // format. Like the `OptimizeTours` method, each `OptimizeToursRequest`
      // contains a `ShipmentModel` and returns an `OptimizeToursResponse`
      // containing `ShipmentRoute`s, which are a set of routes to be performed by
      // vehicles minimizing the overall cost.
      virtual void BatchOptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchOptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::optimization::v1::OptimizeToursResponse>* AsyncOptimizeToursRaw(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::OptimizeToursRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::optimization::v1::OptimizeToursResponse>* PrepareAsyncOptimizeToursRaw(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::OptimizeToursRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchOptimizeToursRaw(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchOptimizeToursRaw(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status OptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::OptimizeToursRequest& request, ::google::cloud::optimization::v1::OptimizeToursResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::optimization::v1::OptimizeToursResponse>> AsyncOptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::OptimizeToursRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::optimization::v1::OptimizeToursResponse>>(AsyncOptimizeToursRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::optimization::v1::OptimizeToursResponse>> PrepareAsyncOptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::OptimizeToursRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::optimization::v1::OptimizeToursResponse>>(PrepareAsyncOptimizeToursRaw(context, request, cq));
    }
    ::grpc::Status BatchOptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchOptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchOptimizeToursRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchOptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchOptimizeToursRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void OptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::OptimizeToursRequest* request, ::google::cloud::optimization::v1::OptimizeToursResponse* response, std::function<void(::grpc::Status)>) override;
      void OptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::OptimizeToursRequest* request, ::google::cloud::optimization::v1::OptimizeToursResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchOptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchOptimizeTours(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::optimization::v1::OptimizeToursResponse>* AsyncOptimizeToursRaw(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::OptimizeToursRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::optimization::v1::OptimizeToursResponse>* PrepareAsyncOptimizeToursRaw(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::OptimizeToursRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchOptimizeToursRaw(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchOptimizeToursRaw(::grpc::ClientContext* context, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_OptimizeTours_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchOptimizeTours_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Sends an `OptimizeToursRequest` containing a `ShipmentModel` and returns an
    // `OptimizeToursResponse` containing `ShipmentRoute`s, which are a set of
    // routes to be performed by vehicles minimizing the overall cost.
    //
    // A `ShipmentModel` model consists mainly of `Shipment`s that need to be
    // carried out and `Vehicle`s that can be used to transport the `Shipment`s.
    // The `ShipmentRoute`s assign `Shipment`s to `Vehicle`s. More specifically,
    // they assign a series of `Visit`s to each vehicle, where a `Visit`
    // corresponds to a `VisitRequest`, which is a pickup or delivery for a
    // `Shipment`.
    //
    // The goal is to provide an assignment of `ShipmentRoute`s to `Vehicle`s that
    // minimizes the total cost where cost has many components defined in the
    // `ShipmentModel`.
    virtual ::grpc::Status OptimizeTours(::grpc::ServerContext* context, const ::google::cloud::optimization::v1::OptimizeToursRequest* request, ::google::cloud::optimization::v1::OptimizeToursResponse* response);
    // Optimizes vehicle tours for one or more `OptimizeToursRequest`
    // messages as a batch.
    //
    // This method is a Long Running Operation (LRO). The inputs for optimization
    // (`OptimizeToursRequest` messages) and outputs (`OptimizeToursResponse`
    // messages) are read/written from/to Cloud Storage in user-specified
    // format. Like the `OptimizeTours` method, each `OptimizeToursRequest`
    // contains a `ShipmentModel` and returns an `OptimizeToursResponse`
    // containing `ShipmentRoute`s, which are a set of routes to be performed by
    // vehicles minimizing the overall cost.
    virtual ::grpc::Status BatchOptimizeTours(::grpc::ServerContext* context, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_OptimizeTours : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_OptimizeTours() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_OptimizeTours() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status OptimizeTours(::grpc::ServerContext* /*context*/, const ::google::cloud::optimization::v1::OptimizeToursRequest* /*request*/, ::google::cloud::optimization::v1::OptimizeToursResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestOptimizeTours(::grpc::ServerContext* context, ::google::cloud::optimization::v1::OptimizeToursRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::optimization::v1::OptimizeToursResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchOptimizeTours : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchOptimizeTours() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_BatchOptimizeTours() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchOptimizeTours(::grpc::ServerContext* /*context*/, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchOptimizeTours(::grpc::ServerContext* context, ::google::cloud::optimization::v1::BatchOptimizeToursRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_OptimizeTours<WithAsyncMethod_BatchOptimizeTours<Service > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_OptimizeTours : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_OptimizeTours() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::optimization::v1::OptimizeToursRequest, ::google::cloud::optimization::v1::OptimizeToursResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::optimization::v1::OptimizeToursRequest* request, ::google::cloud::optimization::v1::OptimizeToursResponse* response) { return this->OptimizeTours(context, request, response); }));}
    void SetMessageAllocatorFor_OptimizeTours(
        ::grpc::MessageAllocator< ::google::cloud::optimization::v1::OptimizeToursRequest, ::google::cloud::optimization::v1::OptimizeToursResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::optimization::v1::OptimizeToursRequest, ::google::cloud::optimization::v1::OptimizeToursResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_OptimizeTours() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status OptimizeTours(::grpc::ServerContext* /*context*/, const ::google::cloud::optimization::v1::OptimizeToursRequest* /*request*/, ::google::cloud::optimization::v1::OptimizeToursResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* OptimizeTours(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::optimization::v1::OptimizeToursRequest* /*request*/, ::google::cloud::optimization::v1::OptimizeToursResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchOptimizeTours : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchOptimizeTours() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::optimization::v1::BatchOptimizeToursRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest* request, ::google::longrunning::Operation* response) { return this->BatchOptimizeTours(context, request, response); }));}
    void SetMessageAllocatorFor_BatchOptimizeTours(
        ::grpc::MessageAllocator< ::google::cloud::optimization::v1::BatchOptimizeToursRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::optimization::v1::BatchOptimizeToursRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchOptimizeTours() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchOptimizeTours(::grpc::ServerContext* /*context*/, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchOptimizeTours(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_OptimizeTours<WithCallbackMethod_BatchOptimizeTours<Service > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_OptimizeTours : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_OptimizeTours() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_OptimizeTours() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status OptimizeTours(::grpc::ServerContext* /*context*/, const ::google::cloud::optimization::v1::OptimizeToursRequest* /*request*/, ::google::cloud::optimization::v1::OptimizeToursResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchOptimizeTours : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchOptimizeTours() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_BatchOptimizeTours() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchOptimizeTours(::grpc::ServerContext* /*context*/, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_OptimizeTours : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_OptimizeTours() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_OptimizeTours() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status OptimizeTours(::grpc::ServerContext* /*context*/, const ::google::cloud::optimization::v1::OptimizeToursRequest* /*request*/, ::google::cloud::optimization::v1::OptimizeToursResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestOptimizeTours(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchOptimizeTours : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchOptimizeTours() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_BatchOptimizeTours() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchOptimizeTours(::grpc::ServerContext* /*context*/, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchOptimizeTours(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_OptimizeTours : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_OptimizeTours() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->OptimizeTours(context, request, response); }));
    }
    ~WithRawCallbackMethod_OptimizeTours() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status OptimizeTours(::grpc::ServerContext* /*context*/, const ::google::cloud::optimization::v1::OptimizeToursRequest* /*request*/, ::google::cloud::optimization::v1::OptimizeToursResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* OptimizeTours(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchOptimizeTours : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchOptimizeTours() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchOptimizeTours(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchOptimizeTours() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchOptimizeTours(::grpc::ServerContext* /*context*/, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchOptimizeTours(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_OptimizeTours : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_OptimizeTours() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::optimization::v1::OptimizeToursRequest, ::google::cloud::optimization::v1::OptimizeToursResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::optimization::v1::OptimizeToursRequest, ::google::cloud::optimization::v1::OptimizeToursResponse>* streamer) {
                       return this->StreamedOptimizeTours(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_OptimizeTours() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status OptimizeTours(::grpc::ServerContext* /*context*/, const ::google::cloud::optimization::v1::OptimizeToursRequest* /*request*/, ::google::cloud::optimization::v1::OptimizeToursResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedOptimizeTours(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::optimization::v1::OptimizeToursRequest,::google::cloud::optimization::v1::OptimizeToursResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchOptimizeTours : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchOptimizeTours() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::optimization::v1::BatchOptimizeToursRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::optimization::v1::BatchOptimizeToursRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedBatchOptimizeTours(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchOptimizeTours() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchOptimizeTours(::grpc::ServerContext* /*context*/, const ::google::cloud::optimization::v1::BatchOptimizeToursRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchOptimizeTours(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::optimization::v1::BatchOptimizeToursRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_OptimizeTours<WithStreamedUnaryMethod_BatchOptimizeTours<Service > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_OptimizeTours<WithStreamedUnaryMethod_BatchOptimizeTours<Service > > StreamedService;
};

}  // namespace v1
}  // namespace optimization
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2foptimization_2fv1_2ffleet_5frouting_2eproto__INCLUDED
