// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/resourcemanager/v3/tag_bindings.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fresourcemanager_2fv3_2ftag_5fbindings_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fresourcemanager_2fv3_2ftag_5fbindings_2eproto__INCLUDED

#include "google/cloud/resourcemanager/v3/tag_bindings.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace resourcemanager {
namespace v3 {

// Allow users to create and manage TagBindings between TagValues and
// different Google Cloud resources throughout the GCP resource hierarchy.
class TagBindings final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.resourcemanager.v3.TagBindings";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists the TagBindings for the given Google Cloud resource, as specified
    // with `parent`.
    //
    // NOTE: The `parent` field is expected to be a full resource name:
    // https://cloud.google.com/apis/design/resource_names#full_resource_name
    virtual ::grpc::Status ListTagBindings(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest& request, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListTagBindingsResponse>> AsyncListTagBindings(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListTagBindingsResponse>>(AsyncListTagBindingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListTagBindingsResponse>> PrepareAsyncListTagBindings(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListTagBindingsResponse>>(PrepareAsyncListTagBindingsRaw(context, request, cq));
    }
    // Creates a TagBinding between a TagValue and a Google Cloud resource.
    virtual ::grpc::Status CreateTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateTagBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateTagBindingRaw(context, request, cq));
    }
    // Deletes a TagBinding.
    virtual ::grpc::Status DeleteTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteTagBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteTagBindingRaw(context, request, cq));
    }
    // Return a list of effective tags for the given Google Cloud resource, as
    // specified in `parent`.
    virtual ::grpc::Status ListEffectiveTags(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest& request, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse>> AsyncListEffectiveTags(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse>>(AsyncListEffectiveTagsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse>> PrepareAsyncListEffectiveTags(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse>>(PrepareAsyncListEffectiveTagsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists the TagBindings for the given Google Cloud resource, as specified
      // with `parent`.
      //
      // NOTE: The `parent` field is expected to be a full resource name:
      // https://cloud.google.com/apis/design/resource_names#full_resource_name
      virtual void ListTagBindings(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest* request, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListTagBindings(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest* request, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a TagBinding between a TagValue and a Google Cloud resource.
      virtual void CreateTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a TagBinding.
      virtual void DeleteTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Return a list of effective tags for the given Google Cloud resource, as
      // specified in `parent`.
      virtual void ListEffectiveTags(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest* request, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListEffectiveTags(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest* request, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListTagBindingsResponse>* AsyncListTagBindingsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListTagBindingsResponse>* PrepareAsyncListTagBindingsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateTagBindingRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateTagBindingRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteTagBindingRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteTagBindingRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse>* AsyncListEffectiveTagsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse>* PrepareAsyncListEffectiveTagsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListTagBindings(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest& request, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListTagBindingsResponse>> AsyncListTagBindings(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListTagBindingsResponse>>(AsyncListTagBindingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListTagBindingsResponse>> PrepareAsyncListTagBindings(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListTagBindingsResponse>>(PrepareAsyncListTagBindingsRaw(context, request, cq));
    }
    ::grpc::Status CreateTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateTagBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateTagBindingRaw(context, request, cq));
    }
    ::grpc::Status DeleteTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteTagBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteTagBindingRaw(context, request, cq));
    }
    ::grpc::Status ListEffectiveTags(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest& request, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse>> AsyncListEffectiveTags(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse>>(AsyncListEffectiveTagsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse>> PrepareAsyncListEffectiveTags(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse>>(PrepareAsyncListEffectiveTagsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListTagBindings(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest* request, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListTagBindings(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest* request, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteTagBinding(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListEffectiveTags(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest* request, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListEffectiveTags(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest* request, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListTagBindingsResponse>* AsyncListTagBindingsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListTagBindingsResponse>* PrepareAsyncListTagBindingsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateTagBindingRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateTagBindingRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteTagBindingRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteTagBindingRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse>* AsyncListEffectiveTagsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse>* PrepareAsyncListEffectiveTagsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListTagBindings_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateTagBinding_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteTagBinding_;
    const ::grpc::internal::RpcMethod rpcmethod_ListEffectiveTags_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists the TagBindings for the given Google Cloud resource, as specified
    // with `parent`.
    //
    // NOTE: The `parent` field is expected to be a full resource name:
    // https://cloud.google.com/apis/design/resource_names#full_resource_name
    virtual ::grpc::Status ListTagBindings(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest* request, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse* response);
    // Creates a TagBinding between a TagValue and a Google Cloud resource.
    virtual ::grpc::Status CreateTagBinding(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest* request, ::google::longrunning::Operation* response);
    // Deletes a TagBinding.
    virtual ::grpc::Status DeleteTagBinding(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest* request, ::google::longrunning::Operation* response);
    // Return a list of effective tags for the given Google Cloud resource, as
    // specified in `parent`.
    virtual ::grpc::Status ListEffectiveTags(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest* request, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListTagBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListTagBindings() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListTagBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTagBindings(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTagBindings(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::ListTagBindingsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::resourcemanager::v3::ListTagBindingsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateTagBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateTagBinding() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_CreateTagBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTagBinding(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::CreateTagBindingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteTagBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteTagBinding() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_DeleteTagBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTagBinding(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListEffectiveTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListEffectiveTags() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ListEffectiveTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEffectiveTags(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEffectiveTags(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListTagBindings<WithAsyncMethod_CreateTagBinding<WithAsyncMethod_DeleteTagBinding<WithAsyncMethod_ListEffectiveTags<Service > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListTagBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListTagBindings() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::ListTagBindingsRequest, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest* request, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse* response) { return this->ListTagBindings(context, request, response); }));}
    void SetMessageAllocatorFor_ListTagBindings(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::ListTagBindingsRequest, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::ListTagBindingsRequest, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListTagBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTagBindings(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTagBindings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateTagBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateTagBinding() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::CreateTagBindingRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest* request, ::google::longrunning::Operation* response) { return this->CreateTagBinding(context, request, response); }));}
    void SetMessageAllocatorFor_CreateTagBinding(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::CreateTagBindingRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::CreateTagBindingRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateTagBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTagBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteTagBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteTagBinding() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest* request, ::google::longrunning::Operation* response) { return this->DeleteTagBinding(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteTagBinding(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteTagBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTagBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListEffectiveTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListEffectiveTags() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest* request, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse* response) { return this->ListEffectiveTags(context, request, response); }));}
    void SetMessageAllocatorFor_ListEffectiveTags(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListEffectiveTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEffectiveTags(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEffectiveTags(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListTagBindings<WithCallbackMethod_CreateTagBinding<WithCallbackMethod_DeleteTagBinding<WithCallbackMethod_ListEffectiveTags<Service > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListTagBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListTagBindings() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListTagBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTagBindings(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateTagBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateTagBinding() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_CreateTagBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteTagBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteTagBinding() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_DeleteTagBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListEffectiveTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListEffectiveTags() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ListEffectiveTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEffectiveTags(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListTagBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListTagBindings() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListTagBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTagBindings(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTagBindings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateTagBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateTagBinding() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_CreateTagBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTagBinding(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteTagBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteTagBinding() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_DeleteTagBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTagBinding(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListEffectiveTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListEffectiveTags() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ListEffectiveTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEffectiveTags(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEffectiveTags(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListTagBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListTagBindings() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListTagBindings(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListTagBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTagBindings(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTagBindings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateTagBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateTagBinding() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateTagBinding(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateTagBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTagBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteTagBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteTagBinding() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteTagBinding(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteTagBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTagBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListEffectiveTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListEffectiveTags() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListEffectiveTags(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListEffectiveTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEffectiveTags(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEffectiveTags(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListTagBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListTagBindings() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::ListTagBindingsRequest, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::ListTagBindingsRequest, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse>* streamer) {
                       return this->StreamedListTagBindings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListTagBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListTagBindings(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListTagBindingsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListTagBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListTagBindings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::ListTagBindingsRequest,::google::cloud::resourcemanager::v3::ListTagBindingsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateTagBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateTagBinding() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::CreateTagBindingRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::CreateTagBindingRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateTagBinding(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateTagBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateTagBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateTagBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateTagBinding(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::CreateTagBindingRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteTagBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteTagBinding() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteTagBinding(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteTagBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteTagBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteTagBinding(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::DeleteTagBindingRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListEffectiveTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListEffectiveTags() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse>* streamer) {
                       return this->StreamedListEffectiveTags(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListEffectiveTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListEffectiveTags(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListEffectiveTags(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::ListEffectiveTagsRequest,::google::cloud::resourcemanager::v3::ListEffectiveTagsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListTagBindings<WithStreamedUnaryMethod_CreateTagBinding<WithStreamedUnaryMethod_DeleteTagBinding<WithStreamedUnaryMethod_ListEffectiveTags<Service > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListTagBindings<WithStreamedUnaryMethod_CreateTagBinding<WithStreamedUnaryMethod_DeleteTagBinding<WithStreamedUnaryMethod_ListEffectiveTags<Service > > > > StreamedService;
};

}  // namespace v3
}  // namespace resourcemanager
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fresourcemanager_2fv3_2ftag_5fbindings_2eproto__INCLUDED
