// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/resourcemanager/v3/tag_holds.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fresourcemanager_2fv3_2ftag_5fholds_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fresourcemanager_2fv3_2ftag_5fholds_2eproto__INCLUDED

#include "google/cloud/resourcemanager/v3/tag_holds.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace resourcemanager {
namespace v3 {

// Allow users to create and manage TagHolds for TagValues. TagHolds represent
// the use of a Tag Value that is not captured by TagBindings but
// should still block TagValue deletion (such as a reference in a policy
// condition). This service provides isolated failure domains by cloud location
// so that TagHolds can be managed in the same location as their usage.
class TagHolds final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.resourcemanager.v3.TagHolds";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a TagHold. Returns ALREADY_EXISTS if a TagHold with the same
    // resource and origin exists under the same TagValue.
    virtual ::grpc::Status CreateTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateTagHoldRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateTagHoldRaw(context, request, cq));
    }
    // Deletes a TagHold.
    virtual ::grpc::Status DeleteTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteTagHoldRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteTagHoldRaw(context, request, cq));
    }
    // Lists TagHolds under a TagValue.
    virtual ::grpc::Status ListTagHolds(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest& request, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListTagHoldsResponse>> AsyncListTagHolds(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListTagHoldsResponse>>(AsyncListTagHoldsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListTagHoldsResponse>> PrepareAsyncListTagHolds(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListTagHoldsResponse>>(PrepareAsyncListTagHoldsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a TagHold. Returns ALREADY_EXISTS if a TagHold with the same
      // resource and origin exists under the same TagValue.
      virtual void CreateTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a TagHold.
      virtual void DeleteTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists TagHolds under a TagValue.
      virtual void ListTagHolds(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest* request, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListTagHolds(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest* request, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateTagHoldRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateTagHoldRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteTagHoldRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteTagHoldRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListTagHoldsResponse>* AsyncListTagHoldsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListTagHoldsResponse>* PrepareAsyncListTagHoldsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateTagHoldRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateTagHoldRaw(context, request, cq));
    }
    ::grpc::Status DeleteTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteTagHoldRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteTagHoldRaw(context, request, cq));
    }
    ::grpc::Status ListTagHolds(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest& request, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListTagHoldsResponse>> AsyncListTagHolds(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListTagHoldsResponse>>(AsyncListTagHoldsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListTagHoldsResponse>> PrepareAsyncListTagHolds(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListTagHoldsResponse>>(PrepareAsyncListTagHoldsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteTagHold(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListTagHolds(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest* request, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListTagHolds(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest* request, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateTagHoldRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateTagHoldRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteTagHoldRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteTagHoldRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListTagHoldsResponse>* AsyncListTagHoldsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListTagHoldsResponse>* PrepareAsyncListTagHoldsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateTagHold_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteTagHold_;
    const ::grpc::internal::RpcMethod rpcmethod_ListTagHolds_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a TagHold. Returns ALREADY_EXISTS if a TagHold with the same
    // resource and origin exists under the same TagValue.
    virtual ::grpc::Status CreateTagHold(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest* request, ::google::longrunning::Operation* response);
    // Deletes a TagHold.
    virtual ::grpc::Status DeleteTagHold(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest* request, ::google::longrunning::Operation* response);
    // Lists TagHolds under a TagValue.
    virtual ::grpc::Status ListTagHolds(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest* request, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateTagHold : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateTagHold() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateTagHold() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagHold(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTagHold(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::CreateTagHoldRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteTagHold : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteTagHold() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_DeleteTagHold() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagHold(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTagHold(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListTagHolds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListTagHolds() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ListTagHolds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTagHolds(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTagHolds(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::ListTagHoldsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::resourcemanager::v3::ListTagHoldsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateTagHold<WithAsyncMethod_DeleteTagHold<WithAsyncMethod_ListTagHolds<Service > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateTagHold : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateTagHold() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::CreateTagHoldRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest* request, ::google::longrunning::Operation* response) { return this->CreateTagHold(context, request, response); }));}
    void SetMessageAllocatorFor_CreateTagHold(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::CreateTagHoldRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::CreateTagHoldRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateTagHold() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagHold(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTagHold(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteTagHold : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteTagHold() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest* request, ::google::longrunning::Operation* response) { return this->DeleteTagHold(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteTagHold(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteTagHold() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagHold(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTagHold(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListTagHolds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListTagHolds() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::ListTagHoldsRequest, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest* request, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse* response) { return this->ListTagHolds(context, request, response); }));}
    void SetMessageAllocatorFor_ListTagHolds(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::ListTagHoldsRequest, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::ListTagHoldsRequest, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListTagHolds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTagHolds(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTagHolds(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateTagHold<WithCallbackMethod_DeleteTagHold<WithCallbackMethod_ListTagHolds<Service > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateTagHold : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateTagHold() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateTagHold() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagHold(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteTagHold : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteTagHold() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_DeleteTagHold() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagHold(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListTagHolds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListTagHolds() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ListTagHolds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTagHolds(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateTagHold : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateTagHold() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateTagHold() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagHold(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTagHold(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteTagHold : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteTagHold() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_DeleteTagHold() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagHold(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTagHold(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListTagHolds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListTagHolds() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ListTagHolds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTagHolds(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTagHolds(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateTagHold : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateTagHold() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateTagHold(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateTagHold() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagHold(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTagHold(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteTagHold : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteTagHold() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteTagHold(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteTagHold() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagHold(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTagHold(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListTagHolds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListTagHolds() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListTagHolds(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListTagHolds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTagHolds(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTagHolds(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateTagHold : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateTagHold() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::CreateTagHoldRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::CreateTagHoldRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateTagHold(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateTagHold() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateTagHold(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateTagHoldRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateTagHold(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::CreateTagHoldRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteTagHold : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteTagHold() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteTagHold(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteTagHold() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteTagHold(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteTagHold(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::DeleteTagHoldRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListTagHolds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListTagHolds() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::ListTagHoldsRequest, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::ListTagHoldsRequest, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse>* streamer) {
                       return this->StreamedListTagHolds(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListTagHolds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListTagHolds(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListTagHoldsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListTagHoldsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListTagHolds(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::ListTagHoldsRequest,::google::cloud::resourcemanager::v3::ListTagHoldsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateTagHold<WithStreamedUnaryMethod_DeleteTagHold<WithStreamedUnaryMethod_ListTagHolds<Service > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateTagHold<WithStreamedUnaryMethod_DeleteTagHold<WithStreamedUnaryMethod_ListTagHolds<Service > > > StreamedService;
};

}  // namespace v3
}  // namespace resourcemanager
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fresourcemanager_2fv3_2ftag_5fholds_2eproto__INCLUDED
