// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/asset/v1/asset_service.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fasset_2fv1_2fasset_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fasset_2fv1_2fasset_5fservice_2eproto__INCLUDED

#include "google/cloud/asset/v1/asset_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace asset {
namespace v1 {

// Asset service definition.
class AssetService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.asset.v1.AssetService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Exports assets with time and resource types to a given Cloud Storage
    // location/BigQuery table. For Cloud Storage location destinations, the
    // output format is newline-delimited JSON. Each line represents a
    // [google.cloud.asset.v1.Asset][google.cloud.asset.v1.Asset] in the JSON
    // format; for BigQuery table destinations, the output table stores the fields
    // in asset Protobuf as columns. This API implements the
    // [google.longrunning.Operation][google.longrunning.Operation] API, which
    // allows you to keep track of the export. We recommend intervals of at least
    // 2 seconds with exponential retry to poll the export operation result. For
    // regular-size resource parent, the export operation usually finishes within
    // 5 minutes.
    virtual ::grpc::Status ExportAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ExportAssetsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncExportAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ExportAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncExportAssetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncExportAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ExportAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncExportAssetsRaw(context, request, cq));
    }
    // Lists assets with time and resource types and returns paged results in
    // response.
    virtual ::grpc::Status ListAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListAssetsRequest& request, ::google::cloud::asset::v1::ListAssetsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::ListAssetsResponse>> AsyncListAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::ListAssetsResponse>>(AsyncListAssetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::ListAssetsResponse>> PrepareAsyncListAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::ListAssetsResponse>>(PrepareAsyncListAssetsRaw(context, request, cq));
    }
    // Batch gets the update history of assets that overlap a time window.
    // For IAM_POLICY content, this API outputs history when the asset and its
    // attached IAM POLICY both exist. This can create gaps in the output history.
    // Otherwise, this API outputs history with asset in both non-delete or
    // deleted status.
    // If a specified asset does not exist, this API returns an INVALID_ARGUMENT
    // error.
    virtual ::grpc::Status BatchGetAssetsHistory(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest& request, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse>> AsyncBatchGetAssetsHistory(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse>>(AsyncBatchGetAssetsHistoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse>> PrepareAsyncBatchGetAssetsHistory(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse>>(PrepareAsyncBatchGetAssetsHistoryRaw(context, request, cq));
    }
    // Creates a feed in a parent project/folder/organization to listen to its
    // asset updates.
    virtual ::grpc::Status CreateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateFeedRequest& request, ::google::cloud::asset::v1::Feed* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::Feed>> AsyncCreateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateFeedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::Feed>>(AsyncCreateFeedRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::Feed>> PrepareAsyncCreateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateFeedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::Feed>>(PrepareAsyncCreateFeedRaw(context, request, cq));
    }
    // Gets details about an asset feed.
    virtual ::grpc::Status GetFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetFeedRequest& request, ::google::cloud::asset::v1::Feed* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::Feed>> AsyncGetFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetFeedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::Feed>>(AsyncGetFeedRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::Feed>> PrepareAsyncGetFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetFeedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::Feed>>(PrepareAsyncGetFeedRaw(context, request, cq));
    }
    // Lists all asset feeds in a parent project/folder/organization.
    virtual ::grpc::Status ListFeeds(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListFeedsRequest& request, ::google::cloud::asset::v1::ListFeedsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::ListFeedsResponse>> AsyncListFeeds(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListFeedsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::ListFeedsResponse>>(AsyncListFeedsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::ListFeedsResponse>> PrepareAsyncListFeeds(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListFeedsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::ListFeedsResponse>>(PrepareAsyncListFeedsRaw(context, request, cq));
    }
    // Updates an asset feed configuration.
    virtual ::grpc::Status UpdateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateFeedRequest& request, ::google::cloud::asset::v1::Feed* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::Feed>> AsyncUpdateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateFeedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::Feed>>(AsyncUpdateFeedRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::Feed>> PrepareAsyncUpdateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateFeedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::Feed>>(PrepareAsyncUpdateFeedRaw(context, request, cq));
    }
    // Deletes an asset feed.
    virtual ::grpc::Status DeleteFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteFeedRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteFeedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteFeedRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteFeedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteFeedRaw(context, request, cq));
    }
    // Searches all Google Cloud resources within the specified scope, such as a
    // project, folder, or organization. The caller must be granted the
    // `cloudasset.assets.searchAllResources` permission on the desired scope,
    // otherwise the request will be rejected.
    virtual ::grpc::Status SearchAllResources(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllResourcesRequest& request, ::google::cloud::asset::v1::SearchAllResourcesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SearchAllResourcesResponse>> AsyncSearchAllResources(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllResourcesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SearchAllResourcesResponse>>(AsyncSearchAllResourcesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SearchAllResourcesResponse>> PrepareAsyncSearchAllResources(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllResourcesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SearchAllResourcesResponse>>(PrepareAsyncSearchAllResourcesRaw(context, request, cq));
    }
    // Searches all IAM policies within the specified scope, such as a project,
    // folder, or organization. The caller must be granted the
    // `cloudasset.assets.searchAllIamPolicies` permission on the desired scope,
    // otherwise the request will be rejected.
    virtual ::grpc::Status SearchAllIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest& request, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SearchAllIamPoliciesResponse>> AsyncSearchAllIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SearchAllIamPoliciesResponse>>(AsyncSearchAllIamPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SearchAllIamPoliciesResponse>> PrepareAsyncSearchAllIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SearchAllIamPoliciesResponse>>(PrepareAsyncSearchAllIamPoliciesRaw(context, request, cq));
    }
    // Analyzes IAM policies to answer which identities have what accesses on
    // which resources.
    virtual ::grpc::Status AnalyzeIamPolicy(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest& request, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeIamPolicyResponse>> AsyncAnalyzeIamPolicy(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeIamPolicyResponse>>(AsyncAnalyzeIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeIamPolicyResponse>> PrepareAsyncAnalyzeIamPolicy(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeIamPolicyResponse>>(PrepareAsyncAnalyzeIamPolicyRaw(context, request, cq));
    }
    // Analyzes IAM policies asynchronously to answer which identities have what
    // accesses on which resources, and writes the analysis results to a Google
    // Cloud Storage or a BigQuery destination. For Cloud Storage destination, the
    // output format is the JSON format that represents a
    // [AnalyzeIamPolicyResponse][google.cloud.asset.v1.AnalyzeIamPolicyResponse].
    // This method implements the
    // [google.longrunning.Operation][google.longrunning.Operation], which allows
    // you to track the operation status. We recommend intervals of at least 2
    // seconds with exponential backoff retry to poll the operation result. The
    // metadata contains the metadata for the long-running operation.
    virtual ::grpc::Status AnalyzeIamPolicyLongrunning(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncAnalyzeIamPolicyLongrunning(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncAnalyzeIamPolicyLongrunningRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncAnalyzeIamPolicyLongrunning(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncAnalyzeIamPolicyLongrunningRaw(context, request, cq));
    }
    // Analyze moving a resource to a specified destination without kicking off
    // the actual move. The analysis is best effort depending on the user's
    // permissions of viewing different hierarchical policies and configurations.
    // The policies and configuration are subject to change before the actual
    // resource migration takes place.
    virtual ::grpc::Status AnalyzeMove(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeMoveRequest& request, ::google::cloud::asset::v1::AnalyzeMoveResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeMoveResponse>> AsyncAnalyzeMove(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeMoveRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeMoveResponse>>(AsyncAnalyzeMoveRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeMoveResponse>> PrepareAsyncAnalyzeMove(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeMoveRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeMoveResponse>>(PrepareAsyncAnalyzeMoveRaw(context, request, cq));
    }
    // Issue a job that queries assets using a SQL statement compatible with
    // [BigQuery SQL](https://cloud.google.com/bigquery/docs/introduction-sql).
    //
    // If the query execution finishes within timeout and there's no pagination,
    // the full query results will be returned in the `QueryAssetsResponse`.
    //
    // Otherwise, full query results can be obtained by issuing extra requests
    // with the `job_reference` from the a previous `QueryAssets` call.
    //
    // Note, the query result has approximately 10 GB limitation enforced by
    // [BigQuery](https://cloud.google.com/bigquery/docs/best-practices-performance-output).
    // Queries return larger results will result in errors.
    virtual ::grpc::Status QueryAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::QueryAssetsRequest& request, ::google::cloud::asset::v1::QueryAssetsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::QueryAssetsResponse>> AsyncQueryAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::QueryAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::QueryAssetsResponse>>(AsyncQueryAssetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::QueryAssetsResponse>> PrepareAsyncQueryAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::QueryAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::QueryAssetsResponse>>(PrepareAsyncQueryAssetsRaw(context, request, cq));
    }
    // Creates a saved query in a parent project/folder/organization.
    virtual ::grpc::Status CreateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateSavedQueryRequest& request, ::google::cloud::asset::v1::SavedQuery* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SavedQuery>> AsyncCreateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateSavedQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SavedQuery>>(AsyncCreateSavedQueryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SavedQuery>> PrepareAsyncCreateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateSavedQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SavedQuery>>(PrepareAsyncCreateSavedQueryRaw(context, request, cq));
    }
    // Gets details about a saved query.
    virtual ::grpc::Status GetSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetSavedQueryRequest& request, ::google::cloud::asset::v1::SavedQuery* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SavedQuery>> AsyncGetSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetSavedQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SavedQuery>>(AsyncGetSavedQueryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SavedQuery>> PrepareAsyncGetSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetSavedQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SavedQuery>>(PrepareAsyncGetSavedQueryRaw(context, request, cq));
    }
    // Lists all saved queries in a parent project/folder/organization.
    virtual ::grpc::Status ListSavedQueries(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListSavedQueriesRequest& request, ::google::cloud::asset::v1::ListSavedQueriesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::ListSavedQueriesResponse>> AsyncListSavedQueries(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListSavedQueriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::ListSavedQueriesResponse>>(AsyncListSavedQueriesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::ListSavedQueriesResponse>> PrepareAsyncListSavedQueries(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListSavedQueriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::ListSavedQueriesResponse>>(PrepareAsyncListSavedQueriesRaw(context, request, cq));
    }
    // Updates a saved query.
    virtual ::grpc::Status UpdateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateSavedQueryRequest& request, ::google::cloud::asset::v1::SavedQuery* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SavedQuery>> AsyncUpdateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateSavedQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SavedQuery>>(AsyncUpdateSavedQueryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SavedQuery>> PrepareAsyncUpdateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateSavedQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SavedQuery>>(PrepareAsyncUpdateSavedQueryRaw(context, request, cq));
    }
    // Deletes a saved query.
    virtual ::grpc::Status DeleteSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteSavedQueryRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteSavedQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteSavedQueryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteSavedQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteSavedQueryRaw(context, request, cq));
    }
    // Gets effective IAM policies for a batch of resources.
    virtual ::grpc::Status BatchGetEffectiveIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest& request, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse>> AsyncBatchGetEffectiveIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse>>(AsyncBatchGetEffectiveIamPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse>> PrepareAsyncBatchGetEffectiveIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse>>(PrepareAsyncBatchGetEffectiveIamPoliciesRaw(context, request, cq));
    }
    // Analyzes organization policies under a scope.
    virtual ::grpc::Status AnalyzeOrgPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest& request, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse>> AsyncAnalyzeOrgPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse>>(AsyncAnalyzeOrgPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse>> PrepareAsyncAnalyzeOrgPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse>>(PrepareAsyncAnalyzeOrgPoliciesRaw(context, request, cq));
    }
    // Analyzes organization policies governed containers (projects, folders or
    // organization) under a scope.
    virtual ::grpc::Status AnalyzeOrgPolicyGovernedContainers(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest& request, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse>> AsyncAnalyzeOrgPolicyGovernedContainers(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse>>(AsyncAnalyzeOrgPolicyGovernedContainersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse>> PrepareAsyncAnalyzeOrgPolicyGovernedContainers(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse>>(PrepareAsyncAnalyzeOrgPolicyGovernedContainersRaw(context, request, cq));
    }
    // Analyzes organization policies governed assets (Google Cloud resources or
    // policies) under a scope. This RPC supports custom constraints and the
    // following 10 canned constraints:
    //
    // * storage.uniformBucketLevelAccess
    // * iam.disableServiceAccountKeyCreation
    // * iam.allowedPolicyMemberDomains
    // * compute.vmExternalIpAccess
    // * appengine.enforceServiceAccountActAsCheck
    // * gcp.resourceLocations
    // * compute.trustedImageProjects
    // * compute.skipDefaultNetworkCreation
    // * compute.requireOsLogin
    // * compute.disableNestedVirtualization
    //
    // This RPC only returns either resources of types supported by [searchable
    // asset
    // types](https://cloud.google.com/asset-inventory/docs/supported-asset-types#searchable_asset_types),
    // or IAM policies.
    virtual ::grpc::Status AnalyzeOrgPolicyGovernedAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest& request, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse>> AsyncAnalyzeOrgPolicyGovernedAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse>>(AsyncAnalyzeOrgPolicyGovernedAssetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse>> PrepareAsyncAnalyzeOrgPolicyGovernedAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse>>(PrepareAsyncAnalyzeOrgPolicyGovernedAssetsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Exports assets with time and resource types to a given Cloud Storage
      // location/BigQuery table. For Cloud Storage location destinations, the
      // output format is newline-delimited JSON. Each line represents a
      // [google.cloud.asset.v1.Asset][google.cloud.asset.v1.Asset] in the JSON
      // format; for BigQuery table destinations, the output table stores the fields
      // in asset Protobuf as columns. This API implements the
      // [google.longrunning.Operation][google.longrunning.Operation] API, which
      // allows you to keep track of the export. We recommend intervals of at least
      // 2 seconds with exponential retry to poll the export operation result. For
      // regular-size resource parent, the export operation usually finishes within
      // 5 minutes.
      virtual void ExportAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ExportAssetsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ExportAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ExportAssetsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists assets with time and resource types and returns paged results in
      // response.
      virtual void ListAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListAssetsRequest* request, ::google::cloud::asset::v1::ListAssetsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListAssetsRequest* request, ::google::cloud::asset::v1::ListAssetsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Batch gets the update history of assets that overlap a time window.
      // For IAM_POLICY content, this API outputs history when the asset and its
      // attached IAM POLICY both exist. This can create gaps in the output history.
      // Otherwise, this API outputs history with asset in both non-delete or
      // deleted status.
      // If a specified asset does not exist, this API returns an INVALID_ARGUMENT
      // error.
      virtual void BatchGetAssetsHistory(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest* request, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchGetAssetsHistory(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest* request, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a feed in a parent project/folder/organization to listen to its
      // asset updates.
      virtual void CreateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateFeedRequest* request, ::google::cloud::asset::v1::Feed* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateFeedRequest* request, ::google::cloud::asset::v1::Feed* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details about an asset feed.
      virtual void GetFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetFeedRequest* request, ::google::cloud::asset::v1::Feed* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetFeedRequest* request, ::google::cloud::asset::v1::Feed* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all asset feeds in a parent project/folder/organization.
      virtual void ListFeeds(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListFeedsRequest* request, ::google::cloud::asset::v1::ListFeedsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListFeeds(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListFeedsRequest* request, ::google::cloud::asset::v1::ListFeedsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an asset feed configuration.
      virtual void UpdateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateFeedRequest* request, ::google::cloud::asset::v1::Feed* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateFeedRequest* request, ::google::cloud::asset::v1::Feed* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an asset feed.
      virtual void DeleteFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteFeedRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteFeedRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Searches all Google Cloud resources within the specified scope, such as a
      // project, folder, or organization. The caller must be granted the
      // `cloudasset.assets.searchAllResources` permission on the desired scope,
      // otherwise the request will be rejected.
      virtual void SearchAllResources(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllResourcesRequest* request, ::google::cloud::asset::v1::SearchAllResourcesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchAllResources(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllResourcesRequest* request, ::google::cloud::asset::v1::SearchAllResourcesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Searches all IAM policies within the specified scope, such as a project,
      // folder, or organization. The caller must be granted the
      // `cloudasset.assets.searchAllIamPolicies` permission on the desired scope,
      // otherwise the request will be rejected.
      virtual void SearchAllIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest* request, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchAllIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest* request, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Analyzes IAM policies to answer which identities have what accesses on
      // which resources.
      virtual void AnalyzeIamPolicy(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest* request, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AnalyzeIamPolicy(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest* request, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Analyzes IAM policies asynchronously to answer which identities have what
      // accesses on which resources, and writes the analysis results to a Google
      // Cloud Storage or a BigQuery destination. For Cloud Storage destination, the
      // output format is the JSON format that represents a
      // [AnalyzeIamPolicyResponse][google.cloud.asset.v1.AnalyzeIamPolicyResponse].
      // This method implements the
      // [google.longrunning.Operation][google.longrunning.Operation], which allows
      // you to track the operation status. We recommend intervals of at least 2
      // seconds with exponential backoff retry to poll the operation result. The
      // metadata contains the metadata for the long-running operation.
      virtual void AnalyzeIamPolicyLongrunning(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AnalyzeIamPolicyLongrunning(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Analyze moving a resource to a specified destination without kicking off
      // the actual move. The analysis is best effort depending on the user's
      // permissions of viewing different hierarchical policies and configurations.
      // The policies and configuration are subject to change before the actual
      // resource migration takes place.
      virtual void AnalyzeMove(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeMoveRequest* request, ::google::cloud::asset::v1::AnalyzeMoveResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AnalyzeMove(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeMoveRequest* request, ::google::cloud::asset::v1::AnalyzeMoveResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Issue a job that queries assets using a SQL statement compatible with
      // [BigQuery SQL](https://cloud.google.com/bigquery/docs/introduction-sql).
      //
      // If the query execution finishes within timeout and there's no pagination,
      // the full query results will be returned in the `QueryAssetsResponse`.
      //
      // Otherwise, full query results can be obtained by issuing extra requests
      // with the `job_reference` from the a previous `QueryAssets` call.
      //
      // Note, the query result has approximately 10 GB limitation enforced by
      // [BigQuery](https://cloud.google.com/bigquery/docs/best-practices-performance-output).
      // Queries return larger results will result in errors.
      virtual void QueryAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::QueryAssetsRequest* request, ::google::cloud::asset::v1::QueryAssetsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void QueryAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::QueryAssetsRequest* request, ::google::cloud::asset::v1::QueryAssetsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a saved query in a parent project/folder/organization.
      virtual void CreateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateSavedQueryRequest* request, ::google::cloud::asset::v1::SavedQuery* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateSavedQueryRequest* request, ::google::cloud::asset::v1::SavedQuery* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details about a saved query.
      virtual void GetSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetSavedQueryRequest* request, ::google::cloud::asset::v1::SavedQuery* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetSavedQueryRequest* request, ::google::cloud::asset::v1::SavedQuery* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all saved queries in a parent project/folder/organization.
      virtual void ListSavedQueries(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListSavedQueriesRequest* request, ::google::cloud::asset::v1::ListSavedQueriesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSavedQueries(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListSavedQueriesRequest* request, ::google::cloud::asset::v1::ListSavedQueriesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a saved query.
      virtual void UpdateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateSavedQueryRequest* request, ::google::cloud::asset::v1::SavedQuery* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateSavedQueryRequest* request, ::google::cloud::asset::v1::SavedQuery* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a saved query.
      virtual void DeleteSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteSavedQueryRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteSavedQueryRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets effective IAM policies for a batch of resources.
      virtual void BatchGetEffectiveIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest* request, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchGetEffectiveIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest* request, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Analyzes organization policies under a scope.
      virtual void AnalyzeOrgPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest* request, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AnalyzeOrgPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest* request, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Analyzes organization policies governed containers (projects, folders or
      // organization) under a scope.
      virtual void AnalyzeOrgPolicyGovernedContainers(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest* request, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AnalyzeOrgPolicyGovernedContainers(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest* request, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Analyzes organization policies governed assets (Google Cloud resources or
      // policies) under a scope. This RPC supports custom constraints and the
      // following 10 canned constraints:
      //
      // * storage.uniformBucketLevelAccess
      // * iam.disableServiceAccountKeyCreation
      // * iam.allowedPolicyMemberDomains
      // * compute.vmExternalIpAccess
      // * appengine.enforceServiceAccountActAsCheck
      // * gcp.resourceLocations
      // * compute.trustedImageProjects
      // * compute.skipDefaultNetworkCreation
      // * compute.requireOsLogin
      // * compute.disableNestedVirtualization
      //
      // This RPC only returns either resources of types supported by [searchable
      // asset
      // types](https://cloud.google.com/asset-inventory/docs/supported-asset-types#searchable_asset_types),
      // or IAM policies.
      virtual void AnalyzeOrgPolicyGovernedAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest* request, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AnalyzeOrgPolicyGovernedAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest* request, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncExportAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ExportAssetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncExportAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ExportAssetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::ListAssetsResponse>* AsyncListAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::ListAssetsResponse>* PrepareAsyncListAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse>* AsyncBatchGetAssetsHistoryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse>* PrepareAsyncBatchGetAssetsHistoryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::Feed>* AsyncCreateFeedRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateFeedRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::Feed>* PrepareAsyncCreateFeedRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateFeedRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::Feed>* AsyncGetFeedRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetFeedRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::Feed>* PrepareAsyncGetFeedRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetFeedRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::ListFeedsResponse>* AsyncListFeedsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListFeedsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::ListFeedsResponse>* PrepareAsyncListFeedsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListFeedsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::Feed>* AsyncUpdateFeedRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateFeedRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::Feed>* PrepareAsyncUpdateFeedRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateFeedRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteFeedRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteFeedRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteFeedRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteFeedRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SearchAllResourcesResponse>* AsyncSearchAllResourcesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllResourcesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SearchAllResourcesResponse>* PrepareAsyncSearchAllResourcesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllResourcesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SearchAllIamPoliciesResponse>* AsyncSearchAllIamPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SearchAllIamPoliciesResponse>* PrepareAsyncSearchAllIamPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeIamPolicyResponse>* AsyncAnalyzeIamPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeIamPolicyResponse>* PrepareAsyncAnalyzeIamPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncAnalyzeIamPolicyLongrunningRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncAnalyzeIamPolicyLongrunningRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeMoveResponse>* AsyncAnalyzeMoveRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeMoveRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeMoveResponse>* PrepareAsyncAnalyzeMoveRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeMoveRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::QueryAssetsResponse>* AsyncQueryAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::QueryAssetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::QueryAssetsResponse>* PrepareAsyncQueryAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::QueryAssetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SavedQuery>* AsyncCreateSavedQueryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateSavedQueryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SavedQuery>* PrepareAsyncCreateSavedQueryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateSavedQueryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SavedQuery>* AsyncGetSavedQueryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetSavedQueryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SavedQuery>* PrepareAsyncGetSavedQueryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetSavedQueryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::ListSavedQueriesResponse>* AsyncListSavedQueriesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListSavedQueriesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::ListSavedQueriesResponse>* PrepareAsyncListSavedQueriesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListSavedQueriesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SavedQuery>* AsyncUpdateSavedQueryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateSavedQueryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::SavedQuery>* PrepareAsyncUpdateSavedQueryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateSavedQueryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteSavedQueryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteSavedQueryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteSavedQueryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteSavedQueryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse>* AsyncBatchGetEffectiveIamPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse>* PrepareAsyncBatchGetEffectiveIamPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse>* AsyncAnalyzeOrgPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse>* PrepareAsyncAnalyzeOrgPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse>* AsyncAnalyzeOrgPolicyGovernedContainersRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse>* PrepareAsyncAnalyzeOrgPolicyGovernedContainersRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse>* AsyncAnalyzeOrgPolicyGovernedAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse>* PrepareAsyncAnalyzeOrgPolicyGovernedAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ExportAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ExportAssetsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncExportAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ExportAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncExportAssetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncExportAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ExportAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncExportAssetsRaw(context, request, cq));
    }
    ::grpc::Status ListAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListAssetsRequest& request, ::google::cloud::asset::v1::ListAssetsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::ListAssetsResponse>> AsyncListAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::ListAssetsResponse>>(AsyncListAssetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::ListAssetsResponse>> PrepareAsyncListAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::ListAssetsResponse>>(PrepareAsyncListAssetsRaw(context, request, cq));
    }
    ::grpc::Status BatchGetAssetsHistory(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest& request, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse>> AsyncBatchGetAssetsHistory(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse>>(AsyncBatchGetAssetsHistoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse>> PrepareAsyncBatchGetAssetsHistory(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse>>(PrepareAsyncBatchGetAssetsHistoryRaw(context, request, cq));
    }
    ::grpc::Status CreateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateFeedRequest& request, ::google::cloud::asset::v1::Feed* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::Feed>> AsyncCreateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateFeedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::Feed>>(AsyncCreateFeedRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::Feed>> PrepareAsyncCreateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateFeedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::Feed>>(PrepareAsyncCreateFeedRaw(context, request, cq));
    }
    ::grpc::Status GetFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetFeedRequest& request, ::google::cloud::asset::v1::Feed* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::Feed>> AsyncGetFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetFeedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::Feed>>(AsyncGetFeedRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::Feed>> PrepareAsyncGetFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetFeedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::Feed>>(PrepareAsyncGetFeedRaw(context, request, cq));
    }
    ::grpc::Status ListFeeds(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListFeedsRequest& request, ::google::cloud::asset::v1::ListFeedsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::ListFeedsResponse>> AsyncListFeeds(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListFeedsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::ListFeedsResponse>>(AsyncListFeedsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::ListFeedsResponse>> PrepareAsyncListFeeds(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListFeedsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::ListFeedsResponse>>(PrepareAsyncListFeedsRaw(context, request, cq));
    }
    ::grpc::Status UpdateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateFeedRequest& request, ::google::cloud::asset::v1::Feed* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::Feed>> AsyncUpdateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateFeedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::Feed>>(AsyncUpdateFeedRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::Feed>> PrepareAsyncUpdateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateFeedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::Feed>>(PrepareAsyncUpdateFeedRaw(context, request, cq));
    }
    ::grpc::Status DeleteFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteFeedRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteFeedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteFeedRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteFeedRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteFeedRaw(context, request, cq));
    }
    ::grpc::Status SearchAllResources(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllResourcesRequest& request, ::google::cloud::asset::v1::SearchAllResourcesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SearchAllResourcesResponse>> AsyncSearchAllResources(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllResourcesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SearchAllResourcesResponse>>(AsyncSearchAllResourcesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SearchAllResourcesResponse>> PrepareAsyncSearchAllResources(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllResourcesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SearchAllResourcesResponse>>(PrepareAsyncSearchAllResourcesRaw(context, request, cq));
    }
    ::grpc::Status SearchAllIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest& request, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SearchAllIamPoliciesResponse>> AsyncSearchAllIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SearchAllIamPoliciesResponse>>(AsyncSearchAllIamPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SearchAllIamPoliciesResponse>> PrepareAsyncSearchAllIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SearchAllIamPoliciesResponse>>(PrepareAsyncSearchAllIamPoliciesRaw(context, request, cq));
    }
    ::grpc::Status AnalyzeIamPolicy(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest& request, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeIamPolicyResponse>> AsyncAnalyzeIamPolicy(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeIamPolicyResponse>>(AsyncAnalyzeIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeIamPolicyResponse>> PrepareAsyncAnalyzeIamPolicy(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeIamPolicyResponse>>(PrepareAsyncAnalyzeIamPolicyRaw(context, request, cq));
    }
    ::grpc::Status AnalyzeIamPolicyLongrunning(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncAnalyzeIamPolicyLongrunning(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncAnalyzeIamPolicyLongrunningRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncAnalyzeIamPolicyLongrunning(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncAnalyzeIamPolicyLongrunningRaw(context, request, cq));
    }
    ::grpc::Status AnalyzeMove(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeMoveRequest& request, ::google::cloud::asset::v1::AnalyzeMoveResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeMoveResponse>> AsyncAnalyzeMove(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeMoveRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeMoveResponse>>(AsyncAnalyzeMoveRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeMoveResponse>> PrepareAsyncAnalyzeMove(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeMoveRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeMoveResponse>>(PrepareAsyncAnalyzeMoveRaw(context, request, cq));
    }
    ::grpc::Status QueryAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::QueryAssetsRequest& request, ::google::cloud::asset::v1::QueryAssetsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::QueryAssetsResponse>> AsyncQueryAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::QueryAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::QueryAssetsResponse>>(AsyncQueryAssetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::QueryAssetsResponse>> PrepareAsyncQueryAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::QueryAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::QueryAssetsResponse>>(PrepareAsyncQueryAssetsRaw(context, request, cq));
    }
    ::grpc::Status CreateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateSavedQueryRequest& request, ::google::cloud::asset::v1::SavedQuery* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SavedQuery>> AsyncCreateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateSavedQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SavedQuery>>(AsyncCreateSavedQueryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SavedQuery>> PrepareAsyncCreateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateSavedQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SavedQuery>>(PrepareAsyncCreateSavedQueryRaw(context, request, cq));
    }
    ::grpc::Status GetSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetSavedQueryRequest& request, ::google::cloud::asset::v1::SavedQuery* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SavedQuery>> AsyncGetSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetSavedQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SavedQuery>>(AsyncGetSavedQueryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SavedQuery>> PrepareAsyncGetSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetSavedQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SavedQuery>>(PrepareAsyncGetSavedQueryRaw(context, request, cq));
    }
    ::grpc::Status ListSavedQueries(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListSavedQueriesRequest& request, ::google::cloud::asset::v1::ListSavedQueriesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::ListSavedQueriesResponse>> AsyncListSavedQueries(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListSavedQueriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::ListSavedQueriesResponse>>(AsyncListSavedQueriesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::ListSavedQueriesResponse>> PrepareAsyncListSavedQueries(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListSavedQueriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::ListSavedQueriesResponse>>(PrepareAsyncListSavedQueriesRaw(context, request, cq));
    }
    ::grpc::Status UpdateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateSavedQueryRequest& request, ::google::cloud::asset::v1::SavedQuery* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SavedQuery>> AsyncUpdateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateSavedQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SavedQuery>>(AsyncUpdateSavedQueryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SavedQuery>> PrepareAsyncUpdateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateSavedQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SavedQuery>>(PrepareAsyncUpdateSavedQueryRaw(context, request, cq));
    }
    ::grpc::Status DeleteSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteSavedQueryRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteSavedQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteSavedQueryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteSavedQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteSavedQueryRaw(context, request, cq));
    }
    ::grpc::Status BatchGetEffectiveIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest& request, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse>> AsyncBatchGetEffectiveIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse>>(AsyncBatchGetEffectiveIamPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse>> PrepareAsyncBatchGetEffectiveIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse>>(PrepareAsyncBatchGetEffectiveIamPoliciesRaw(context, request, cq));
    }
    ::grpc::Status AnalyzeOrgPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest& request, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse>> AsyncAnalyzeOrgPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse>>(AsyncAnalyzeOrgPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse>> PrepareAsyncAnalyzeOrgPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse>>(PrepareAsyncAnalyzeOrgPoliciesRaw(context, request, cq));
    }
    ::grpc::Status AnalyzeOrgPolicyGovernedContainers(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest& request, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse>> AsyncAnalyzeOrgPolicyGovernedContainers(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse>>(AsyncAnalyzeOrgPolicyGovernedContainersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse>> PrepareAsyncAnalyzeOrgPolicyGovernedContainers(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse>>(PrepareAsyncAnalyzeOrgPolicyGovernedContainersRaw(context, request, cq));
    }
    ::grpc::Status AnalyzeOrgPolicyGovernedAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest& request, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse>> AsyncAnalyzeOrgPolicyGovernedAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse>>(AsyncAnalyzeOrgPolicyGovernedAssetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse>> PrepareAsyncAnalyzeOrgPolicyGovernedAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse>>(PrepareAsyncAnalyzeOrgPolicyGovernedAssetsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ExportAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ExportAssetsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ExportAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ExportAssetsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListAssetsRequest* request, ::google::cloud::asset::v1::ListAssetsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListAssetsRequest* request, ::google::cloud::asset::v1::ListAssetsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchGetAssetsHistory(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest* request, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse* response, std::function<void(::grpc::Status)>) override;
      void BatchGetAssetsHistory(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest* request, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateFeedRequest* request, ::google::cloud::asset::v1::Feed* response, std::function<void(::grpc::Status)>) override;
      void CreateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateFeedRequest* request, ::google::cloud::asset::v1::Feed* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetFeedRequest* request, ::google::cloud::asset::v1::Feed* response, std::function<void(::grpc::Status)>) override;
      void GetFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetFeedRequest* request, ::google::cloud::asset::v1::Feed* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListFeeds(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListFeedsRequest* request, ::google::cloud::asset::v1::ListFeedsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListFeeds(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListFeedsRequest* request, ::google::cloud::asset::v1::ListFeedsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateFeedRequest* request, ::google::cloud::asset::v1::Feed* response, std::function<void(::grpc::Status)>) override;
      void UpdateFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateFeedRequest* request, ::google::cloud::asset::v1::Feed* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteFeedRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteFeed(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteFeedRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SearchAllResources(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllResourcesRequest* request, ::google::cloud::asset::v1::SearchAllResourcesResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchAllResources(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllResourcesRequest* request, ::google::cloud::asset::v1::SearchAllResourcesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SearchAllIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest* request, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchAllIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest* request, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AnalyzeIamPolicy(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest* request, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse* response, std::function<void(::grpc::Status)>) override;
      void AnalyzeIamPolicy(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest* request, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AnalyzeIamPolicyLongrunning(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void AnalyzeIamPolicyLongrunning(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AnalyzeMove(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeMoveRequest* request, ::google::cloud::asset::v1::AnalyzeMoveResponse* response, std::function<void(::grpc::Status)>) override;
      void AnalyzeMove(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeMoveRequest* request, ::google::cloud::asset::v1::AnalyzeMoveResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void QueryAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::QueryAssetsRequest* request, ::google::cloud::asset::v1::QueryAssetsResponse* response, std::function<void(::grpc::Status)>) override;
      void QueryAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::QueryAssetsRequest* request, ::google::cloud::asset::v1::QueryAssetsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateSavedQueryRequest* request, ::google::cloud::asset::v1::SavedQuery* response, std::function<void(::grpc::Status)>) override;
      void CreateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateSavedQueryRequest* request, ::google::cloud::asset::v1::SavedQuery* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetSavedQueryRequest* request, ::google::cloud::asset::v1::SavedQuery* response, std::function<void(::grpc::Status)>) override;
      void GetSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetSavedQueryRequest* request, ::google::cloud::asset::v1::SavedQuery* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListSavedQueries(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListSavedQueriesRequest* request, ::google::cloud::asset::v1::ListSavedQueriesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSavedQueries(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListSavedQueriesRequest* request, ::google::cloud::asset::v1::ListSavedQueriesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateSavedQueryRequest* request, ::google::cloud::asset::v1::SavedQuery* response, std::function<void(::grpc::Status)>) override;
      void UpdateSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateSavedQueryRequest* request, ::google::cloud::asset::v1::SavedQuery* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteSavedQueryRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteSavedQuery(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteSavedQueryRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchGetEffectiveIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest* request, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse* response, std::function<void(::grpc::Status)>) override;
      void BatchGetEffectiveIamPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest* request, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AnalyzeOrgPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest* request, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse* response, std::function<void(::grpc::Status)>) override;
      void AnalyzeOrgPolicies(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest* request, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AnalyzeOrgPolicyGovernedContainers(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest* request, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse* response, std::function<void(::grpc::Status)>) override;
      void AnalyzeOrgPolicyGovernedContainers(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest* request, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AnalyzeOrgPolicyGovernedAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest* request, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse* response, std::function<void(::grpc::Status)>) override;
      void AnalyzeOrgPolicyGovernedAssets(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest* request, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncExportAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ExportAssetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncExportAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ExportAssetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::ListAssetsResponse>* AsyncListAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::ListAssetsResponse>* PrepareAsyncListAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse>* AsyncBatchGetAssetsHistoryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse>* PrepareAsyncBatchGetAssetsHistoryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::Feed>* AsyncCreateFeedRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateFeedRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::Feed>* PrepareAsyncCreateFeedRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateFeedRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::Feed>* AsyncGetFeedRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetFeedRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::Feed>* PrepareAsyncGetFeedRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetFeedRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::ListFeedsResponse>* AsyncListFeedsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListFeedsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::ListFeedsResponse>* PrepareAsyncListFeedsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListFeedsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::Feed>* AsyncUpdateFeedRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateFeedRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::Feed>* PrepareAsyncUpdateFeedRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateFeedRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteFeedRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteFeedRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteFeedRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteFeedRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SearchAllResourcesResponse>* AsyncSearchAllResourcesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllResourcesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SearchAllResourcesResponse>* PrepareAsyncSearchAllResourcesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllResourcesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SearchAllIamPoliciesResponse>* AsyncSearchAllIamPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SearchAllIamPoliciesResponse>* PrepareAsyncSearchAllIamPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeIamPolicyResponse>* AsyncAnalyzeIamPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeIamPolicyResponse>* PrepareAsyncAnalyzeIamPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncAnalyzeIamPolicyLongrunningRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncAnalyzeIamPolicyLongrunningRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeMoveResponse>* AsyncAnalyzeMoveRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeMoveRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeMoveResponse>* PrepareAsyncAnalyzeMoveRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeMoveRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::QueryAssetsResponse>* AsyncQueryAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::QueryAssetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::QueryAssetsResponse>* PrepareAsyncQueryAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::QueryAssetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SavedQuery>* AsyncCreateSavedQueryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateSavedQueryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SavedQuery>* PrepareAsyncCreateSavedQueryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::CreateSavedQueryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SavedQuery>* AsyncGetSavedQueryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetSavedQueryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SavedQuery>* PrepareAsyncGetSavedQueryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::GetSavedQueryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::ListSavedQueriesResponse>* AsyncListSavedQueriesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListSavedQueriesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::ListSavedQueriesResponse>* PrepareAsyncListSavedQueriesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::ListSavedQueriesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SavedQuery>* AsyncUpdateSavedQueryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateSavedQueryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::SavedQuery>* PrepareAsyncUpdateSavedQueryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::UpdateSavedQueryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteSavedQueryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteSavedQueryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteSavedQueryRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::DeleteSavedQueryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse>* AsyncBatchGetEffectiveIamPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse>* PrepareAsyncBatchGetEffectiveIamPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse>* AsyncAnalyzeOrgPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse>* PrepareAsyncAnalyzeOrgPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse>* AsyncAnalyzeOrgPolicyGovernedContainersRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse>* PrepareAsyncAnalyzeOrgPolicyGovernedContainersRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse>* AsyncAnalyzeOrgPolicyGovernedAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse>* PrepareAsyncAnalyzeOrgPolicyGovernedAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ExportAssets_;
    const ::grpc::internal::RpcMethod rpcmethod_ListAssets_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchGetAssetsHistory_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateFeed_;
    const ::grpc::internal::RpcMethod rpcmethod_GetFeed_;
    const ::grpc::internal::RpcMethod rpcmethod_ListFeeds_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateFeed_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteFeed_;
    const ::grpc::internal::RpcMethod rpcmethod_SearchAllResources_;
    const ::grpc::internal::RpcMethod rpcmethod_SearchAllIamPolicies_;
    const ::grpc::internal::RpcMethod rpcmethod_AnalyzeIamPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_AnalyzeIamPolicyLongrunning_;
    const ::grpc::internal::RpcMethod rpcmethod_AnalyzeMove_;
    const ::grpc::internal::RpcMethod rpcmethod_QueryAssets_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateSavedQuery_;
    const ::grpc::internal::RpcMethod rpcmethod_GetSavedQuery_;
    const ::grpc::internal::RpcMethod rpcmethod_ListSavedQueries_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateSavedQuery_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteSavedQuery_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchGetEffectiveIamPolicies_;
    const ::grpc::internal::RpcMethod rpcmethod_AnalyzeOrgPolicies_;
    const ::grpc::internal::RpcMethod rpcmethod_AnalyzeOrgPolicyGovernedContainers_;
    const ::grpc::internal::RpcMethod rpcmethod_AnalyzeOrgPolicyGovernedAssets_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Exports assets with time and resource types to a given Cloud Storage
    // location/BigQuery table. For Cloud Storage location destinations, the
    // output format is newline-delimited JSON. Each line represents a
    // [google.cloud.asset.v1.Asset][google.cloud.asset.v1.Asset] in the JSON
    // format; for BigQuery table destinations, the output table stores the fields
    // in asset Protobuf as columns. This API implements the
    // [google.longrunning.Operation][google.longrunning.Operation] API, which
    // allows you to keep track of the export. We recommend intervals of at least
    // 2 seconds with exponential retry to poll the export operation result. For
    // regular-size resource parent, the export operation usually finishes within
    // 5 minutes.
    virtual ::grpc::Status ExportAssets(::grpc::ServerContext* context, const ::google::cloud::asset::v1::ExportAssetsRequest* request, ::google::longrunning::Operation* response);
    // Lists assets with time and resource types and returns paged results in
    // response.
    virtual ::grpc::Status ListAssets(::grpc::ServerContext* context, const ::google::cloud::asset::v1::ListAssetsRequest* request, ::google::cloud::asset::v1::ListAssetsResponse* response);
    // Batch gets the update history of assets that overlap a time window.
    // For IAM_POLICY content, this API outputs history when the asset and its
    // attached IAM POLICY both exist. This can create gaps in the output history.
    // Otherwise, this API outputs history with asset in both non-delete or
    // deleted status.
    // If a specified asset does not exist, this API returns an INVALID_ARGUMENT
    // error.
    virtual ::grpc::Status BatchGetAssetsHistory(::grpc::ServerContext* context, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest* request, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse* response);
    // Creates a feed in a parent project/folder/organization to listen to its
    // asset updates.
    virtual ::grpc::Status CreateFeed(::grpc::ServerContext* context, const ::google::cloud::asset::v1::CreateFeedRequest* request, ::google::cloud::asset::v1::Feed* response);
    // Gets details about an asset feed.
    virtual ::grpc::Status GetFeed(::grpc::ServerContext* context, const ::google::cloud::asset::v1::GetFeedRequest* request, ::google::cloud::asset::v1::Feed* response);
    // Lists all asset feeds in a parent project/folder/organization.
    virtual ::grpc::Status ListFeeds(::grpc::ServerContext* context, const ::google::cloud::asset::v1::ListFeedsRequest* request, ::google::cloud::asset::v1::ListFeedsResponse* response);
    // Updates an asset feed configuration.
    virtual ::grpc::Status UpdateFeed(::grpc::ServerContext* context, const ::google::cloud::asset::v1::UpdateFeedRequest* request, ::google::cloud::asset::v1::Feed* response);
    // Deletes an asset feed.
    virtual ::grpc::Status DeleteFeed(::grpc::ServerContext* context, const ::google::cloud::asset::v1::DeleteFeedRequest* request, ::google::protobuf::Empty* response);
    // Searches all Google Cloud resources within the specified scope, such as a
    // project, folder, or organization. The caller must be granted the
    // `cloudasset.assets.searchAllResources` permission on the desired scope,
    // otherwise the request will be rejected.
    virtual ::grpc::Status SearchAllResources(::grpc::ServerContext* context, const ::google::cloud::asset::v1::SearchAllResourcesRequest* request, ::google::cloud::asset::v1::SearchAllResourcesResponse* response);
    // Searches all IAM policies within the specified scope, such as a project,
    // folder, or organization. The caller must be granted the
    // `cloudasset.assets.searchAllIamPolicies` permission on the desired scope,
    // otherwise the request will be rejected.
    virtual ::grpc::Status SearchAllIamPolicies(::grpc::ServerContext* context, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest* request, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse* response);
    // Analyzes IAM policies to answer which identities have what accesses on
    // which resources.
    virtual ::grpc::Status AnalyzeIamPolicy(::grpc::ServerContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest* request, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse* response);
    // Analyzes IAM policies asynchronously to answer which identities have what
    // accesses on which resources, and writes the analysis results to a Google
    // Cloud Storage or a BigQuery destination. For Cloud Storage destination, the
    // output format is the JSON format that represents a
    // [AnalyzeIamPolicyResponse][google.cloud.asset.v1.AnalyzeIamPolicyResponse].
    // This method implements the
    // [google.longrunning.Operation][google.longrunning.Operation], which allows
    // you to track the operation status. We recommend intervals of at least 2
    // seconds with exponential backoff retry to poll the operation result. The
    // metadata contains the metadata for the long-running operation.
    virtual ::grpc::Status AnalyzeIamPolicyLongrunning(::grpc::ServerContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest* request, ::google::longrunning::Operation* response);
    // Analyze moving a resource to a specified destination without kicking off
    // the actual move. The analysis is best effort depending on the user's
    // permissions of viewing different hierarchical policies and configurations.
    // The policies and configuration are subject to change before the actual
    // resource migration takes place.
    virtual ::grpc::Status AnalyzeMove(::grpc::ServerContext* context, const ::google::cloud::asset::v1::AnalyzeMoveRequest* request, ::google::cloud::asset::v1::AnalyzeMoveResponse* response);
    // Issue a job that queries assets using a SQL statement compatible with
    // [BigQuery SQL](https://cloud.google.com/bigquery/docs/introduction-sql).
    //
    // If the query execution finishes within timeout and there's no pagination,
    // the full query results will be returned in the `QueryAssetsResponse`.
    //
    // Otherwise, full query results can be obtained by issuing extra requests
    // with the `job_reference` from the a previous `QueryAssets` call.
    //
    // Note, the query result has approximately 10 GB limitation enforced by
    // [BigQuery](https://cloud.google.com/bigquery/docs/best-practices-performance-output).
    // Queries return larger results will result in errors.
    virtual ::grpc::Status QueryAssets(::grpc::ServerContext* context, const ::google::cloud::asset::v1::QueryAssetsRequest* request, ::google::cloud::asset::v1::QueryAssetsResponse* response);
    // Creates a saved query in a parent project/folder/organization.
    virtual ::grpc::Status CreateSavedQuery(::grpc::ServerContext* context, const ::google::cloud::asset::v1::CreateSavedQueryRequest* request, ::google::cloud::asset::v1::SavedQuery* response);
    // Gets details about a saved query.
    virtual ::grpc::Status GetSavedQuery(::grpc::ServerContext* context, const ::google::cloud::asset::v1::GetSavedQueryRequest* request, ::google::cloud::asset::v1::SavedQuery* response);
    // Lists all saved queries in a parent project/folder/organization.
    virtual ::grpc::Status ListSavedQueries(::grpc::ServerContext* context, const ::google::cloud::asset::v1::ListSavedQueriesRequest* request, ::google::cloud::asset::v1::ListSavedQueriesResponse* response);
    // Updates a saved query.
    virtual ::grpc::Status UpdateSavedQuery(::grpc::ServerContext* context, const ::google::cloud::asset::v1::UpdateSavedQueryRequest* request, ::google::cloud::asset::v1::SavedQuery* response);
    // Deletes a saved query.
    virtual ::grpc::Status DeleteSavedQuery(::grpc::ServerContext* context, const ::google::cloud::asset::v1::DeleteSavedQueryRequest* request, ::google::protobuf::Empty* response);
    // Gets effective IAM policies for a batch of resources.
    virtual ::grpc::Status BatchGetEffectiveIamPolicies(::grpc::ServerContext* context, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest* request, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse* response);
    // Analyzes organization policies under a scope.
    virtual ::grpc::Status AnalyzeOrgPolicies(::grpc::ServerContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest* request, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse* response);
    // Analyzes organization policies governed containers (projects, folders or
    // organization) under a scope.
    virtual ::grpc::Status AnalyzeOrgPolicyGovernedContainers(::grpc::ServerContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest* request, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse* response);
    // Analyzes organization policies governed assets (Google Cloud resources or
    // policies) under a scope. This RPC supports custom constraints and the
    // following 10 canned constraints:
    //
    // * storage.uniformBucketLevelAccess
    // * iam.disableServiceAccountKeyCreation
    // * iam.allowedPolicyMemberDomains
    // * compute.vmExternalIpAccess
    // * appengine.enforceServiceAccountActAsCheck
    // * gcp.resourceLocations
    // * compute.trustedImageProjects
    // * compute.skipDefaultNetworkCreation
    // * compute.requireOsLogin
    // * compute.disableNestedVirtualization
    //
    // This RPC only returns either resources of types supported by [searchable
    // asset
    // types](https://cloud.google.com/asset-inventory/docs/supported-asset-types#searchable_asset_types),
    // or IAM policies.
    virtual ::grpc::Status AnalyzeOrgPolicyGovernedAssets(::grpc::ServerContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest* request, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ExportAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ExportAssets() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ExportAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ExportAssetsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportAssets(::grpc::ServerContext* context, ::google::cloud::asset::v1::ExportAssetsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAssets() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ListAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ListAssetsRequest* /*request*/, ::google::cloud::asset::v1::ListAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAssets(::grpc::ServerContext* context, ::google::cloud::asset::v1::ListAssetsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::asset::v1::ListAssetsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchGetAssetsHistory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchGetAssetsHistory() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_BatchGetAssetsHistory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchGetAssetsHistory(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest* /*request*/, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchGetAssetsHistory(::grpc::ServerContext* context, ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateFeed() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_CreateFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::CreateFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateFeed(::grpc::ServerContext* context, ::google::cloud::asset::v1::CreateFeedRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::asset::v1::Feed>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetFeed() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_GetFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::GetFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetFeed(::grpc::ServerContext* context, ::google::cloud::asset::v1::GetFeedRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::asset::v1::Feed>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListFeeds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListFeeds() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListFeeds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFeeds(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ListFeedsRequest* /*request*/, ::google::cloud::asset::v1::ListFeedsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListFeeds(::grpc::ServerContext* context, ::google::cloud::asset::v1::ListFeedsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::asset::v1::ListFeedsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateFeed() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_UpdateFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::UpdateFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateFeed(::grpc::ServerContext* context, ::google::cloud::asset::v1::UpdateFeedRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::asset::v1::Feed>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteFeed() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_DeleteFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::DeleteFeedRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteFeed(::grpc::ServerContext* context, ::google::cloud::asset::v1::DeleteFeedRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchAllResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchAllResources() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_SearchAllResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchAllResources(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::SearchAllResourcesRequest* /*request*/, ::google::cloud::asset::v1::SearchAllResourcesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchAllResources(::grpc::ServerContext* context, ::google::cloud::asset::v1::SearchAllResourcesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::asset::v1::SearchAllResourcesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchAllIamPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchAllIamPolicies() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_SearchAllIamPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchAllIamPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest* /*request*/, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchAllIamPolicies(::grpc::ServerContext* context, ::google::cloud::asset::v1::SearchAllIamPoliciesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::asset::v1::SearchAllIamPoliciesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AnalyzeIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AnalyzeIamPolicy() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_AnalyzeIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeIamPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAnalyzeIamPolicy(::grpc::ServerContext* context, ::google::cloud::asset::v1::AnalyzeIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::asset::v1::AnalyzeIamPolicyResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AnalyzeIamPolicyLongrunning : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AnalyzeIamPolicyLongrunning() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_AnalyzeIamPolicyLongrunning() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeIamPolicyLongrunning(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAnalyzeIamPolicyLongrunning(::grpc::ServerContext* context, ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AnalyzeMove : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AnalyzeMove() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_AnalyzeMove() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeMove(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeMoveRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeMoveResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAnalyzeMove(::grpc::ServerContext* context, ::google::cloud::asset::v1::AnalyzeMoveRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::asset::v1::AnalyzeMoveResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_QueryAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_QueryAssets() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_QueryAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status QueryAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::QueryAssetsRequest* /*request*/, ::google::cloud::asset::v1::QueryAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestQueryAssets(::grpc::ServerContext* context, ::google::cloud::asset::v1::QueryAssetsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::asset::v1::QueryAssetsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateSavedQuery() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_CreateSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::CreateSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSavedQuery(::grpc::ServerContext* context, ::google::cloud::asset::v1::CreateSavedQueryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::asset::v1::SavedQuery>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetSavedQuery() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_GetSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::GetSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSavedQuery(::grpc::ServerContext* context, ::google::cloud::asset::v1::GetSavedQueryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::asset::v1::SavedQuery>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSavedQueries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSavedQueries() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_ListSavedQueries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSavedQueries(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ListSavedQueriesRequest* /*request*/, ::google::cloud::asset::v1::ListSavedQueriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSavedQueries(::grpc::ServerContext* context, ::google::cloud::asset::v1::ListSavedQueriesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::asset::v1::ListSavedQueriesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateSavedQuery() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_UpdateSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::UpdateSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSavedQuery(::grpc::ServerContext* context, ::google::cloud::asset::v1::UpdateSavedQueryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::asset::v1::SavedQuery>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteSavedQuery() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_DeleteSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::DeleteSavedQueryRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSavedQuery(::grpc::ServerContext* context, ::google::cloud::asset::v1::DeleteSavedQueryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchGetEffectiveIamPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchGetEffectiveIamPolicies() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_BatchGetEffectiveIamPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchGetEffectiveIamPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest* /*request*/, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchGetEffectiveIamPolicies(::grpc::ServerContext* context, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AnalyzeOrgPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AnalyzeOrgPolicies() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_AnalyzeOrgPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeOrgPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAnalyzeOrgPolicies(::grpc::ServerContext* context, ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AnalyzeOrgPolicyGovernedContainers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AnalyzeOrgPolicyGovernedContainers() {
      ::grpc::Service::MarkMethodAsync(21);
    }
    ~WithAsyncMethod_AnalyzeOrgPolicyGovernedContainers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeOrgPolicyGovernedContainers(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAnalyzeOrgPolicyGovernedContainers(::grpc::ServerContext* context, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AnalyzeOrgPolicyGovernedAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AnalyzeOrgPolicyGovernedAssets() {
      ::grpc::Service::MarkMethodAsync(22);
    }
    ~WithAsyncMethod_AnalyzeOrgPolicyGovernedAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeOrgPolicyGovernedAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAnalyzeOrgPolicyGovernedAssets(::grpc::ServerContext* context, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ExportAssets<WithAsyncMethod_ListAssets<WithAsyncMethod_BatchGetAssetsHistory<WithAsyncMethod_CreateFeed<WithAsyncMethod_GetFeed<WithAsyncMethod_ListFeeds<WithAsyncMethod_UpdateFeed<WithAsyncMethod_DeleteFeed<WithAsyncMethod_SearchAllResources<WithAsyncMethod_SearchAllIamPolicies<WithAsyncMethod_AnalyzeIamPolicy<WithAsyncMethod_AnalyzeIamPolicyLongrunning<WithAsyncMethod_AnalyzeMove<WithAsyncMethod_QueryAssets<WithAsyncMethod_CreateSavedQuery<WithAsyncMethod_GetSavedQuery<WithAsyncMethod_ListSavedQueries<WithAsyncMethod_UpdateSavedQuery<WithAsyncMethod_DeleteSavedQuery<WithAsyncMethod_BatchGetEffectiveIamPolicies<WithAsyncMethod_AnalyzeOrgPolicies<WithAsyncMethod_AnalyzeOrgPolicyGovernedContainers<WithAsyncMethod_AnalyzeOrgPolicyGovernedAssets<Service > > > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ExportAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ExportAssets() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::ExportAssetsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::ExportAssetsRequest* request, ::google::longrunning::Operation* response) { return this->ExportAssets(context, request, response); }));}
    void SetMessageAllocatorFor_ExportAssets(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::ExportAssetsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::ExportAssetsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ExportAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ExportAssetsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ExportAssets(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::ExportAssetsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAssets() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::ListAssetsRequest, ::google::cloud::asset::v1::ListAssetsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::ListAssetsRequest* request, ::google::cloud::asset::v1::ListAssetsResponse* response) { return this->ListAssets(context, request, response); }));}
    void SetMessageAllocatorFor_ListAssets(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::ListAssetsRequest, ::google::cloud::asset::v1::ListAssetsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::ListAssetsRequest, ::google::cloud::asset::v1::ListAssetsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ListAssetsRequest* /*request*/, ::google::cloud::asset::v1::ListAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAssets(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::ListAssetsRequest* /*request*/, ::google::cloud::asset::v1::ListAssetsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchGetAssetsHistory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchGetAssetsHistory() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest* request, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse* response) { return this->BatchGetAssetsHistory(context, request, response); }));}
    void SetMessageAllocatorFor_BatchGetAssetsHistory(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchGetAssetsHistory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchGetAssetsHistory(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest* /*request*/, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchGetAssetsHistory(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest* /*request*/, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateFeed() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::CreateFeedRequest, ::google::cloud::asset::v1::Feed>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::CreateFeedRequest* request, ::google::cloud::asset::v1::Feed* response) { return this->CreateFeed(context, request, response); }));}
    void SetMessageAllocatorFor_CreateFeed(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::CreateFeedRequest, ::google::cloud::asset::v1::Feed>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::CreateFeedRequest, ::google::cloud::asset::v1::Feed>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::CreateFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateFeed(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::CreateFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetFeed() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::GetFeedRequest, ::google::cloud::asset::v1::Feed>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::GetFeedRequest* request, ::google::cloud::asset::v1::Feed* response) { return this->GetFeed(context, request, response); }));}
    void SetMessageAllocatorFor_GetFeed(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::GetFeedRequest, ::google::cloud::asset::v1::Feed>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::GetFeedRequest, ::google::cloud::asset::v1::Feed>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::GetFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetFeed(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::GetFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListFeeds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListFeeds() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::ListFeedsRequest, ::google::cloud::asset::v1::ListFeedsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::ListFeedsRequest* request, ::google::cloud::asset::v1::ListFeedsResponse* response) { return this->ListFeeds(context, request, response); }));}
    void SetMessageAllocatorFor_ListFeeds(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::ListFeedsRequest, ::google::cloud::asset::v1::ListFeedsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::ListFeedsRequest, ::google::cloud::asset::v1::ListFeedsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListFeeds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFeeds(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ListFeedsRequest* /*request*/, ::google::cloud::asset::v1::ListFeedsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListFeeds(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::ListFeedsRequest* /*request*/, ::google::cloud::asset::v1::ListFeedsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateFeed() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::UpdateFeedRequest, ::google::cloud::asset::v1::Feed>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::UpdateFeedRequest* request, ::google::cloud::asset::v1::Feed* response) { return this->UpdateFeed(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateFeed(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::UpdateFeedRequest, ::google::cloud::asset::v1::Feed>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::UpdateFeedRequest, ::google::cloud::asset::v1::Feed>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::UpdateFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateFeed(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::UpdateFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteFeed() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::DeleteFeedRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::DeleteFeedRequest* request, ::google::protobuf::Empty* response) { return this->DeleteFeed(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteFeed(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::DeleteFeedRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::DeleteFeedRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::DeleteFeedRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteFeed(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::DeleteFeedRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SearchAllResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchAllResources() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::SearchAllResourcesRequest, ::google::cloud::asset::v1::SearchAllResourcesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::SearchAllResourcesRequest* request, ::google::cloud::asset::v1::SearchAllResourcesResponse* response) { return this->SearchAllResources(context, request, response); }));}
    void SetMessageAllocatorFor_SearchAllResources(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::SearchAllResourcesRequest, ::google::cloud::asset::v1::SearchAllResourcesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::SearchAllResourcesRequest, ::google::cloud::asset::v1::SearchAllResourcesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchAllResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchAllResources(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::SearchAllResourcesRequest* /*request*/, ::google::cloud::asset::v1::SearchAllResourcesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchAllResources(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::SearchAllResourcesRequest* /*request*/, ::google::cloud::asset::v1::SearchAllResourcesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SearchAllIamPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchAllIamPolicies() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::SearchAllIamPoliciesRequest, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest* request, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse* response) { return this->SearchAllIamPolicies(context, request, response); }));}
    void SetMessageAllocatorFor_SearchAllIamPolicies(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::SearchAllIamPoliciesRequest, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::SearchAllIamPoliciesRequest, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchAllIamPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchAllIamPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest* /*request*/, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchAllIamPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest* /*request*/, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AnalyzeIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AnalyzeIamPolicy() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::AnalyzeIamPolicyRequest, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest* request, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse* response) { return this->AnalyzeIamPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_AnalyzeIamPolicy(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::AnalyzeIamPolicyRequest, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::AnalyzeIamPolicyRequest, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AnalyzeIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeIamPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AnalyzeIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AnalyzeIamPolicyLongrunning : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AnalyzeIamPolicyLongrunning() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest* request, ::google::longrunning::Operation* response) { return this->AnalyzeIamPolicyLongrunning(context, request, response); }));}
    void SetMessageAllocatorFor_AnalyzeIamPolicyLongrunning(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AnalyzeIamPolicyLongrunning() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeIamPolicyLongrunning(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AnalyzeIamPolicyLongrunning(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AnalyzeMove : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AnalyzeMove() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::AnalyzeMoveRequest, ::google::cloud::asset::v1::AnalyzeMoveResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::AnalyzeMoveRequest* request, ::google::cloud::asset::v1::AnalyzeMoveResponse* response) { return this->AnalyzeMove(context, request, response); }));}
    void SetMessageAllocatorFor_AnalyzeMove(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::AnalyzeMoveRequest, ::google::cloud::asset::v1::AnalyzeMoveResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::AnalyzeMoveRequest, ::google::cloud::asset::v1::AnalyzeMoveResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AnalyzeMove() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeMove(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeMoveRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeMoveResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AnalyzeMove(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeMoveRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeMoveResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_QueryAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_QueryAssets() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::QueryAssetsRequest, ::google::cloud::asset::v1::QueryAssetsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::QueryAssetsRequest* request, ::google::cloud::asset::v1::QueryAssetsResponse* response) { return this->QueryAssets(context, request, response); }));}
    void SetMessageAllocatorFor_QueryAssets(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::QueryAssetsRequest, ::google::cloud::asset::v1::QueryAssetsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::QueryAssetsRequest, ::google::cloud::asset::v1::QueryAssetsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_QueryAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status QueryAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::QueryAssetsRequest* /*request*/, ::google::cloud::asset::v1::QueryAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* QueryAssets(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::QueryAssetsRequest* /*request*/, ::google::cloud::asset::v1::QueryAssetsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateSavedQuery() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::CreateSavedQueryRequest, ::google::cloud::asset::v1::SavedQuery>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::CreateSavedQueryRequest* request, ::google::cloud::asset::v1::SavedQuery* response) { return this->CreateSavedQuery(context, request, response); }));}
    void SetMessageAllocatorFor_CreateSavedQuery(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::CreateSavedQueryRequest, ::google::cloud::asset::v1::SavedQuery>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::CreateSavedQueryRequest, ::google::cloud::asset::v1::SavedQuery>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::CreateSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSavedQuery(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::CreateSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetSavedQuery() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::GetSavedQueryRequest, ::google::cloud::asset::v1::SavedQuery>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::GetSavedQueryRequest* request, ::google::cloud::asset::v1::SavedQuery* response) { return this->GetSavedQuery(context, request, response); }));}
    void SetMessageAllocatorFor_GetSavedQuery(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::GetSavedQueryRequest, ::google::cloud::asset::v1::SavedQuery>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::GetSavedQueryRequest, ::google::cloud::asset::v1::SavedQuery>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::GetSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSavedQuery(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::GetSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListSavedQueries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSavedQueries() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::ListSavedQueriesRequest, ::google::cloud::asset::v1::ListSavedQueriesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::ListSavedQueriesRequest* request, ::google::cloud::asset::v1::ListSavedQueriesResponse* response) { return this->ListSavedQueries(context, request, response); }));}
    void SetMessageAllocatorFor_ListSavedQueries(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::ListSavedQueriesRequest, ::google::cloud::asset::v1::ListSavedQueriesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::ListSavedQueriesRequest, ::google::cloud::asset::v1::ListSavedQueriesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSavedQueries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSavedQueries(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ListSavedQueriesRequest* /*request*/, ::google::cloud::asset::v1::ListSavedQueriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSavedQueries(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::ListSavedQueriesRequest* /*request*/, ::google::cloud::asset::v1::ListSavedQueriesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateSavedQuery() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::UpdateSavedQueryRequest, ::google::cloud::asset::v1::SavedQuery>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::UpdateSavedQueryRequest* request, ::google::cloud::asset::v1::SavedQuery* response) { return this->UpdateSavedQuery(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateSavedQuery(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::UpdateSavedQueryRequest, ::google::cloud::asset::v1::SavedQuery>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::UpdateSavedQueryRequest, ::google::cloud::asset::v1::SavedQuery>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::UpdateSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSavedQuery(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::UpdateSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteSavedQuery() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::DeleteSavedQueryRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::DeleteSavedQueryRequest* request, ::google::protobuf::Empty* response) { return this->DeleteSavedQuery(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteSavedQuery(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::DeleteSavedQueryRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::DeleteSavedQueryRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::DeleteSavedQueryRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSavedQuery(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::DeleteSavedQueryRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchGetEffectiveIamPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchGetEffectiveIamPolicies() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest* request, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse* response) { return this->BatchGetEffectiveIamPolicies(context, request, response); }));}
    void SetMessageAllocatorFor_BatchGetEffectiveIamPolicies(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchGetEffectiveIamPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchGetEffectiveIamPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest* /*request*/, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchGetEffectiveIamPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest* /*request*/, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AnalyzeOrgPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AnalyzeOrgPolicies() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest* request, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse* response) { return this->AnalyzeOrgPolicies(context, request, response); }));}
    void SetMessageAllocatorFor_AnalyzeOrgPolicies(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AnalyzeOrgPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeOrgPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AnalyzeOrgPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AnalyzeOrgPolicyGovernedContainers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AnalyzeOrgPolicyGovernedContainers() {
      ::grpc::Service::MarkMethodCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest* request, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse* response) { return this->AnalyzeOrgPolicyGovernedContainers(context, request, response); }));}
    void SetMessageAllocatorFor_AnalyzeOrgPolicyGovernedContainers(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(21);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AnalyzeOrgPolicyGovernedContainers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeOrgPolicyGovernedContainers(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AnalyzeOrgPolicyGovernedContainers(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AnalyzeOrgPolicyGovernedAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AnalyzeOrgPolicyGovernedAssets() {
      ::grpc::Service::MarkMethodCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest* request, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse* response) { return this->AnalyzeOrgPolicyGovernedAssets(context, request, response); }));}
    void SetMessageAllocatorFor_AnalyzeOrgPolicyGovernedAssets(
        ::grpc::MessageAllocator< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(22);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AnalyzeOrgPolicyGovernedAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeOrgPolicyGovernedAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AnalyzeOrgPolicyGovernedAssets(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ExportAssets<WithCallbackMethod_ListAssets<WithCallbackMethod_BatchGetAssetsHistory<WithCallbackMethod_CreateFeed<WithCallbackMethod_GetFeed<WithCallbackMethod_ListFeeds<WithCallbackMethod_UpdateFeed<WithCallbackMethod_DeleteFeed<WithCallbackMethod_SearchAllResources<WithCallbackMethod_SearchAllIamPolicies<WithCallbackMethod_AnalyzeIamPolicy<WithCallbackMethod_AnalyzeIamPolicyLongrunning<WithCallbackMethod_AnalyzeMove<WithCallbackMethod_QueryAssets<WithCallbackMethod_CreateSavedQuery<WithCallbackMethod_GetSavedQuery<WithCallbackMethod_ListSavedQueries<WithCallbackMethod_UpdateSavedQuery<WithCallbackMethod_DeleteSavedQuery<WithCallbackMethod_BatchGetEffectiveIamPolicies<WithCallbackMethod_AnalyzeOrgPolicies<WithCallbackMethod_AnalyzeOrgPolicyGovernedContainers<WithCallbackMethod_AnalyzeOrgPolicyGovernedAssets<Service > > > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ExportAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ExportAssets() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ExportAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ExportAssetsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAssets() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ListAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ListAssetsRequest* /*request*/, ::google::cloud::asset::v1::ListAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchGetAssetsHistory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchGetAssetsHistory() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_BatchGetAssetsHistory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchGetAssetsHistory(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest* /*request*/, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateFeed() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_CreateFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::CreateFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetFeed() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_GetFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::GetFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListFeeds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListFeeds() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListFeeds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFeeds(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ListFeedsRequest* /*request*/, ::google::cloud::asset::v1::ListFeedsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateFeed() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_UpdateFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::UpdateFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteFeed() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_DeleteFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::DeleteFeedRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SearchAllResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchAllResources() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_SearchAllResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchAllResources(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::SearchAllResourcesRequest* /*request*/, ::google::cloud::asset::v1::SearchAllResourcesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SearchAllIamPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchAllIamPolicies() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_SearchAllIamPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchAllIamPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest* /*request*/, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AnalyzeIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AnalyzeIamPolicy() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_AnalyzeIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeIamPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AnalyzeIamPolicyLongrunning : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AnalyzeIamPolicyLongrunning() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_AnalyzeIamPolicyLongrunning() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeIamPolicyLongrunning(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AnalyzeMove : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AnalyzeMove() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_AnalyzeMove() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeMove(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeMoveRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeMoveResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_QueryAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_QueryAssets() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_QueryAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status QueryAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::QueryAssetsRequest* /*request*/, ::google::cloud::asset::v1::QueryAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateSavedQuery() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_CreateSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::CreateSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetSavedQuery() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_GetSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::GetSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListSavedQueries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSavedQueries() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_ListSavedQueries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSavedQueries(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ListSavedQueriesRequest* /*request*/, ::google::cloud::asset::v1::ListSavedQueriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateSavedQuery() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_UpdateSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::UpdateSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteSavedQuery() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_DeleteSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::DeleteSavedQueryRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchGetEffectiveIamPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchGetEffectiveIamPolicies() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_BatchGetEffectiveIamPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchGetEffectiveIamPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest* /*request*/, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AnalyzeOrgPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AnalyzeOrgPolicies() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_AnalyzeOrgPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeOrgPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AnalyzeOrgPolicyGovernedContainers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AnalyzeOrgPolicyGovernedContainers() {
      ::grpc::Service::MarkMethodGeneric(21);
    }
    ~WithGenericMethod_AnalyzeOrgPolicyGovernedContainers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeOrgPolicyGovernedContainers(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AnalyzeOrgPolicyGovernedAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AnalyzeOrgPolicyGovernedAssets() {
      ::grpc::Service::MarkMethodGeneric(22);
    }
    ~WithGenericMethod_AnalyzeOrgPolicyGovernedAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeOrgPolicyGovernedAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ExportAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ExportAssets() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ExportAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ExportAssetsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportAssets(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAssets() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ListAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ListAssetsRequest* /*request*/, ::google::cloud::asset::v1::ListAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAssets(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchGetAssetsHistory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchGetAssetsHistory() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_BatchGetAssetsHistory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchGetAssetsHistory(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest* /*request*/, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchGetAssetsHistory(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateFeed() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_CreateFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::CreateFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateFeed(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetFeed() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_GetFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::GetFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetFeed(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListFeeds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListFeeds() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListFeeds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFeeds(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ListFeedsRequest* /*request*/, ::google::cloud::asset::v1::ListFeedsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListFeeds(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateFeed() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_UpdateFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::UpdateFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateFeed(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteFeed() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_DeleteFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::DeleteFeedRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteFeed(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchAllResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchAllResources() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_SearchAllResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchAllResources(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::SearchAllResourcesRequest* /*request*/, ::google::cloud::asset::v1::SearchAllResourcesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchAllResources(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchAllIamPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchAllIamPolicies() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_SearchAllIamPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchAllIamPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest* /*request*/, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchAllIamPolicies(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AnalyzeIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AnalyzeIamPolicy() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_AnalyzeIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeIamPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAnalyzeIamPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AnalyzeIamPolicyLongrunning : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AnalyzeIamPolicyLongrunning() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_AnalyzeIamPolicyLongrunning() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeIamPolicyLongrunning(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAnalyzeIamPolicyLongrunning(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AnalyzeMove : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AnalyzeMove() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_AnalyzeMove() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeMove(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeMoveRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeMoveResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAnalyzeMove(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_QueryAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_QueryAssets() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_QueryAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status QueryAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::QueryAssetsRequest* /*request*/, ::google::cloud::asset::v1::QueryAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestQueryAssets(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateSavedQuery() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_CreateSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::CreateSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSavedQuery(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetSavedQuery() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_GetSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::GetSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSavedQuery(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSavedQueries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSavedQueries() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_ListSavedQueries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSavedQueries(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ListSavedQueriesRequest* /*request*/, ::google::cloud::asset::v1::ListSavedQueriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSavedQueries(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateSavedQuery() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_UpdateSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::UpdateSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSavedQuery(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteSavedQuery() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_DeleteSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::DeleteSavedQueryRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSavedQuery(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchGetEffectiveIamPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchGetEffectiveIamPolicies() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_BatchGetEffectiveIamPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchGetEffectiveIamPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest* /*request*/, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchGetEffectiveIamPolicies(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AnalyzeOrgPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AnalyzeOrgPolicies() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_AnalyzeOrgPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeOrgPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAnalyzeOrgPolicies(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AnalyzeOrgPolicyGovernedContainers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AnalyzeOrgPolicyGovernedContainers() {
      ::grpc::Service::MarkMethodRaw(21);
    }
    ~WithRawMethod_AnalyzeOrgPolicyGovernedContainers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeOrgPolicyGovernedContainers(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAnalyzeOrgPolicyGovernedContainers(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AnalyzeOrgPolicyGovernedAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AnalyzeOrgPolicyGovernedAssets() {
      ::grpc::Service::MarkMethodRaw(22);
    }
    ~WithRawMethod_AnalyzeOrgPolicyGovernedAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeOrgPolicyGovernedAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAnalyzeOrgPolicyGovernedAssets(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ExportAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ExportAssets() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ExportAssets(context, request, response); }));
    }
    ~WithRawCallbackMethod_ExportAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ExportAssetsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ExportAssets(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAssets() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAssets(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ListAssetsRequest* /*request*/, ::google::cloud::asset::v1::ListAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAssets(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchGetAssetsHistory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchGetAssetsHistory() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchGetAssetsHistory(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchGetAssetsHistory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchGetAssetsHistory(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest* /*request*/, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchGetAssetsHistory(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateFeed() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateFeed(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::CreateFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateFeed(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetFeed() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetFeed(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::GetFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetFeed(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListFeeds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListFeeds() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListFeeds(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListFeeds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFeeds(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ListFeedsRequest* /*request*/, ::google::cloud::asset::v1::ListFeedsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListFeeds(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateFeed() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateFeed(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::UpdateFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateFeed(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteFeed() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteFeed(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::DeleteFeedRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteFeed(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchAllResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchAllResources() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchAllResources(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchAllResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchAllResources(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::SearchAllResourcesRequest* /*request*/, ::google::cloud::asset::v1::SearchAllResourcesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchAllResources(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchAllIamPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchAllIamPolicies() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchAllIamPolicies(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchAllIamPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchAllIamPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest* /*request*/, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchAllIamPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AnalyzeIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AnalyzeIamPolicy() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AnalyzeIamPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_AnalyzeIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeIamPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AnalyzeIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AnalyzeIamPolicyLongrunning : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AnalyzeIamPolicyLongrunning() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AnalyzeIamPolicyLongrunning(context, request, response); }));
    }
    ~WithRawCallbackMethod_AnalyzeIamPolicyLongrunning() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeIamPolicyLongrunning(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AnalyzeIamPolicyLongrunning(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AnalyzeMove : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AnalyzeMove() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AnalyzeMove(context, request, response); }));
    }
    ~WithRawCallbackMethod_AnalyzeMove() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeMove(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeMoveRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeMoveResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AnalyzeMove(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_QueryAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_QueryAssets() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->QueryAssets(context, request, response); }));
    }
    ~WithRawCallbackMethod_QueryAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status QueryAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::QueryAssetsRequest* /*request*/, ::google::cloud::asset::v1::QueryAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* QueryAssets(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateSavedQuery() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateSavedQuery(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::CreateSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSavedQuery(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetSavedQuery() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetSavedQuery(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::GetSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSavedQuery(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSavedQueries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSavedQueries() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSavedQueries(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSavedQueries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSavedQueries(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ListSavedQueriesRequest* /*request*/, ::google::cloud::asset::v1::ListSavedQueriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSavedQueries(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateSavedQuery() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateSavedQuery(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::UpdateSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSavedQuery(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteSavedQuery() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteSavedQuery(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::DeleteSavedQueryRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSavedQuery(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchGetEffectiveIamPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchGetEffectiveIamPolicies() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchGetEffectiveIamPolicies(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchGetEffectiveIamPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchGetEffectiveIamPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest* /*request*/, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchGetEffectiveIamPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AnalyzeOrgPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AnalyzeOrgPolicies() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AnalyzeOrgPolicies(context, request, response); }));
    }
    ~WithRawCallbackMethod_AnalyzeOrgPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeOrgPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AnalyzeOrgPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AnalyzeOrgPolicyGovernedContainers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AnalyzeOrgPolicyGovernedContainers() {
      ::grpc::Service::MarkMethodRawCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AnalyzeOrgPolicyGovernedContainers(context, request, response); }));
    }
    ~WithRawCallbackMethod_AnalyzeOrgPolicyGovernedContainers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeOrgPolicyGovernedContainers(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AnalyzeOrgPolicyGovernedContainers(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AnalyzeOrgPolicyGovernedAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AnalyzeOrgPolicyGovernedAssets() {
      ::grpc::Service::MarkMethodRawCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AnalyzeOrgPolicyGovernedAssets(context, request, response); }));
    }
    ~WithRawCallbackMethod_AnalyzeOrgPolicyGovernedAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AnalyzeOrgPolicyGovernedAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AnalyzeOrgPolicyGovernedAssets(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ExportAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ExportAssets() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::ExportAssetsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::ExportAssetsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedExportAssets(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ExportAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ExportAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ExportAssetsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedExportAssets(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::ExportAssetsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAssets() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::ListAssetsRequest, ::google::cloud::asset::v1::ListAssetsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::ListAssetsRequest, ::google::cloud::asset::v1::ListAssetsResponse>* streamer) {
                       return this->StreamedListAssets(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ListAssetsRequest* /*request*/, ::google::cloud::asset::v1::ListAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAssets(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::ListAssetsRequest,::google::cloud::asset::v1::ListAssetsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchGetAssetsHistory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchGetAssetsHistory() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse>* streamer) {
                       return this->StreamedBatchGetAssetsHistory(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchGetAssetsHistory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchGetAssetsHistory(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest* /*request*/, ::google::cloud::asset::v1::BatchGetAssetsHistoryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchGetAssetsHistory(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::BatchGetAssetsHistoryRequest,::google::cloud::asset::v1::BatchGetAssetsHistoryResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateFeed() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::CreateFeedRequest, ::google::cloud::asset::v1::Feed>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::CreateFeedRequest, ::google::cloud::asset::v1::Feed>* streamer) {
                       return this->StreamedCreateFeed(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::CreateFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateFeed(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::CreateFeedRequest,::google::cloud::asset::v1::Feed>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetFeed() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::GetFeedRequest, ::google::cloud::asset::v1::Feed>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::GetFeedRequest, ::google::cloud::asset::v1::Feed>* streamer) {
                       return this->StreamedGetFeed(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::GetFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetFeed(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::GetFeedRequest,::google::cloud::asset::v1::Feed>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListFeeds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListFeeds() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::ListFeedsRequest, ::google::cloud::asset::v1::ListFeedsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::ListFeedsRequest, ::google::cloud::asset::v1::ListFeedsResponse>* streamer) {
                       return this->StreamedListFeeds(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListFeeds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListFeeds(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ListFeedsRequest* /*request*/, ::google::cloud::asset::v1::ListFeedsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListFeeds(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::ListFeedsRequest,::google::cloud::asset::v1::ListFeedsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateFeed() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::UpdateFeedRequest, ::google::cloud::asset::v1::Feed>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::UpdateFeedRequest, ::google::cloud::asset::v1::Feed>* streamer) {
                       return this->StreamedUpdateFeed(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::UpdateFeedRequest* /*request*/, ::google::cloud::asset::v1::Feed* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateFeed(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::UpdateFeedRequest,::google::cloud::asset::v1::Feed>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteFeed : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteFeed() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::DeleteFeedRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::DeleteFeedRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteFeed(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteFeed() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteFeed(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::DeleteFeedRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteFeed(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::DeleteFeedRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchAllResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchAllResources() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::SearchAllResourcesRequest, ::google::cloud::asset::v1::SearchAllResourcesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::SearchAllResourcesRequest, ::google::cloud::asset::v1::SearchAllResourcesResponse>* streamer) {
                       return this->StreamedSearchAllResources(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchAllResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchAllResources(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::SearchAllResourcesRequest* /*request*/, ::google::cloud::asset::v1::SearchAllResourcesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchAllResources(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::SearchAllResourcesRequest,::google::cloud::asset::v1::SearchAllResourcesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchAllIamPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchAllIamPolicies() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::SearchAllIamPoliciesRequest, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::SearchAllIamPoliciesRequest, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse>* streamer) {
                       return this->StreamedSearchAllIamPolicies(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchAllIamPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchAllIamPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::SearchAllIamPoliciesRequest* /*request*/, ::google::cloud::asset::v1::SearchAllIamPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchAllIamPolicies(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::SearchAllIamPoliciesRequest,::google::cloud::asset::v1::SearchAllIamPoliciesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AnalyzeIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AnalyzeIamPolicy() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::AnalyzeIamPolicyRequest, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::AnalyzeIamPolicyRequest, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse>* streamer) {
                       return this->StreamedAnalyzeIamPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AnalyzeIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AnalyzeIamPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeIamPolicyRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeIamPolicyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAnalyzeIamPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::AnalyzeIamPolicyRequest,::google::cloud::asset::v1::AnalyzeIamPolicyResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AnalyzeIamPolicyLongrunning : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AnalyzeIamPolicyLongrunning() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedAnalyzeIamPolicyLongrunning(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AnalyzeIamPolicyLongrunning() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AnalyzeIamPolicyLongrunning(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAnalyzeIamPolicyLongrunning(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::AnalyzeIamPolicyLongrunningRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AnalyzeMove : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AnalyzeMove() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::AnalyzeMoveRequest, ::google::cloud::asset::v1::AnalyzeMoveResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::AnalyzeMoveRequest, ::google::cloud::asset::v1::AnalyzeMoveResponse>* streamer) {
                       return this->StreamedAnalyzeMove(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AnalyzeMove() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AnalyzeMove(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeMoveRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeMoveResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAnalyzeMove(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::AnalyzeMoveRequest,::google::cloud::asset::v1::AnalyzeMoveResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_QueryAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_QueryAssets() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::QueryAssetsRequest, ::google::cloud::asset::v1::QueryAssetsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::QueryAssetsRequest, ::google::cloud::asset::v1::QueryAssetsResponse>* streamer) {
                       return this->StreamedQueryAssets(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_QueryAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status QueryAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::QueryAssetsRequest* /*request*/, ::google::cloud::asset::v1::QueryAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedQueryAssets(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::QueryAssetsRequest,::google::cloud::asset::v1::QueryAssetsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateSavedQuery() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::CreateSavedQueryRequest, ::google::cloud::asset::v1::SavedQuery>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::CreateSavedQueryRequest, ::google::cloud::asset::v1::SavedQuery>* streamer) {
                       return this->StreamedCreateSavedQuery(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::CreateSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateSavedQuery(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::CreateSavedQueryRequest,::google::cloud::asset::v1::SavedQuery>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetSavedQuery() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::GetSavedQueryRequest, ::google::cloud::asset::v1::SavedQuery>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::GetSavedQueryRequest, ::google::cloud::asset::v1::SavedQuery>* streamer) {
                       return this->StreamedGetSavedQuery(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::GetSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetSavedQuery(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::GetSavedQueryRequest,::google::cloud::asset::v1::SavedQuery>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSavedQueries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSavedQueries() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::ListSavedQueriesRequest, ::google::cloud::asset::v1::ListSavedQueriesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::ListSavedQueriesRequest, ::google::cloud::asset::v1::ListSavedQueriesResponse>* streamer) {
                       return this->StreamedListSavedQueries(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSavedQueries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSavedQueries(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::ListSavedQueriesRequest* /*request*/, ::google::cloud::asset::v1::ListSavedQueriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSavedQueries(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::ListSavedQueriesRequest,::google::cloud::asset::v1::ListSavedQueriesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateSavedQuery() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::UpdateSavedQueryRequest, ::google::cloud::asset::v1::SavedQuery>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::UpdateSavedQueryRequest, ::google::cloud::asset::v1::SavedQuery>* streamer) {
                       return this->StreamedUpdateSavedQuery(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::UpdateSavedQueryRequest* /*request*/, ::google::cloud::asset::v1::SavedQuery* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateSavedQuery(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::UpdateSavedQueryRequest,::google::cloud::asset::v1::SavedQuery>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteSavedQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteSavedQuery() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::DeleteSavedQueryRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::DeleteSavedQueryRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteSavedQuery(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteSavedQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteSavedQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::DeleteSavedQueryRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteSavedQuery(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::DeleteSavedQueryRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchGetEffectiveIamPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchGetEffectiveIamPolicies() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse>* streamer) {
                       return this->StreamedBatchGetEffectiveIamPolicies(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchGetEffectiveIamPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchGetEffectiveIamPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest* /*request*/, ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchGetEffectiveIamPolicies(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesRequest,::google::cloud::asset::v1::BatchGetEffectiveIamPoliciesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AnalyzeOrgPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AnalyzeOrgPolicies() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse>* streamer) {
                       return this->StreamedAnalyzeOrgPolicies(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AnalyzeOrgPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AnalyzeOrgPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAnalyzeOrgPolicies(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::AnalyzeOrgPoliciesRequest,::google::cloud::asset::v1::AnalyzeOrgPoliciesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AnalyzeOrgPolicyGovernedContainers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AnalyzeOrgPolicyGovernedContainers() {
      ::grpc::Service::MarkMethodStreamed(21,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse>* streamer) {
                       return this->StreamedAnalyzeOrgPolicyGovernedContainers(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AnalyzeOrgPolicyGovernedContainers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AnalyzeOrgPolicyGovernedContainers(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAnalyzeOrgPolicyGovernedContainers(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersRequest,::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedContainersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AnalyzeOrgPolicyGovernedAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AnalyzeOrgPolicyGovernedAssets() {
      ::grpc::Service::MarkMethodStreamed(22,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse>* streamer) {
                       return this->StreamedAnalyzeOrgPolicyGovernedAssets(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AnalyzeOrgPolicyGovernedAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AnalyzeOrgPolicyGovernedAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest* /*request*/, ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAnalyzeOrgPolicyGovernedAssets(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsRequest,::google::cloud::asset::v1::AnalyzeOrgPolicyGovernedAssetsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ExportAssets<WithStreamedUnaryMethod_ListAssets<WithStreamedUnaryMethod_BatchGetAssetsHistory<WithStreamedUnaryMethod_CreateFeed<WithStreamedUnaryMethod_GetFeed<WithStreamedUnaryMethod_ListFeeds<WithStreamedUnaryMethod_UpdateFeed<WithStreamedUnaryMethod_DeleteFeed<WithStreamedUnaryMethod_SearchAllResources<WithStreamedUnaryMethod_SearchAllIamPolicies<WithStreamedUnaryMethod_AnalyzeIamPolicy<WithStreamedUnaryMethod_AnalyzeIamPolicyLongrunning<WithStreamedUnaryMethod_AnalyzeMove<WithStreamedUnaryMethod_QueryAssets<WithStreamedUnaryMethod_CreateSavedQuery<WithStreamedUnaryMethod_GetSavedQuery<WithStreamedUnaryMethod_ListSavedQueries<WithStreamedUnaryMethod_UpdateSavedQuery<WithStreamedUnaryMethod_DeleteSavedQuery<WithStreamedUnaryMethod_BatchGetEffectiveIamPolicies<WithStreamedUnaryMethod_AnalyzeOrgPolicies<WithStreamedUnaryMethod_AnalyzeOrgPolicyGovernedContainers<WithStreamedUnaryMethod_AnalyzeOrgPolicyGovernedAssets<Service > > > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ExportAssets<WithStreamedUnaryMethod_ListAssets<WithStreamedUnaryMethod_BatchGetAssetsHistory<WithStreamedUnaryMethod_CreateFeed<WithStreamedUnaryMethod_GetFeed<WithStreamedUnaryMethod_ListFeeds<WithStreamedUnaryMethod_UpdateFeed<WithStreamedUnaryMethod_DeleteFeed<WithStreamedUnaryMethod_SearchAllResources<WithStreamedUnaryMethod_SearchAllIamPolicies<WithStreamedUnaryMethod_AnalyzeIamPolicy<WithStreamedUnaryMethod_AnalyzeIamPolicyLongrunning<WithStreamedUnaryMethod_AnalyzeMove<WithStreamedUnaryMethod_QueryAssets<WithStreamedUnaryMethod_CreateSavedQuery<WithStreamedUnaryMethod_GetSavedQuery<WithStreamedUnaryMethod_ListSavedQueries<WithStreamedUnaryMethod_UpdateSavedQuery<WithStreamedUnaryMethod_DeleteSavedQuery<WithStreamedUnaryMethod_BatchGetEffectiveIamPolicies<WithStreamedUnaryMethod_AnalyzeOrgPolicies<WithStreamedUnaryMethod_AnalyzeOrgPolicyGovernedContainers<WithStreamedUnaryMethod_AnalyzeOrgPolicyGovernedAssets<Service > > > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace asset
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fasset_2fv1_2fasset_5fservice_2eproto__INCLUDED
