// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/automl/v1/service.proto
// Original file comments:
// Copyright 2021 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fautoml_2fv1_2fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fautoml_2fv1_2fservice_2eproto__INCLUDED

#include "google/cloud/automl/v1/service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace automl {
namespace v1 {

// AutoML Server API.
//
// The resource names are assigned by the server.
// The server never reuses names that it has created after the resources with
// those names are deleted.
//
// An ID of a resource is the last element of the item's resource name. For
// `projects/{project_id}/locations/{location_id}/datasets/{dataset_id}`, then
// the id for the item is `{dataset_id}`.
//
// Currently the only supported `location_id` is "us-central1".
//
// On any input that is documented to expect a string parameter in
// snake_case or dash-case, either of those cases is accepted.
class AutoMl final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.automl.v1.AutoMl";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a dataset.
    virtual ::grpc::Status CreateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateDatasetRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateDatasetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateDatasetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateDatasetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateDatasetRaw(context, request, cq));
    }
    // Gets a dataset.
    virtual ::grpc::Status GetDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetDatasetRequest& request, ::google::cloud::automl::v1::Dataset* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Dataset>> AsyncGetDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetDatasetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Dataset>>(AsyncGetDatasetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Dataset>> PrepareAsyncGetDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetDatasetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Dataset>>(PrepareAsyncGetDatasetRaw(context, request, cq));
    }
    // Lists datasets in a project.
    virtual ::grpc::Status ListDatasets(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListDatasetsRequest& request, ::google::cloud::automl::v1::ListDatasetsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ListDatasetsResponse>> AsyncListDatasets(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListDatasetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ListDatasetsResponse>>(AsyncListDatasetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ListDatasetsResponse>> PrepareAsyncListDatasets(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListDatasetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ListDatasetsResponse>>(PrepareAsyncListDatasetsRaw(context, request, cq));
    }
    // Updates a dataset.
    virtual ::grpc::Status UpdateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateDatasetRequest& request, ::google::cloud::automl::v1::Dataset* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Dataset>> AsyncUpdateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateDatasetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Dataset>>(AsyncUpdateDatasetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Dataset>> PrepareAsyncUpdateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateDatasetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Dataset>>(PrepareAsyncUpdateDatasetRaw(context, request, cq));
    }
    // Deletes a dataset and all of its contents.
    // Returns empty response in the
    // [response][google.longrunning.Operation.response] field when it completes,
    // and `delete_details` in the
    // [metadata][google.longrunning.Operation.metadata] field.
    virtual ::grpc::Status DeleteDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteDatasetRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteDatasetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteDatasetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteDatasetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteDatasetRaw(context, request, cq));
    }
    // Imports data into a dataset.
    // For Tables this method can only be called on an empty Dataset.
    //
    // For Tables:
    // *   A
    // [schema_inference_version][google.cloud.automl.v1.InputConfig.params]
    //     parameter must be explicitly set.
    // Returns an empty response in the
    // [response][google.longrunning.Operation.response] field when it completes.
    virtual ::grpc::Status ImportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ImportDataRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncImportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ImportDataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncImportDataRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncImportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ImportDataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncImportDataRaw(context, request, cq));
    }
    // Exports dataset's data to the provided output location.
    // Returns an empty response in the
    // [response][google.longrunning.Operation.response] field when it completes.
    virtual ::grpc::Status ExportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportDataRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncExportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportDataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncExportDataRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncExportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportDataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncExportDataRaw(context, request, cq));
    }
    // Gets an annotation spec.
    virtual ::grpc::Status GetAnnotationSpec(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetAnnotationSpecRequest& request, ::google::cloud::automl::v1::AnnotationSpec* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::AnnotationSpec>> AsyncGetAnnotationSpec(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetAnnotationSpecRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::AnnotationSpec>>(AsyncGetAnnotationSpecRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::AnnotationSpec>> PrepareAsyncGetAnnotationSpec(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetAnnotationSpecRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::AnnotationSpec>>(PrepareAsyncGetAnnotationSpecRaw(context, request, cq));
    }
    // Creates a model.
    // Returns a Model in the [response][google.longrunning.Operation.response]
    // field when it completes.
    // When you create a model, several model evaluations are created for it:
    // a global evaluation, and one evaluation for each annotation spec.
    virtual ::grpc::Status CreateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateModelRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateModelRaw(context, request, cq));
    }
    // Gets a model.
    virtual ::grpc::Status GetModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelRequest& request, ::google::cloud::automl::v1::Model* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Model>> AsyncGetModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Model>>(AsyncGetModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Model>> PrepareAsyncGetModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Model>>(PrepareAsyncGetModelRaw(context, request, cq));
    }
    // Lists models.
    virtual ::grpc::Status ListModels(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelsRequest& request, ::google::cloud::automl::v1::ListModelsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ListModelsResponse>> AsyncListModels(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ListModelsResponse>>(AsyncListModelsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ListModelsResponse>> PrepareAsyncListModels(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ListModelsResponse>>(PrepareAsyncListModelsRaw(context, request, cq));
    }
    // Deletes a model.
    // Returns `google.protobuf.Empty` in the
    // [response][google.longrunning.Operation.response] field when it completes,
    // and `delete_details` in the
    // [metadata][google.longrunning.Operation.metadata] field.
    virtual ::grpc::Status DeleteModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteModelRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteModelRaw(context, request, cq));
    }
    // Updates a model.
    virtual ::grpc::Status UpdateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateModelRequest& request, ::google::cloud::automl::v1::Model* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Model>> AsyncUpdateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Model>>(AsyncUpdateModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Model>> PrepareAsyncUpdateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Model>>(PrepareAsyncUpdateModelRaw(context, request, cq));
    }
    // Deploys a model. If a model is already deployed, deploying it with the
    // same parameters has no effect. Deploying with different parametrs
    // (as e.g. changing
    // [node_number][google.cloud.automl.v1p1beta.ImageObjectDetectionModelDeploymentMetadata.node_number])
    //  will reset the deployment state without pausing the model's availability.
    //
    // Only applicable for Text Classification, Image Object Detection , Tables, and Image Segmentation; all other domains manage
    // deployment automatically.
    //
    // Returns an empty response in the
    // [response][google.longrunning.Operation.response] field when it completes.
    virtual ::grpc::Status DeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeployModelRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeployModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeployModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeployModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeployModelRaw(context, request, cq));
    }
    // Undeploys a model. If the model is not deployed this method has no effect.
    //
    // Only applicable for Text Classification, Image Object Detection and Tables;
    // all other domains manage deployment automatically.
    //
    // Returns an empty response in the
    // [response][google.longrunning.Operation.response] field when it completes.
    virtual ::grpc::Status UndeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UndeployModelRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUndeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UndeployModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUndeployModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUndeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UndeployModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUndeployModelRaw(context, request, cq));
    }
    // Exports a trained, "export-able", model to a user specified Google Cloud
    // Storage location. A model is considered export-able if and only if it has
    // an export format defined for it in
    // [ModelExportOutputConfig][google.cloud.automl.v1.ModelExportOutputConfig].
    //
    // Returns an empty response in the
    // [response][google.longrunning.Operation.response] field when it completes.
    virtual ::grpc::Status ExportModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportModelRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncExportModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncExportModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncExportModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncExportModelRaw(context, request, cq));
    }
    // Gets a model evaluation.
    virtual ::grpc::Status GetModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelEvaluationRequest& request, ::google::cloud::automl::v1::ModelEvaluation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ModelEvaluation>> AsyncGetModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ModelEvaluation>>(AsyncGetModelEvaluationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ModelEvaluation>> PrepareAsyncGetModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ModelEvaluation>>(PrepareAsyncGetModelEvaluationRaw(context, request, cq));
    }
    // Lists model evaluations.
    virtual ::grpc::Status ListModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelEvaluationsRequest& request, ::google::cloud::automl::v1::ListModelEvaluationsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ListModelEvaluationsResponse>> AsyncListModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelEvaluationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ListModelEvaluationsResponse>>(AsyncListModelEvaluationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ListModelEvaluationsResponse>> PrepareAsyncListModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelEvaluationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ListModelEvaluationsResponse>>(PrepareAsyncListModelEvaluationsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a dataset.
      virtual void CreateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateDatasetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateDatasetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a dataset.
      virtual void GetDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetDatasetRequest* request, ::google::cloud::automl::v1::Dataset* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetDatasetRequest* request, ::google::cloud::automl::v1::Dataset* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists datasets in a project.
      virtual void ListDatasets(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListDatasetsRequest* request, ::google::cloud::automl::v1::ListDatasetsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListDatasets(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListDatasetsRequest* request, ::google::cloud::automl::v1::ListDatasetsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a dataset.
      virtual void UpdateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateDatasetRequest* request, ::google::cloud::automl::v1::Dataset* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateDatasetRequest* request, ::google::cloud::automl::v1::Dataset* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a dataset and all of its contents.
      // Returns empty response in the
      // [response][google.longrunning.Operation.response] field when it completes,
      // and `delete_details` in the
      // [metadata][google.longrunning.Operation.metadata] field.
      virtual void DeleteDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteDatasetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteDatasetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Imports data into a dataset.
      // For Tables this method can only be called on an empty Dataset.
      //
      // For Tables:
      // *   A
      // [schema_inference_version][google.cloud.automl.v1.InputConfig.params]
      //     parameter must be explicitly set.
      // Returns an empty response in the
      // [response][google.longrunning.Operation.response] field when it completes.
      virtual void ImportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ImportDataRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ImportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ImportDataRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Exports dataset's data to the provided output location.
      // Returns an empty response in the
      // [response][google.longrunning.Operation.response] field when it completes.
      virtual void ExportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportDataRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ExportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportDataRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets an annotation spec.
      virtual void GetAnnotationSpec(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetAnnotationSpecRequest* request, ::google::cloud::automl::v1::AnnotationSpec* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAnnotationSpec(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetAnnotationSpecRequest* request, ::google::cloud::automl::v1::AnnotationSpec* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a model.
      // Returns a Model in the [response][google.longrunning.Operation.response]
      // field when it completes.
      // When you create a model, several model evaluations are created for it:
      // a global evaluation, and one evaluation for each annotation spec.
      virtual void CreateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a model.
      virtual void GetModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelRequest* request, ::google::cloud::automl::v1::Model* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelRequest* request, ::google::cloud::automl::v1::Model* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists models.
      virtual void ListModels(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelsRequest* request, ::google::cloud::automl::v1::ListModelsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListModels(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelsRequest* request, ::google::cloud::automl::v1::ListModelsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a model.
      // Returns `google.protobuf.Empty` in the
      // [response][google.longrunning.Operation.response] field when it completes,
      // and `delete_details` in the
      // [metadata][google.longrunning.Operation.metadata] field.
      virtual void DeleteModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a model.
      virtual void UpdateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateModelRequest* request, ::google::cloud::automl::v1::Model* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateModelRequest* request, ::google::cloud::automl::v1::Model* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deploys a model. If a model is already deployed, deploying it with the
      // same parameters has no effect. Deploying with different parametrs
      // (as e.g. changing
      // [node_number][google.cloud.automl.v1p1beta.ImageObjectDetectionModelDeploymentMetadata.node_number])
      //  will reset the deployment state without pausing the model's availability.
      //
      // Only applicable for Text Classification, Image Object Detection , Tables, and Image Segmentation; all other domains manage
      // deployment automatically.
      //
      // Returns an empty response in the
      // [response][google.longrunning.Operation.response] field when it completes.
      virtual void DeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeployModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeployModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Undeploys a model. If the model is not deployed this method has no effect.
      //
      // Only applicable for Text Classification, Image Object Detection and Tables;
      // all other domains manage deployment automatically.
      //
      // Returns an empty response in the
      // [response][google.longrunning.Operation.response] field when it completes.
      virtual void UndeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UndeployModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UndeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UndeployModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Exports a trained, "export-able", model to a user specified Google Cloud
      // Storage location. A model is considered export-able if and only if it has
      // an export format defined for it in
      // [ModelExportOutputConfig][google.cloud.automl.v1.ModelExportOutputConfig].
      //
      // Returns an empty response in the
      // [response][google.longrunning.Operation.response] field when it completes.
      virtual void ExportModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ExportModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a model evaluation.
      virtual void GetModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelEvaluationRequest* request, ::google::cloud::automl::v1::ModelEvaluation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelEvaluationRequest* request, ::google::cloud::automl::v1::ModelEvaluation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists model evaluations.
      virtual void ListModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelEvaluationsRequest* request, ::google::cloud::automl::v1::ListModelEvaluationsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelEvaluationsRequest* request, ::google::cloud::automl::v1::ListModelEvaluationsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateDatasetRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateDatasetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateDatasetRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateDatasetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Dataset>* AsyncGetDatasetRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetDatasetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Dataset>* PrepareAsyncGetDatasetRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetDatasetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ListDatasetsResponse>* AsyncListDatasetsRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListDatasetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ListDatasetsResponse>* PrepareAsyncListDatasetsRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListDatasetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Dataset>* AsyncUpdateDatasetRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateDatasetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Dataset>* PrepareAsyncUpdateDatasetRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateDatasetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteDatasetRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteDatasetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteDatasetRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteDatasetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncImportDataRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ImportDataRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncImportDataRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ImportDataRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncExportDataRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportDataRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncExportDataRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportDataRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::AnnotationSpec>* AsyncGetAnnotationSpecRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetAnnotationSpecRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::AnnotationSpec>* PrepareAsyncGetAnnotationSpecRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetAnnotationSpecRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Model>* AsyncGetModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Model>* PrepareAsyncGetModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ListModelsResponse>* AsyncListModelsRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ListModelsResponse>* PrepareAsyncListModelsRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Model>* AsyncUpdateModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::Model>* PrepareAsyncUpdateModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeployModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeployModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeployModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeployModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUndeployModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UndeployModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUndeployModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UndeployModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncExportModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncExportModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ModelEvaluation>* AsyncGetModelEvaluationRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ModelEvaluation>* PrepareAsyncGetModelEvaluationRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ListModelEvaluationsResponse>* AsyncListModelEvaluationsRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelEvaluationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::automl::v1::ListModelEvaluationsResponse>* PrepareAsyncListModelEvaluationsRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelEvaluationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateDatasetRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateDatasetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateDatasetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateDatasetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateDatasetRaw(context, request, cq));
    }
    ::grpc::Status GetDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetDatasetRequest& request, ::google::cloud::automl::v1::Dataset* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Dataset>> AsyncGetDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetDatasetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Dataset>>(AsyncGetDatasetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Dataset>> PrepareAsyncGetDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetDatasetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Dataset>>(PrepareAsyncGetDatasetRaw(context, request, cq));
    }
    ::grpc::Status ListDatasets(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListDatasetsRequest& request, ::google::cloud::automl::v1::ListDatasetsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ListDatasetsResponse>> AsyncListDatasets(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListDatasetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ListDatasetsResponse>>(AsyncListDatasetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ListDatasetsResponse>> PrepareAsyncListDatasets(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListDatasetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ListDatasetsResponse>>(PrepareAsyncListDatasetsRaw(context, request, cq));
    }
    ::grpc::Status UpdateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateDatasetRequest& request, ::google::cloud::automl::v1::Dataset* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Dataset>> AsyncUpdateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateDatasetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Dataset>>(AsyncUpdateDatasetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Dataset>> PrepareAsyncUpdateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateDatasetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Dataset>>(PrepareAsyncUpdateDatasetRaw(context, request, cq));
    }
    ::grpc::Status DeleteDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteDatasetRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteDatasetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteDatasetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteDatasetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteDatasetRaw(context, request, cq));
    }
    ::grpc::Status ImportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ImportDataRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncImportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ImportDataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncImportDataRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncImportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ImportDataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncImportDataRaw(context, request, cq));
    }
    ::grpc::Status ExportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportDataRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncExportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportDataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncExportDataRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncExportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportDataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncExportDataRaw(context, request, cq));
    }
    ::grpc::Status GetAnnotationSpec(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetAnnotationSpecRequest& request, ::google::cloud::automl::v1::AnnotationSpec* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::AnnotationSpec>> AsyncGetAnnotationSpec(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetAnnotationSpecRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::AnnotationSpec>>(AsyncGetAnnotationSpecRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::AnnotationSpec>> PrepareAsyncGetAnnotationSpec(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetAnnotationSpecRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::AnnotationSpec>>(PrepareAsyncGetAnnotationSpecRaw(context, request, cq));
    }
    ::grpc::Status CreateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateModelRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateModelRaw(context, request, cq));
    }
    ::grpc::Status GetModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelRequest& request, ::google::cloud::automl::v1::Model* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Model>> AsyncGetModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Model>>(AsyncGetModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Model>> PrepareAsyncGetModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Model>>(PrepareAsyncGetModelRaw(context, request, cq));
    }
    ::grpc::Status ListModels(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelsRequest& request, ::google::cloud::automl::v1::ListModelsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ListModelsResponse>> AsyncListModels(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ListModelsResponse>>(AsyncListModelsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ListModelsResponse>> PrepareAsyncListModels(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ListModelsResponse>>(PrepareAsyncListModelsRaw(context, request, cq));
    }
    ::grpc::Status DeleteModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteModelRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteModelRaw(context, request, cq));
    }
    ::grpc::Status UpdateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateModelRequest& request, ::google::cloud::automl::v1::Model* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Model>> AsyncUpdateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Model>>(AsyncUpdateModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Model>> PrepareAsyncUpdateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Model>>(PrepareAsyncUpdateModelRaw(context, request, cq));
    }
    ::grpc::Status DeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeployModelRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeployModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeployModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeployModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeployModelRaw(context, request, cq));
    }
    ::grpc::Status UndeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UndeployModelRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUndeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UndeployModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUndeployModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUndeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UndeployModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUndeployModelRaw(context, request, cq));
    }
    ::grpc::Status ExportModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportModelRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncExportModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncExportModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncExportModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncExportModelRaw(context, request, cq));
    }
    ::grpc::Status GetModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelEvaluationRequest& request, ::google::cloud::automl::v1::ModelEvaluation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ModelEvaluation>> AsyncGetModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ModelEvaluation>>(AsyncGetModelEvaluationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ModelEvaluation>> PrepareAsyncGetModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ModelEvaluation>>(PrepareAsyncGetModelEvaluationRaw(context, request, cq));
    }
    ::grpc::Status ListModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelEvaluationsRequest& request, ::google::cloud::automl::v1::ListModelEvaluationsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ListModelEvaluationsResponse>> AsyncListModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelEvaluationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ListModelEvaluationsResponse>>(AsyncListModelEvaluationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ListModelEvaluationsResponse>> PrepareAsyncListModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelEvaluationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ListModelEvaluationsResponse>>(PrepareAsyncListModelEvaluationsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateDatasetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateDatasetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetDatasetRequest* request, ::google::cloud::automl::v1::Dataset* response, std::function<void(::grpc::Status)>) override;
      void GetDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetDatasetRequest* request, ::google::cloud::automl::v1::Dataset* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListDatasets(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListDatasetsRequest* request, ::google::cloud::automl::v1::ListDatasetsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListDatasets(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListDatasetsRequest* request, ::google::cloud::automl::v1::ListDatasetsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateDatasetRequest* request, ::google::cloud::automl::v1::Dataset* response, std::function<void(::grpc::Status)>) override;
      void UpdateDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateDatasetRequest* request, ::google::cloud::automl::v1::Dataset* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteDatasetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteDataset(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteDatasetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ImportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ImportDataRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ImportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ImportDataRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ExportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportDataRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ExportData(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportDataRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAnnotationSpec(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetAnnotationSpecRequest* request, ::google::cloud::automl::v1::AnnotationSpec* response, std::function<void(::grpc::Status)>) override;
      void GetAnnotationSpec(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetAnnotationSpecRequest* request, ::google::cloud::automl::v1::AnnotationSpec* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelRequest* request, ::google::cloud::automl::v1::Model* response, std::function<void(::grpc::Status)>) override;
      void GetModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelRequest* request, ::google::cloud::automl::v1::Model* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListModels(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelsRequest* request, ::google::cloud::automl::v1::ListModelsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListModels(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelsRequest* request, ::google::cloud::automl::v1::ListModelsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateModelRequest* request, ::google::cloud::automl::v1::Model* response, std::function<void(::grpc::Status)>) override;
      void UpdateModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateModelRequest* request, ::google::cloud::automl::v1::Model* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeployModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeployModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UndeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UndeployModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UndeployModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UndeployModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ExportModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ExportModel(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelEvaluationRequest* request, ::google::cloud::automl::v1::ModelEvaluation* response, std::function<void(::grpc::Status)>) override;
      void GetModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelEvaluationRequest* request, ::google::cloud::automl::v1::ModelEvaluation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelEvaluationsRequest* request, ::google::cloud::automl::v1::ListModelEvaluationsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelEvaluationsRequest* request, ::google::cloud::automl::v1::ListModelEvaluationsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateDatasetRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateDatasetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateDatasetRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateDatasetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Dataset>* AsyncGetDatasetRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetDatasetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Dataset>* PrepareAsyncGetDatasetRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetDatasetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ListDatasetsResponse>* AsyncListDatasetsRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListDatasetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ListDatasetsResponse>* PrepareAsyncListDatasetsRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListDatasetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Dataset>* AsyncUpdateDatasetRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateDatasetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Dataset>* PrepareAsyncUpdateDatasetRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateDatasetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteDatasetRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteDatasetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteDatasetRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteDatasetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncImportDataRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ImportDataRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncImportDataRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ImportDataRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncExportDataRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportDataRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncExportDataRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportDataRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::AnnotationSpec>* AsyncGetAnnotationSpecRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetAnnotationSpecRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::AnnotationSpec>* PrepareAsyncGetAnnotationSpecRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetAnnotationSpecRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::CreateModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Model>* AsyncGetModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Model>* PrepareAsyncGetModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ListModelsResponse>* AsyncListModelsRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ListModelsResponse>* PrepareAsyncListModelsRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeleteModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Model>* AsyncUpdateModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::Model>* PrepareAsyncUpdateModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UpdateModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeployModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeployModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeployModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::DeployModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUndeployModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UndeployModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUndeployModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::UndeployModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncExportModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncExportModelRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ExportModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ModelEvaluation>* AsyncGetModelEvaluationRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ModelEvaluation>* PrepareAsyncGetModelEvaluationRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::GetModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ListModelEvaluationsResponse>* AsyncListModelEvaluationsRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelEvaluationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::automl::v1::ListModelEvaluationsResponse>* PrepareAsyncListModelEvaluationsRaw(::grpc::ClientContext* context, const ::google::cloud::automl::v1::ListModelEvaluationsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateDataset_;
    const ::grpc::internal::RpcMethod rpcmethod_GetDataset_;
    const ::grpc::internal::RpcMethod rpcmethod_ListDatasets_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateDataset_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteDataset_;
    const ::grpc::internal::RpcMethod rpcmethod_ImportData_;
    const ::grpc::internal::RpcMethod rpcmethod_ExportData_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAnnotationSpec_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateModel_;
    const ::grpc::internal::RpcMethod rpcmethod_GetModel_;
    const ::grpc::internal::RpcMethod rpcmethod_ListModels_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteModel_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateModel_;
    const ::grpc::internal::RpcMethod rpcmethod_DeployModel_;
    const ::grpc::internal::RpcMethod rpcmethod_UndeployModel_;
    const ::grpc::internal::RpcMethod rpcmethod_ExportModel_;
    const ::grpc::internal::RpcMethod rpcmethod_GetModelEvaluation_;
    const ::grpc::internal::RpcMethod rpcmethod_ListModelEvaluations_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a dataset.
    virtual ::grpc::Status CreateDataset(::grpc::ServerContext* context, const ::google::cloud::automl::v1::CreateDatasetRequest* request, ::google::longrunning::Operation* response);
    // Gets a dataset.
    virtual ::grpc::Status GetDataset(::grpc::ServerContext* context, const ::google::cloud::automl::v1::GetDatasetRequest* request, ::google::cloud::automl::v1::Dataset* response);
    // Lists datasets in a project.
    virtual ::grpc::Status ListDatasets(::grpc::ServerContext* context, const ::google::cloud::automl::v1::ListDatasetsRequest* request, ::google::cloud::automl::v1::ListDatasetsResponse* response);
    // Updates a dataset.
    virtual ::grpc::Status UpdateDataset(::grpc::ServerContext* context, const ::google::cloud::automl::v1::UpdateDatasetRequest* request, ::google::cloud::automl::v1::Dataset* response);
    // Deletes a dataset and all of its contents.
    // Returns empty response in the
    // [response][google.longrunning.Operation.response] field when it completes,
    // and `delete_details` in the
    // [metadata][google.longrunning.Operation.metadata] field.
    virtual ::grpc::Status DeleteDataset(::grpc::ServerContext* context, const ::google::cloud::automl::v1::DeleteDatasetRequest* request, ::google::longrunning::Operation* response);
    // Imports data into a dataset.
    // For Tables this method can only be called on an empty Dataset.
    //
    // For Tables:
    // *   A
    // [schema_inference_version][google.cloud.automl.v1.InputConfig.params]
    //     parameter must be explicitly set.
    // Returns an empty response in the
    // [response][google.longrunning.Operation.response] field when it completes.
    virtual ::grpc::Status ImportData(::grpc::ServerContext* context, const ::google::cloud::automl::v1::ImportDataRequest* request, ::google::longrunning::Operation* response);
    // Exports dataset's data to the provided output location.
    // Returns an empty response in the
    // [response][google.longrunning.Operation.response] field when it completes.
    virtual ::grpc::Status ExportData(::grpc::ServerContext* context, const ::google::cloud::automl::v1::ExportDataRequest* request, ::google::longrunning::Operation* response);
    // Gets an annotation spec.
    virtual ::grpc::Status GetAnnotationSpec(::grpc::ServerContext* context, const ::google::cloud::automl::v1::GetAnnotationSpecRequest* request, ::google::cloud::automl::v1::AnnotationSpec* response);
    // Creates a model.
    // Returns a Model in the [response][google.longrunning.Operation.response]
    // field when it completes.
    // When you create a model, several model evaluations are created for it:
    // a global evaluation, and one evaluation for each annotation spec.
    virtual ::grpc::Status CreateModel(::grpc::ServerContext* context, const ::google::cloud::automl::v1::CreateModelRequest* request, ::google::longrunning::Operation* response);
    // Gets a model.
    virtual ::grpc::Status GetModel(::grpc::ServerContext* context, const ::google::cloud::automl::v1::GetModelRequest* request, ::google::cloud::automl::v1::Model* response);
    // Lists models.
    virtual ::grpc::Status ListModels(::grpc::ServerContext* context, const ::google::cloud::automl::v1::ListModelsRequest* request, ::google::cloud::automl::v1::ListModelsResponse* response);
    // Deletes a model.
    // Returns `google.protobuf.Empty` in the
    // [response][google.longrunning.Operation.response] field when it completes,
    // and `delete_details` in the
    // [metadata][google.longrunning.Operation.metadata] field.
    virtual ::grpc::Status DeleteModel(::grpc::ServerContext* context, const ::google::cloud::automl::v1::DeleteModelRequest* request, ::google::longrunning::Operation* response);
    // Updates a model.
    virtual ::grpc::Status UpdateModel(::grpc::ServerContext* context, const ::google::cloud::automl::v1::UpdateModelRequest* request, ::google::cloud::automl::v1::Model* response);
    // Deploys a model. If a model is already deployed, deploying it with the
    // same parameters has no effect. Deploying with different parametrs
    // (as e.g. changing
    // [node_number][google.cloud.automl.v1p1beta.ImageObjectDetectionModelDeploymentMetadata.node_number])
    //  will reset the deployment state without pausing the model's availability.
    //
    // Only applicable for Text Classification, Image Object Detection , Tables, and Image Segmentation; all other domains manage
    // deployment automatically.
    //
    // Returns an empty response in the
    // [response][google.longrunning.Operation.response] field when it completes.
    virtual ::grpc::Status DeployModel(::grpc::ServerContext* context, const ::google::cloud::automl::v1::DeployModelRequest* request, ::google::longrunning::Operation* response);
    // Undeploys a model. If the model is not deployed this method has no effect.
    //
    // Only applicable for Text Classification, Image Object Detection and Tables;
    // all other domains manage deployment automatically.
    //
    // Returns an empty response in the
    // [response][google.longrunning.Operation.response] field when it completes.
    virtual ::grpc::Status UndeployModel(::grpc::ServerContext* context, const ::google::cloud::automl::v1::UndeployModelRequest* request, ::google::longrunning::Operation* response);
    // Exports a trained, "export-able", model to a user specified Google Cloud
    // Storage location. A model is considered export-able if and only if it has
    // an export format defined for it in
    // [ModelExportOutputConfig][google.cloud.automl.v1.ModelExportOutputConfig].
    //
    // Returns an empty response in the
    // [response][google.longrunning.Operation.response] field when it completes.
    virtual ::grpc::Status ExportModel(::grpc::ServerContext* context, const ::google::cloud::automl::v1::ExportModelRequest* request, ::google::longrunning::Operation* response);
    // Gets a model evaluation.
    virtual ::grpc::Status GetModelEvaluation(::grpc::ServerContext* context, const ::google::cloud::automl::v1::GetModelEvaluationRequest* request, ::google::cloud::automl::v1::ModelEvaluation* response);
    // Lists model evaluations.
    virtual ::grpc::Status ListModelEvaluations(::grpc::ServerContext* context, const ::google::cloud::automl::v1::ListModelEvaluationsRequest* request, ::google::cloud::automl::v1::ListModelEvaluationsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateDataset() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::CreateDatasetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDataset(::grpc::ServerContext* context, ::google::cloud::automl::v1::CreateDatasetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetDataset() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetDatasetRequest* /*request*/, ::google::cloud::automl::v1::Dataset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDataset(::grpc::ServerContext* context, ::google::cloud::automl::v1::GetDatasetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::automl::v1::Dataset>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListDatasets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListDatasets() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ListDatasets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDatasets(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ListDatasetsRequest* /*request*/, ::google::cloud::automl::v1::ListDatasetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDatasets(::grpc::ServerContext* context, ::google::cloud::automl::v1::ListDatasetsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::automl::v1::ListDatasetsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateDataset() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::UpdateDatasetRequest* /*request*/, ::google::cloud::automl::v1::Dataset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDataset(::grpc::ServerContext* context, ::google::cloud::automl::v1::UpdateDatasetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::automl::v1::Dataset>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteDataset() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::DeleteDatasetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDataset(::grpc::ServerContext* context, ::google::cloud::automl::v1::DeleteDatasetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ImportData : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ImportData() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ImportData() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportData(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ImportDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportData(::grpc::ServerContext* context, ::google::cloud::automl::v1::ImportDataRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ExportData : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ExportData() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_ExportData() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportData(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ExportDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportData(::grpc::ServerContext* context, ::google::cloud::automl::v1::ExportDataRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAnnotationSpec : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAnnotationSpec() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_GetAnnotationSpec() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAnnotationSpec(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetAnnotationSpecRequest* /*request*/, ::google::cloud::automl::v1::AnnotationSpec* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAnnotationSpec(::grpc::ServerContext* context, ::google::cloud::automl::v1::GetAnnotationSpecRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::automl::v1::AnnotationSpec>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateModel() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_CreateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::CreateModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateModel(::grpc::ServerContext* context, ::google::cloud::automl::v1::CreateModelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetModel() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_GetModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetModelRequest* /*request*/, ::google::cloud::automl::v1::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetModel(::grpc::ServerContext* context, ::google::cloud::automl::v1::GetModelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::automl::v1::Model>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListModels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListModels() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_ListModels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListModels(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ListModelsRequest* /*request*/, ::google::cloud::automl::v1::ListModelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListModels(::grpc::ServerContext* context, ::google::cloud::automl::v1::ListModelsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::automl::v1::ListModelsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteModel() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_DeleteModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::DeleteModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteModel(::grpc::ServerContext* context, ::google::cloud::automl::v1::DeleteModelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateModel() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_UpdateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::UpdateModelRequest* /*request*/, ::google::cloud::automl::v1::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateModel(::grpc::ServerContext* context, ::google::cloud::automl::v1::UpdateModelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::automl::v1::Model>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeployModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeployModel() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_DeployModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeployModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::DeployModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeployModel(::grpc::ServerContext* context, ::google::cloud::automl::v1::DeployModelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UndeployModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UndeployModel() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_UndeployModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeployModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::UndeployModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUndeployModel(::grpc::ServerContext* context, ::google::cloud::automl::v1::UndeployModelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ExportModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ExportModel() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_ExportModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ExportModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportModel(::grpc::ServerContext* context, ::google::cloud::automl::v1::ExportModelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetModelEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetModelEvaluation() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_GetModelEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetModelEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetModelEvaluationRequest* /*request*/, ::google::cloud::automl::v1::ModelEvaluation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetModelEvaluation(::grpc::ServerContext* context, ::google::cloud::automl::v1::GetModelEvaluationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::automl::v1::ModelEvaluation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListModelEvaluations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListModelEvaluations() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_ListModelEvaluations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListModelEvaluations(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ListModelEvaluationsRequest* /*request*/, ::google::cloud::automl::v1::ListModelEvaluationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListModelEvaluations(::grpc::ServerContext* context, ::google::cloud::automl::v1::ListModelEvaluationsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::automl::v1::ListModelEvaluationsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateDataset<WithAsyncMethod_GetDataset<WithAsyncMethod_ListDatasets<WithAsyncMethod_UpdateDataset<WithAsyncMethod_DeleteDataset<WithAsyncMethod_ImportData<WithAsyncMethod_ExportData<WithAsyncMethod_GetAnnotationSpec<WithAsyncMethod_CreateModel<WithAsyncMethod_GetModel<WithAsyncMethod_ListModels<WithAsyncMethod_DeleteModel<WithAsyncMethod_UpdateModel<WithAsyncMethod_DeployModel<WithAsyncMethod_UndeployModel<WithAsyncMethod_ExportModel<WithAsyncMethod_GetModelEvaluation<WithAsyncMethod_ListModelEvaluations<Service > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateDataset() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::CreateDatasetRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::CreateDatasetRequest* request, ::google::longrunning::Operation* response) { return this->CreateDataset(context, request, response); }));}
    void SetMessageAllocatorFor_CreateDataset(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::CreateDatasetRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::CreateDatasetRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::CreateDatasetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDataset(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::CreateDatasetRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetDataset() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::GetDatasetRequest, ::google::cloud::automl::v1::Dataset>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::GetDatasetRequest* request, ::google::cloud::automl::v1::Dataset* response) { return this->GetDataset(context, request, response); }));}
    void SetMessageAllocatorFor_GetDataset(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::GetDatasetRequest, ::google::cloud::automl::v1::Dataset>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::GetDatasetRequest, ::google::cloud::automl::v1::Dataset>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetDatasetRequest* /*request*/, ::google::cloud::automl::v1::Dataset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDataset(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::GetDatasetRequest* /*request*/, ::google::cloud::automl::v1::Dataset* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListDatasets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListDatasets() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::ListDatasetsRequest, ::google::cloud::automl::v1::ListDatasetsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::ListDatasetsRequest* request, ::google::cloud::automl::v1::ListDatasetsResponse* response) { return this->ListDatasets(context, request, response); }));}
    void SetMessageAllocatorFor_ListDatasets(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::ListDatasetsRequest, ::google::cloud::automl::v1::ListDatasetsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::ListDatasetsRequest, ::google::cloud::automl::v1::ListDatasetsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListDatasets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDatasets(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ListDatasetsRequest* /*request*/, ::google::cloud::automl::v1::ListDatasetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDatasets(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::ListDatasetsRequest* /*request*/, ::google::cloud::automl::v1::ListDatasetsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateDataset() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::UpdateDatasetRequest, ::google::cloud::automl::v1::Dataset>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::UpdateDatasetRequest* request, ::google::cloud::automl::v1::Dataset* response) { return this->UpdateDataset(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateDataset(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::UpdateDatasetRequest, ::google::cloud::automl::v1::Dataset>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::UpdateDatasetRequest, ::google::cloud::automl::v1::Dataset>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::UpdateDatasetRequest* /*request*/, ::google::cloud::automl::v1::Dataset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDataset(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::UpdateDatasetRequest* /*request*/, ::google::cloud::automl::v1::Dataset* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteDataset() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::DeleteDatasetRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::DeleteDatasetRequest* request, ::google::longrunning::Operation* response) { return this->DeleteDataset(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteDataset(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::DeleteDatasetRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::DeleteDatasetRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::DeleteDatasetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDataset(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::DeleteDatasetRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ImportData : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ImportData() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::ImportDataRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::ImportDataRequest* request, ::google::longrunning::Operation* response) { return this->ImportData(context, request, response); }));}
    void SetMessageAllocatorFor_ImportData(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::ImportDataRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::ImportDataRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ImportData() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportData(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ImportDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportData(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::ImportDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ExportData : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ExportData() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::ExportDataRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::ExportDataRequest* request, ::google::longrunning::Operation* response) { return this->ExportData(context, request, response); }));}
    void SetMessageAllocatorFor_ExportData(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::ExportDataRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::ExportDataRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ExportData() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportData(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ExportDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ExportData(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::ExportDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAnnotationSpec : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAnnotationSpec() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::GetAnnotationSpecRequest, ::google::cloud::automl::v1::AnnotationSpec>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::GetAnnotationSpecRequest* request, ::google::cloud::automl::v1::AnnotationSpec* response) { return this->GetAnnotationSpec(context, request, response); }));}
    void SetMessageAllocatorFor_GetAnnotationSpec(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::GetAnnotationSpecRequest, ::google::cloud::automl::v1::AnnotationSpec>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::GetAnnotationSpecRequest, ::google::cloud::automl::v1::AnnotationSpec>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAnnotationSpec() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAnnotationSpec(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetAnnotationSpecRequest* /*request*/, ::google::cloud::automl::v1::AnnotationSpec* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAnnotationSpec(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::GetAnnotationSpecRequest* /*request*/, ::google::cloud::automl::v1::AnnotationSpec* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateModel() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::CreateModelRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::CreateModelRequest* request, ::google::longrunning::Operation* response) { return this->CreateModel(context, request, response); }));}
    void SetMessageAllocatorFor_CreateModel(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::CreateModelRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::CreateModelRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::CreateModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateModel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::CreateModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetModel() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::GetModelRequest, ::google::cloud::automl::v1::Model>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::GetModelRequest* request, ::google::cloud::automl::v1::Model* response) { return this->GetModel(context, request, response); }));}
    void SetMessageAllocatorFor_GetModel(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::GetModelRequest, ::google::cloud::automl::v1::Model>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::GetModelRequest, ::google::cloud::automl::v1::Model>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetModelRequest* /*request*/, ::google::cloud::automl::v1::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetModel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::GetModelRequest* /*request*/, ::google::cloud::automl::v1::Model* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListModels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListModels() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::ListModelsRequest, ::google::cloud::automl::v1::ListModelsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::ListModelsRequest* request, ::google::cloud::automl::v1::ListModelsResponse* response) { return this->ListModels(context, request, response); }));}
    void SetMessageAllocatorFor_ListModels(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::ListModelsRequest, ::google::cloud::automl::v1::ListModelsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::ListModelsRequest, ::google::cloud::automl::v1::ListModelsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListModels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListModels(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ListModelsRequest* /*request*/, ::google::cloud::automl::v1::ListModelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListModels(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::ListModelsRequest* /*request*/, ::google::cloud::automl::v1::ListModelsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteModel() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::DeleteModelRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::DeleteModelRequest* request, ::google::longrunning::Operation* response) { return this->DeleteModel(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteModel(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::DeleteModelRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::DeleteModelRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::DeleteModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteModel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::DeleteModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateModel() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::UpdateModelRequest, ::google::cloud::automl::v1::Model>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::UpdateModelRequest* request, ::google::cloud::automl::v1::Model* response) { return this->UpdateModel(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateModel(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::UpdateModelRequest, ::google::cloud::automl::v1::Model>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::UpdateModelRequest, ::google::cloud::automl::v1::Model>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::UpdateModelRequest* /*request*/, ::google::cloud::automl::v1::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateModel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::UpdateModelRequest* /*request*/, ::google::cloud::automl::v1::Model* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeployModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeployModel() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::DeployModelRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::DeployModelRequest* request, ::google::longrunning::Operation* response) { return this->DeployModel(context, request, response); }));}
    void SetMessageAllocatorFor_DeployModel(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::DeployModelRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::DeployModelRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeployModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeployModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::DeployModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeployModel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::DeployModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UndeployModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UndeployModel() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::UndeployModelRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::UndeployModelRequest* request, ::google::longrunning::Operation* response) { return this->UndeployModel(context, request, response); }));}
    void SetMessageAllocatorFor_UndeployModel(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::UndeployModelRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::UndeployModelRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UndeployModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeployModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::UndeployModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UndeployModel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::UndeployModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ExportModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ExportModel() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::ExportModelRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::ExportModelRequest* request, ::google::longrunning::Operation* response) { return this->ExportModel(context, request, response); }));}
    void SetMessageAllocatorFor_ExportModel(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::ExportModelRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::ExportModelRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ExportModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ExportModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ExportModel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::ExportModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetModelEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetModelEvaluation() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::GetModelEvaluationRequest, ::google::cloud::automl::v1::ModelEvaluation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::GetModelEvaluationRequest* request, ::google::cloud::automl::v1::ModelEvaluation* response) { return this->GetModelEvaluation(context, request, response); }));}
    void SetMessageAllocatorFor_GetModelEvaluation(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::GetModelEvaluationRequest, ::google::cloud::automl::v1::ModelEvaluation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::GetModelEvaluationRequest, ::google::cloud::automl::v1::ModelEvaluation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetModelEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetModelEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetModelEvaluationRequest* /*request*/, ::google::cloud::automl::v1::ModelEvaluation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetModelEvaluation(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::GetModelEvaluationRequest* /*request*/, ::google::cloud::automl::v1::ModelEvaluation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListModelEvaluations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListModelEvaluations() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::ListModelEvaluationsRequest, ::google::cloud::automl::v1::ListModelEvaluationsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::automl::v1::ListModelEvaluationsRequest* request, ::google::cloud::automl::v1::ListModelEvaluationsResponse* response) { return this->ListModelEvaluations(context, request, response); }));}
    void SetMessageAllocatorFor_ListModelEvaluations(
        ::grpc::MessageAllocator< ::google::cloud::automl::v1::ListModelEvaluationsRequest, ::google::cloud::automl::v1::ListModelEvaluationsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::automl::v1::ListModelEvaluationsRequest, ::google::cloud::automl::v1::ListModelEvaluationsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListModelEvaluations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListModelEvaluations(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ListModelEvaluationsRequest* /*request*/, ::google::cloud::automl::v1::ListModelEvaluationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListModelEvaluations(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::automl::v1::ListModelEvaluationsRequest* /*request*/, ::google::cloud::automl::v1::ListModelEvaluationsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateDataset<WithCallbackMethod_GetDataset<WithCallbackMethod_ListDatasets<WithCallbackMethod_UpdateDataset<WithCallbackMethod_DeleteDataset<WithCallbackMethod_ImportData<WithCallbackMethod_ExportData<WithCallbackMethod_GetAnnotationSpec<WithCallbackMethod_CreateModel<WithCallbackMethod_GetModel<WithCallbackMethod_ListModels<WithCallbackMethod_DeleteModel<WithCallbackMethod_UpdateModel<WithCallbackMethod_DeployModel<WithCallbackMethod_UndeployModel<WithCallbackMethod_ExportModel<WithCallbackMethod_GetModelEvaluation<WithCallbackMethod_ListModelEvaluations<Service > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateDataset() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::CreateDatasetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetDataset() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetDatasetRequest* /*request*/, ::google::cloud::automl::v1::Dataset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListDatasets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListDatasets() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ListDatasets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDatasets(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ListDatasetsRequest* /*request*/, ::google::cloud::automl::v1::ListDatasetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateDataset() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::UpdateDatasetRequest* /*request*/, ::google::cloud::automl::v1::Dataset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteDataset() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::DeleteDatasetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ImportData : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ImportData() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ImportData() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportData(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ImportDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ExportData : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ExportData() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_ExportData() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportData(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ExportDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAnnotationSpec : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAnnotationSpec() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_GetAnnotationSpec() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAnnotationSpec(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetAnnotationSpecRequest* /*request*/, ::google::cloud::automl::v1::AnnotationSpec* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateModel() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_CreateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::CreateModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetModel() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_GetModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetModelRequest* /*request*/, ::google::cloud::automl::v1::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListModels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListModels() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_ListModels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListModels(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ListModelsRequest* /*request*/, ::google::cloud::automl::v1::ListModelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteModel() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_DeleteModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::DeleteModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateModel() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_UpdateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::UpdateModelRequest* /*request*/, ::google::cloud::automl::v1::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeployModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeployModel() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_DeployModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeployModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::DeployModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UndeployModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UndeployModel() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_UndeployModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeployModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::UndeployModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ExportModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ExportModel() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_ExportModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ExportModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetModelEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetModelEvaluation() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_GetModelEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetModelEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetModelEvaluationRequest* /*request*/, ::google::cloud::automl::v1::ModelEvaluation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListModelEvaluations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListModelEvaluations() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_ListModelEvaluations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListModelEvaluations(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ListModelEvaluationsRequest* /*request*/, ::google::cloud::automl::v1::ListModelEvaluationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateDataset() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::CreateDatasetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDataset(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetDataset() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetDatasetRequest* /*request*/, ::google::cloud::automl::v1::Dataset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDataset(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListDatasets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListDatasets() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ListDatasets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDatasets(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ListDatasetsRequest* /*request*/, ::google::cloud::automl::v1::ListDatasetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDatasets(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateDataset() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::UpdateDatasetRequest* /*request*/, ::google::cloud::automl::v1::Dataset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDataset(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteDataset() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::DeleteDatasetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDataset(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ImportData : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ImportData() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ImportData() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportData(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ImportDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportData(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ExportData : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ExportData() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_ExportData() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportData(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ExportDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportData(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAnnotationSpec : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAnnotationSpec() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_GetAnnotationSpec() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAnnotationSpec(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetAnnotationSpecRequest* /*request*/, ::google::cloud::automl::v1::AnnotationSpec* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAnnotationSpec(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateModel() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_CreateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::CreateModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateModel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetModel() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_GetModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetModelRequest* /*request*/, ::google::cloud::automl::v1::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetModel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListModels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListModels() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_ListModels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListModels(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ListModelsRequest* /*request*/, ::google::cloud::automl::v1::ListModelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListModels(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteModel() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_DeleteModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::DeleteModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteModel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateModel() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_UpdateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::UpdateModelRequest* /*request*/, ::google::cloud::automl::v1::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateModel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeployModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeployModel() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_DeployModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeployModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::DeployModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeployModel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UndeployModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UndeployModel() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_UndeployModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeployModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::UndeployModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUndeployModel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ExportModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ExportModel() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_ExportModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ExportModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportModel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetModelEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetModelEvaluation() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_GetModelEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetModelEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetModelEvaluationRequest* /*request*/, ::google::cloud::automl::v1::ModelEvaluation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetModelEvaluation(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListModelEvaluations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListModelEvaluations() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_ListModelEvaluations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListModelEvaluations(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ListModelEvaluationsRequest* /*request*/, ::google::cloud::automl::v1::ListModelEvaluationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListModelEvaluations(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateDataset() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateDataset(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::CreateDatasetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDataset(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetDataset() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetDataset(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetDatasetRequest* /*request*/, ::google::cloud::automl::v1::Dataset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDataset(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListDatasets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListDatasets() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListDatasets(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListDatasets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDatasets(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ListDatasetsRequest* /*request*/, ::google::cloud::automl::v1::ListDatasetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDatasets(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateDataset() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateDataset(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::UpdateDatasetRequest* /*request*/, ::google::cloud::automl::v1::Dataset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDataset(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteDataset() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteDataset(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::DeleteDatasetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDataset(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ImportData : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ImportData() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ImportData(context, request, response); }));
    }
    ~WithRawCallbackMethod_ImportData() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportData(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ImportDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportData(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ExportData : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ExportData() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ExportData(context, request, response); }));
    }
    ~WithRawCallbackMethod_ExportData() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportData(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ExportDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ExportData(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAnnotationSpec : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAnnotationSpec() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAnnotationSpec(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAnnotationSpec() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAnnotationSpec(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetAnnotationSpecRequest* /*request*/, ::google::cloud::automl::v1::AnnotationSpec* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAnnotationSpec(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateModel() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateModel(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::CreateModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateModel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetModel() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetModel(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetModelRequest* /*request*/, ::google::cloud::automl::v1::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetModel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListModels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListModels() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListModels(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListModels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListModels(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ListModelsRequest* /*request*/, ::google::cloud::automl::v1::ListModelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListModels(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteModel() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteModel(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::DeleteModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteModel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateModel() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateModel(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::UpdateModelRequest* /*request*/, ::google::cloud::automl::v1::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateModel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeployModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeployModel() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeployModel(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeployModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeployModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::DeployModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeployModel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UndeployModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UndeployModel() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UndeployModel(context, request, response); }));
    }
    ~WithRawCallbackMethod_UndeployModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeployModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::UndeployModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UndeployModel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ExportModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ExportModel() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ExportModel(context, request, response); }));
    }
    ~WithRawCallbackMethod_ExportModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ExportModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ExportModel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetModelEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetModelEvaluation() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetModelEvaluation(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetModelEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetModelEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetModelEvaluationRequest* /*request*/, ::google::cloud::automl::v1::ModelEvaluation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetModelEvaluation(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListModelEvaluations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListModelEvaluations() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListModelEvaluations(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListModelEvaluations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListModelEvaluations(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ListModelEvaluationsRequest* /*request*/, ::google::cloud::automl::v1::ListModelEvaluationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListModelEvaluations(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateDataset() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::CreateDatasetRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::CreateDatasetRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateDataset(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::CreateDatasetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateDataset(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::CreateDatasetRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetDataset() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::GetDatasetRequest, ::google::cloud::automl::v1::Dataset>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::GetDatasetRequest, ::google::cloud::automl::v1::Dataset>* streamer) {
                       return this->StreamedGetDataset(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetDatasetRequest* /*request*/, ::google::cloud::automl::v1::Dataset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetDataset(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::GetDatasetRequest,::google::cloud::automl::v1::Dataset>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListDatasets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListDatasets() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::ListDatasetsRequest, ::google::cloud::automl::v1::ListDatasetsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::ListDatasetsRequest, ::google::cloud::automl::v1::ListDatasetsResponse>* streamer) {
                       return this->StreamedListDatasets(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListDatasets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListDatasets(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ListDatasetsRequest* /*request*/, ::google::cloud::automl::v1::ListDatasetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListDatasets(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::ListDatasetsRequest,::google::cloud::automl::v1::ListDatasetsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateDataset() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::UpdateDatasetRequest, ::google::cloud::automl::v1::Dataset>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::UpdateDatasetRequest, ::google::cloud::automl::v1::Dataset>* streamer) {
                       return this->StreamedUpdateDataset(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::UpdateDatasetRequest* /*request*/, ::google::cloud::automl::v1::Dataset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateDataset(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::UpdateDatasetRequest,::google::cloud::automl::v1::Dataset>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteDataset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteDataset() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::DeleteDatasetRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::DeleteDatasetRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteDataset(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteDataset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteDataset(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::DeleteDatasetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteDataset(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::DeleteDatasetRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ImportData : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ImportData() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::ImportDataRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::ImportDataRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedImportData(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ImportData() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ImportData(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ImportDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedImportData(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::ImportDataRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ExportData : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ExportData() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::ExportDataRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::ExportDataRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedExportData(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ExportData() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ExportData(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ExportDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedExportData(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::ExportDataRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAnnotationSpec : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAnnotationSpec() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::GetAnnotationSpecRequest, ::google::cloud::automl::v1::AnnotationSpec>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::GetAnnotationSpecRequest, ::google::cloud::automl::v1::AnnotationSpec>* streamer) {
                       return this->StreamedGetAnnotationSpec(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAnnotationSpec() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAnnotationSpec(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetAnnotationSpecRequest* /*request*/, ::google::cloud::automl::v1::AnnotationSpec* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAnnotationSpec(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::GetAnnotationSpecRequest,::google::cloud::automl::v1::AnnotationSpec>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateModel() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::CreateModelRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::CreateModelRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateModel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::CreateModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateModel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::CreateModelRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetModel() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::GetModelRequest, ::google::cloud::automl::v1::Model>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::GetModelRequest, ::google::cloud::automl::v1::Model>* streamer) {
                       return this->StreamedGetModel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetModelRequest* /*request*/, ::google::cloud::automl::v1::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetModel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::GetModelRequest,::google::cloud::automl::v1::Model>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListModels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListModels() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::ListModelsRequest, ::google::cloud::automl::v1::ListModelsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::ListModelsRequest, ::google::cloud::automl::v1::ListModelsResponse>* streamer) {
                       return this->StreamedListModels(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListModels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListModels(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ListModelsRequest* /*request*/, ::google::cloud::automl::v1::ListModelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListModels(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::ListModelsRequest,::google::cloud::automl::v1::ListModelsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteModel() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::DeleteModelRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::DeleteModelRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteModel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::DeleteModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteModel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::DeleteModelRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateModel() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::UpdateModelRequest, ::google::cloud::automl::v1::Model>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::UpdateModelRequest, ::google::cloud::automl::v1::Model>* streamer) {
                       return this->StreamedUpdateModel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::UpdateModelRequest* /*request*/, ::google::cloud::automl::v1::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateModel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::UpdateModelRequest,::google::cloud::automl::v1::Model>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeployModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeployModel() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::DeployModelRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::DeployModelRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeployModel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeployModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeployModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::DeployModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeployModel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::DeployModelRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UndeployModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UndeployModel() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::UndeployModelRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::UndeployModelRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUndeployModel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UndeployModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UndeployModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::UndeployModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUndeployModel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::UndeployModelRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ExportModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ExportModel() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::ExportModelRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::ExportModelRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedExportModel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ExportModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ExportModel(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ExportModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedExportModel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::ExportModelRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetModelEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetModelEvaluation() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::GetModelEvaluationRequest, ::google::cloud::automl::v1::ModelEvaluation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::GetModelEvaluationRequest, ::google::cloud::automl::v1::ModelEvaluation>* streamer) {
                       return this->StreamedGetModelEvaluation(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetModelEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetModelEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::GetModelEvaluationRequest* /*request*/, ::google::cloud::automl::v1::ModelEvaluation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetModelEvaluation(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::GetModelEvaluationRequest,::google::cloud::automl::v1::ModelEvaluation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListModelEvaluations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListModelEvaluations() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::automl::v1::ListModelEvaluationsRequest, ::google::cloud::automl::v1::ListModelEvaluationsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::automl::v1::ListModelEvaluationsRequest, ::google::cloud::automl::v1::ListModelEvaluationsResponse>* streamer) {
                       return this->StreamedListModelEvaluations(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListModelEvaluations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListModelEvaluations(::grpc::ServerContext* /*context*/, const ::google::cloud::automl::v1::ListModelEvaluationsRequest* /*request*/, ::google::cloud::automl::v1::ListModelEvaluationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListModelEvaluations(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::automl::v1::ListModelEvaluationsRequest,::google::cloud::automl::v1::ListModelEvaluationsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateDataset<WithStreamedUnaryMethod_GetDataset<WithStreamedUnaryMethod_ListDatasets<WithStreamedUnaryMethod_UpdateDataset<WithStreamedUnaryMethod_DeleteDataset<WithStreamedUnaryMethod_ImportData<WithStreamedUnaryMethod_ExportData<WithStreamedUnaryMethod_GetAnnotationSpec<WithStreamedUnaryMethod_CreateModel<WithStreamedUnaryMethod_GetModel<WithStreamedUnaryMethod_ListModels<WithStreamedUnaryMethod_DeleteModel<WithStreamedUnaryMethod_UpdateModel<WithStreamedUnaryMethod_DeployModel<WithStreamedUnaryMethod_UndeployModel<WithStreamedUnaryMethod_ExportModel<WithStreamedUnaryMethod_GetModelEvaluation<WithStreamedUnaryMethod_ListModelEvaluations<Service > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateDataset<WithStreamedUnaryMethod_GetDataset<WithStreamedUnaryMethod_ListDatasets<WithStreamedUnaryMethod_UpdateDataset<WithStreamedUnaryMethod_DeleteDataset<WithStreamedUnaryMethod_ImportData<WithStreamedUnaryMethod_ExportData<WithStreamedUnaryMethod_GetAnnotationSpec<WithStreamedUnaryMethod_CreateModel<WithStreamedUnaryMethod_GetModel<WithStreamedUnaryMethod_ListModels<WithStreamedUnaryMethod_DeleteModel<WithStreamedUnaryMethod_UpdateModel<WithStreamedUnaryMethod_DeployModel<WithStreamedUnaryMethod_UndeployModel<WithStreamedUnaryMethod_ExportModel<WithStreamedUnaryMethod_GetModelEvaluation<WithStreamedUnaryMethod_ListModelEvaluations<Service > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace automl
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fautoml_2fv1_2fservice_2eproto__INCLUDED
