// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/metastore/v1/metastore.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fmetastore_2fv1_2fmetastore_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fmetastore_2fv1_2fmetastore_2eproto__INCLUDED

#include "google/cloud/metastore/v1/metastore.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace metastore {
namespace v1 {

// Configures and manages metastore services.
// Metastore services are fully managed, highly available, autoscaled,
// autohealing, OSS-native deployments of technical metadata management
// software. Each metastore service exposes a network endpoint through which
// metadata queries are served. Metadata queries can originate from a variety
// of sources, including Apache Hive, Apache Presto, and Apache Spark.
//
// The Dataproc Metastore API defines the following resource model:
//
// * The service works with a collection of Google Cloud projects, named:
// `/projects/*`
// * Each project has a collection of available locations, named: `/locations/*`
//   (a location must refer to a Google Cloud `region`)
// * Each location has a collection of services, named: `/services/*`
// * Dataproc Metastore services are resources with names of the form:
//
//   `/projects/{project_number}/locations/{location_id}/services/{service_id}`.
class DataprocMetastore final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.metastore.v1.DataprocMetastore";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists services in a project and location.
    virtual ::grpc::Status ListServices(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListServicesRequest& request, ::google::cloud::metastore::v1::ListServicesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListServicesResponse>> AsyncListServices(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListServicesResponse>>(AsyncListServicesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListServicesResponse>> PrepareAsyncListServices(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListServicesResponse>>(PrepareAsyncListServicesRaw(context, request, cq));
    }
    // Gets the details of a single service.
    virtual ::grpc::Status GetService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetServiceRequest& request, ::google::cloud::metastore::v1::Service* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::Service>> AsyncGetService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::Service>>(AsyncGetServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::Service>> PrepareAsyncGetService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::Service>>(PrepareAsyncGetServiceRaw(context, request, cq));
    }
    // Creates a metastore service in a project and location.
    virtual ::grpc::Status CreateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateServiceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateServiceRaw(context, request, cq));
    }
    // Updates the parameters of a single service.
    virtual ::grpc::Status UpdateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateServiceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateServiceRaw(context, request, cq));
    }
    // Deletes a single service.
    virtual ::grpc::Status DeleteService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteServiceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteServiceRaw(context, request, cq));
    }
    // Lists imports in a service.
    virtual ::grpc::Status ListMetadataImports(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListMetadataImportsRequest& request, ::google::cloud::metastore::v1::ListMetadataImportsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListMetadataImportsResponse>> AsyncListMetadataImports(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListMetadataImportsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListMetadataImportsResponse>>(AsyncListMetadataImportsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListMetadataImportsResponse>> PrepareAsyncListMetadataImports(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListMetadataImportsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListMetadataImportsResponse>>(PrepareAsyncListMetadataImportsRaw(context, request, cq));
    }
    // Gets details of a single import.
    virtual ::grpc::Status GetMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetMetadataImportRequest& request, ::google::cloud::metastore::v1::MetadataImport* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::MetadataImport>> AsyncGetMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetMetadataImportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::MetadataImport>>(AsyncGetMetadataImportRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::MetadataImport>> PrepareAsyncGetMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetMetadataImportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::MetadataImport>>(PrepareAsyncGetMetadataImportRaw(context, request, cq));
    }
    // Creates a new MetadataImport in a given project and location.
    virtual ::grpc::Status CreateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateMetadataImportRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateMetadataImportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateMetadataImportRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateMetadataImportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateMetadataImportRaw(context, request, cq));
    }
    // Updates a single import.
    // Only the description field of MetadataImport is supported to be updated.
    virtual ::grpc::Status UpdateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateMetadataImportRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateMetadataImportRaw(context, request, cq));
    }
    // Exports metadata from a service.
    virtual ::grpc::Status ExportMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ExportMetadataRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncExportMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ExportMetadataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncExportMetadataRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncExportMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ExportMetadataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncExportMetadataRaw(context, request, cq));
    }
    // Restores a service from a backup.
    virtual ::grpc::Status RestoreService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::RestoreServiceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncRestoreService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::RestoreServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncRestoreServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncRestoreService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::RestoreServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncRestoreServiceRaw(context, request, cq));
    }
    // Lists backups in a service.
    virtual ::grpc::Status ListBackups(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListBackupsRequest& request, ::google::cloud::metastore::v1::ListBackupsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListBackupsResponse>> AsyncListBackups(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListBackupsResponse>>(AsyncListBackupsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListBackupsResponse>> PrepareAsyncListBackups(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListBackupsResponse>>(PrepareAsyncListBackupsRaw(context, request, cq));
    }
    // Gets details of a single backup.
    virtual ::grpc::Status GetBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetBackupRequest& request, ::google::cloud::metastore::v1::Backup* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::Backup>> AsyncGetBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::Backup>>(AsyncGetBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::Backup>> PrepareAsyncGetBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::Backup>>(PrepareAsyncGetBackupRaw(context, request, cq));
    }
    // Creates a new backup in a given project and location.
    virtual ::grpc::Status CreateBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateBackupRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateBackupRaw(context, request, cq));
    }
    // Deletes a single backup.
    virtual ::grpc::Status DeleteBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteBackupRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteBackupRaw(context, request, cq));
    }
    // Query DPMS metadata.
    virtual ::grpc::Status QueryMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::QueryMetadataRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncQueryMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::QueryMetadataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncQueryMetadataRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncQueryMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::QueryMetadataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncQueryMetadataRaw(context, request, cq));
    }
    // Move a table to another database.
    virtual ::grpc::Status MoveTableToDatabase(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncMoveTableToDatabase(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncMoveTableToDatabaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncMoveTableToDatabase(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncMoveTableToDatabaseRaw(context, request, cq));
    }
    // Alter metadata resource location. The metadata resource can be a database,
    // table, or partition. This functionality only updates the parent directory
    // for the respective metadata resource and does not transfer any existing
    // data to the new location.
    virtual ::grpc::Status AlterMetadataResourceLocation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncAlterMetadataResourceLocation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncAlterMetadataResourceLocationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncAlterMetadataResourceLocation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncAlterMetadataResourceLocationRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists services in a project and location.
      virtual void ListServices(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListServicesRequest* request, ::google::cloud::metastore::v1::ListServicesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListServices(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListServicesRequest* request, ::google::cloud::metastore::v1::ListServicesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the details of a single service.
      virtual void GetService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetServiceRequest* request, ::google::cloud::metastore::v1::Service* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetServiceRequest* request, ::google::cloud::metastore::v1::Service* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a metastore service in a project and location.
      virtual void CreateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a single service.
      virtual void UpdateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single service.
      virtual void DeleteService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists imports in a service.
      virtual void ListMetadataImports(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListMetadataImportsRequest* request, ::google::cloud::metastore::v1::ListMetadataImportsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListMetadataImports(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListMetadataImportsRequest* request, ::google::cloud::metastore::v1::ListMetadataImportsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single import.
      virtual void GetMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetMetadataImportRequest* request, ::google::cloud::metastore::v1::MetadataImport* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetMetadataImportRequest* request, ::google::cloud::metastore::v1::MetadataImport* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new MetadataImport in a given project and location.
      virtual void CreateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateMetadataImportRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateMetadataImportRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a single import.
      // Only the description field of MetadataImport is supported to be updated.
      virtual void UpdateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Exports metadata from a service.
      virtual void ExportMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ExportMetadataRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ExportMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ExportMetadataRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Restores a service from a backup.
      virtual void RestoreService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::RestoreServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RestoreService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::RestoreServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists backups in a service.
      virtual void ListBackups(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListBackupsRequest* request, ::google::cloud::metastore::v1::ListBackupsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListBackups(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListBackupsRequest* request, ::google::cloud::metastore::v1::ListBackupsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single backup.
      virtual void GetBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetBackupRequest* request, ::google::cloud::metastore::v1::Backup* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetBackupRequest* request, ::google::cloud::metastore::v1::Backup* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new backup in a given project and location.
      virtual void CreateBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateBackupRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateBackupRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single backup.
      virtual void DeleteBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteBackupRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteBackupRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Query DPMS metadata.
      virtual void QueryMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::QueryMetadataRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void QueryMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::QueryMetadataRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Move a table to another database.
      virtual void MoveTableToDatabase(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void MoveTableToDatabase(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Alter metadata resource location. The metadata resource can be a database,
      // table, or partition. This functionality only updates the parent directory
      // for the respective metadata resource and does not transfer any existing
      // data to the new location.
      virtual void AlterMetadataResourceLocation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AlterMetadataResourceLocation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListServicesResponse>* AsyncListServicesRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListServicesResponse>* PrepareAsyncListServicesRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::Service>* AsyncGetServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::Service>* PrepareAsyncGetServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListMetadataImportsResponse>* AsyncListMetadataImportsRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListMetadataImportsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListMetadataImportsResponse>* PrepareAsyncListMetadataImportsRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListMetadataImportsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::MetadataImport>* AsyncGetMetadataImportRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetMetadataImportRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::MetadataImport>* PrepareAsyncGetMetadataImportRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetMetadataImportRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateMetadataImportRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateMetadataImportRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateMetadataImportRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateMetadataImportRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateMetadataImportRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateMetadataImportRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncExportMetadataRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ExportMetadataRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncExportMetadataRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ExportMetadataRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncRestoreServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::RestoreServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncRestoreServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::RestoreServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListBackupsResponse>* AsyncListBackupsRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListBackupsResponse>* PrepareAsyncListBackupsRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::Backup>* AsyncGetBackupRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::Backup>* PrepareAsyncGetBackupRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateBackupRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateBackupRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteBackupRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteBackupRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncQueryMetadataRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::QueryMetadataRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncQueryMetadataRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::QueryMetadataRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncMoveTableToDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncMoveTableToDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncAlterMetadataResourceLocationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncAlterMetadataResourceLocationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListServices(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListServicesRequest& request, ::google::cloud::metastore::v1::ListServicesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListServicesResponse>> AsyncListServices(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListServicesResponse>>(AsyncListServicesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListServicesResponse>> PrepareAsyncListServices(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListServicesResponse>>(PrepareAsyncListServicesRaw(context, request, cq));
    }
    ::grpc::Status GetService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetServiceRequest& request, ::google::cloud::metastore::v1::Service* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::Service>> AsyncGetService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::Service>>(AsyncGetServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::Service>> PrepareAsyncGetService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::Service>>(PrepareAsyncGetServiceRaw(context, request, cq));
    }
    ::grpc::Status CreateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateServiceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateServiceRaw(context, request, cq));
    }
    ::grpc::Status UpdateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateServiceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateServiceRaw(context, request, cq));
    }
    ::grpc::Status DeleteService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteServiceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteServiceRaw(context, request, cq));
    }
    ::grpc::Status ListMetadataImports(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListMetadataImportsRequest& request, ::google::cloud::metastore::v1::ListMetadataImportsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListMetadataImportsResponse>> AsyncListMetadataImports(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListMetadataImportsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListMetadataImportsResponse>>(AsyncListMetadataImportsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListMetadataImportsResponse>> PrepareAsyncListMetadataImports(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListMetadataImportsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListMetadataImportsResponse>>(PrepareAsyncListMetadataImportsRaw(context, request, cq));
    }
    ::grpc::Status GetMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetMetadataImportRequest& request, ::google::cloud::metastore::v1::MetadataImport* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::MetadataImport>> AsyncGetMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetMetadataImportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::MetadataImport>>(AsyncGetMetadataImportRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::MetadataImport>> PrepareAsyncGetMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetMetadataImportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::MetadataImport>>(PrepareAsyncGetMetadataImportRaw(context, request, cq));
    }
    ::grpc::Status CreateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateMetadataImportRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateMetadataImportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateMetadataImportRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateMetadataImportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateMetadataImportRaw(context, request, cq));
    }
    ::grpc::Status UpdateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateMetadataImportRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateMetadataImportRaw(context, request, cq));
    }
    ::grpc::Status ExportMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ExportMetadataRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncExportMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ExportMetadataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncExportMetadataRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncExportMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ExportMetadataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncExportMetadataRaw(context, request, cq));
    }
    ::grpc::Status RestoreService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::RestoreServiceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncRestoreService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::RestoreServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncRestoreServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncRestoreService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::RestoreServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncRestoreServiceRaw(context, request, cq));
    }
    ::grpc::Status ListBackups(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListBackupsRequest& request, ::google::cloud::metastore::v1::ListBackupsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListBackupsResponse>> AsyncListBackups(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListBackupsResponse>>(AsyncListBackupsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListBackupsResponse>> PrepareAsyncListBackups(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListBackupsResponse>>(PrepareAsyncListBackupsRaw(context, request, cq));
    }
    ::grpc::Status GetBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetBackupRequest& request, ::google::cloud::metastore::v1::Backup* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::Backup>> AsyncGetBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::Backup>>(AsyncGetBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::Backup>> PrepareAsyncGetBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::Backup>>(PrepareAsyncGetBackupRaw(context, request, cq));
    }
    ::grpc::Status CreateBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateBackupRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateBackupRaw(context, request, cq));
    }
    ::grpc::Status DeleteBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteBackupRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteBackupRaw(context, request, cq));
    }
    ::grpc::Status QueryMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::QueryMetadataRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncQueryMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::QueryMetadataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncQueryMetadataRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncQueryMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::QueryMetadataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncQueryMetadataRaw(context, request, cq));
    }
    ::grpc::Status MoveTableToDatabase(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncMoveTableToDatabase(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncMoveTableToDatabaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncMoveTableToDatabase(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncMoveTableToDatabaseRaw(context, request, cq));
    }
    ::grpc::Status AlterMetadataResourceLocation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncAlterMetadataResourceLocation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncAlterMetadataResourceLocationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncAlterMetadataResourceLocation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncAlterMetadataResourceLocationRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListServices(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListServicesRequest* request, ::google::cloud::metastore::v1::ListServicesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListServices(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListServicesRequest* request, ::google::cloud::metastore::v1::ListServicesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetServiceRequest* request, ::google::cloud::metastore::v1::Service* response, std::function<void(::grpc::Status)>) override;
      void GetService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetServiceRequest* request, ::google::cloud::metastore::v1::Service* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListMetadataImports(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListMetadataImportsRequest* request, ::google::cloud::metastore::v1::ListMetadataImportsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListMetadataImports(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListMetadataImportsRequest* request, ::google::cloud::metastore::v1::ListMetadataImportsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetMetadataImportRequest* request, ::google::cloud::metastore::v1::MetadataImport* response, std::function<void(::grpc::Status)>) override;
      void GetMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetMetadataImportRequest* request, ::google::cloud::metastore::v1::MetadataImport* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateMetadataImportRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateMetadataImportRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateMetadataImport(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ExportMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ExportMetadataRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ExportMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ExportMetadataRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RestoreService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::RestoreServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RestoreService(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::RestoreServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListBackups(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListBackupsRequest* request, ::google::cloud::metastore::v1::ListBackupsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListBackups(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListBackupsRequest* request, ::google::cloud::metastore::v1::ListBackupsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetBackupRequest* request, ::google::cloud::metastore::v1::Backup* response, std::function<void(::grpc::Status)>) override;
      void GetBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetBackupRequest* request, ::google::cloud::metastore::v1::Backup* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateBackupRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateBackupRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteBackupRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteBackup(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteBackupRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void QueryMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::QueryMetadataRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void QueryMetadata(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::QueryMetadataRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void MoveTableToDatabase(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void MoveTableToDatabase(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AlterMetadataResourceLocation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void AlterMetadataResourceLocation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListServicesResponse>* AsyncListServicesRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListServicesResponse>* PrepareAsyncListServicesRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::Service>* AsyncGetServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::Service>* PrepareAsyncGetServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListMetadataImportsResponse>* AsyncListMetadataImportsRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListMetadataImportsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListMetadataImportsResponse>* PrepareAsyncListMetadataImportsRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListMetadataImportsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::MetadataImport>* AsyncGetMetadataImportRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetMetadataImportRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::MetadataImport>* PrepareAsyncGetMetadataImportRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetMetadataImportRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateMetadataImportRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateMetadataImportRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateMetadataImportRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateMetadataImportRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateMetadataImportRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateMetadataImportRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncExportMetadataRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ExportMetadataRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncExportMetadataRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ExportMetadataRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncRestoreServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::RestoreServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncRestoreServiceRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::RestoreServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListBackupsResponse>* AsyncListBackupsRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListBackupsResponse>* PrepareAsyncListBackupsRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::Backup>* AsyncGetBackupRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::Backup>* PrepareAsyncGetBackupRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateBackupRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateBackupRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteBackupRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteBackupRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncQueryMetadataRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::QueryMetadataRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncQueryMetadataRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::QueryMetadataRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncMoveTableToDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncMoveTableToDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncAlterMetadataResourceLocationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncAlterMetadataResourceLocationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListServices_;
    const ::grpc::internal::RpcMethod rpcmethod_GetService_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateService_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateService_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteService_;
    const ::grpc::internal::RpcMethod rpcmethod_ListMetadataImports_;
    const ::grpc::internal::RpcMethod rpcmethod_GetMetadataImport_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateMetadataImport_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateMetadataImport_;
    const ::grpc::internal::RpcMethod rpcmethod_ExportMetadata_;
    const ::grpc::internal::RpcMethod rpcmethod_RestoreService_;
    const ::grpc::internal::RpcMethod rpcmethod_ListBackups_;
    const ::grpc::internal::RpcMethod rpcmethod_GetBackup_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateBackup_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteBackup_;
    const ::grpc::internal::RpcMethod rpcmethod_QueryMetadata_;
    const ::grpc::internal::RpcMethod rpcmethod_MoveTableToDatabase_;
    const ::grpc::internal::RpcMethod rpcmethod_AlterMetadataResourceLocation_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists services in a project and location.
    virtual ::grpc::Status ListServices(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::ListServicesRequest* request, ::google::cloud::metastore::v1::ListServicesResponse* response);
    // Gets the details of a single service.
    virtual ::grpc::Status GetService(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::GetServiceRequest* request, ::google::cloud::metastore::v1::Service* response);
    // Creates a metastore service in a project and location.
    virtual ::grpc::Status CreateService(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::CreateServiceRequest* request, ::google::longrunning::Operation* response);
    // Updates the parameters of a single service.
    virtual ::grpc::Status UpdateService(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::UpdateServiceRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single service.
    virtual ::grpc::Status DeleteService(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::DeleteServiceRequest* request, ::google::longrunning::Operation* response);
    // Lists imports in a service.
    virtual ::grpc::Status ListMetadataImports(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::ListMetadataImportsRequest* request, ::google::cloud::metastore::v1::ListMetadataImportsResponse* response);
    // Gets details of a single import.
    virtual ::grpc::Status GetMetadataImport(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::GetMetadataImportRequest* request, ::google::cloud::metastore::v1::MetadataImport* response);
    // Creates a new MetadataImport in a given project and location.
    virtual ::grpc::Status CreateMetadataImport(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::CreateMetadataImportRequest* request, ::google::longrunning::Operation* response);
    // Updates a single import.
    // Only the description field of MetadataImport is supported to be updated.
    virtual ::grpc::Status UpdateMetadataImport(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest* request, ::google::longrunning::Operation* response);
    // Exports metadata from a service.
    virtual ::grpc::Status ExportMetadata(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::ExportMetadataRequest* request, ::google::longrunning::Operation* response);
    // Restores a service from a backup.
    virtual ::grpc::Status RestoreService(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::RestoreServiceRequest* request, ::google::longrunning::Operation* response);
    // Lists backups in a service.
    virtual ::grpc::Status ListBackups(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::ListBackupsRequest* request, ::google::cloud::metastore::v1::ListBackupsResponse* response);
    // Gets details of a single backup.
    virtual ::grpc::Status GetBackup(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::GetBackupRequest* request, ::google::cloud::metastore::v1::Backup* response);
    // Creates a new backup in a given project and location.
    virtual ::grpc::Status CreateBackup(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::CreateBackupRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single backup.
    virtual ::grpc::Status DeleteBackup(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::DeleteBackupRequest* request, ::google::longrunning::Operation* response);
    // Query DPMS metadata.
    virtual ::grpc::Status QueryMetadata(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::QueryMetadataRequest* request, ::google::longrunning::Operation* response);
    // Move a table to another database.
    virtual ::grpc::Status MoveTableToDatabase(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest* request, ::google::longrunning::Operation* response);
    // Alter metadata resource location. The metadata resource can be a database,
    // table, or partition. This functionality only updates the parent directory
    // for the respective metadata resource and does not transfer any existing
    // data to the new location.
    virtual ::grpc::Status AlterMetadataResourceLocation(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListServices() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListServicesRequest* /*request*/, ::google::cloud::metastore::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListServices(::grpc::ServerContext* context, ::google::cloud::metastore::v1::ListServicesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::metastore::v1::ListServicesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetService() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetServiceRequest* /*request*/, ::google::cloud::metastore::v1::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetService(::grpc::ServerContext* context, ::google::cloud::metastore::v1::GetServiceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::metastore::v1::Service>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateService() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateService(::grpc::ServerContext* context, ::google::cloud::metastore::v1::CreateServiceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateService() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateService(::grpc::ServerContext* context, ::google::cloud::metastore::v1::UpdateServiceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteService() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteService(::grpc::ServerContext* context, ::google::cloud::metastore::v1::DeleteServiceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListMetadataImports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListMetadataImports() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListMetadataImports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListMetadataImports(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListMetadataImportsRequest* /*request*/, ::google::cloud::metastore::v1::ListMetadataImportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListMetadataImports(::grpc::ServerContext* context, ::google::cloud::metastore::v1::ListMetadataImportsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::metastore::v1::ListMetadataImportsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetMetadataImport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetMetadataImport() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GetMetadataImport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetMetadataImport(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetMetadataImportRequest* /*request*/, ::google::cloud::metastore::v1::MetadataImport* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetMetadataImport(::grpc::ServerContext* context, ::google::cloud::metastore::v1::GetMetadataImportRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::metastore::v1::MetadataImport>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateMetadataImport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateMetadataImport() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_CreateMetadataImport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateMetadataImport(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateMetadataImportRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateMetadataImport(::grpc::ServerContext* context, ::google::cloud::metastore::v1::CreateMetadataImportRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateMetadataImport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateMetadataImport() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_UpdateMetadataImport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateMetadataImport(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateMetadataImport(::grpc::ServerContext* context, ::google::cloud::metastore::v1::UpdateMetadataImportRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ExportMetadata : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ExportMetadata() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_ExportMetadata() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportMetadata(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ExportMetadataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportMetadata(::grpc::ServerContext* context, ::google::cloud::metastore::v1::ExportMetadataRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RestoreService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RestoreService() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_RestoreService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::RestoreServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRestoreService(::grpc::ServerContext* context, ::google::cloud::metastore::v1::RestoreServiceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListBackups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListBackups() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_ListBackups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackups(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListBackupsRequest* /*request*/, ::google::cloud::metastore::v1::ListBackupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBackups(::grpc::ServerContext* context, ::google::cloud::metastore::v1::ListBackupsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::metastore::v1::ListBackupsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetBackup() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_GetBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetBackupRequest* /*request*/, ::google::cloud::metastore::v1::Backup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBackup(::grpc::ServerContext* context, ::google::cloud::metastore::v1::GetBackupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::metastore::v1::Backup>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateBackup() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_CreateBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateBackup(::grpc::ServerContext* context, ::google::cloud::metastore::v1::CreateBackupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteBackup() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_DeleteBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteBackup(::grpc::ServerContext* context, ::google::cloud::metastore::v1::DeleteBackupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_QueryMetadata : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_QueryMetadata() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_QueryMetadata() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status QueryMetadata(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::QueryMetadataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestQueryMetadata(::grpc::ServerContext* context, ::google::cloud::metastore::v1::QueryMetadataRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_MoveTableToDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_MoveTableToDatabase() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_MoveTableToDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveTableToDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMoveTableToDatabase(::grpc::ServerContext* context, ::google::cloud::metastore::v1::MoveTableToDatabaseRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AlterMetadataResourceLocation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AlterMetadataResourceLocation() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_AlterMetadataResourceLocation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AlterMetadataResourceLocation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAlterMetadataResourceLocation(::grpc::ServerContext* context, ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListServices<WithAsyncMethod_GetService<WithAsyncMethod_CreateService<WithAsyncMethod_UpdateService<WithAsyncMethod_DeleteService<WithAsyncMethod_ListMetadataImports<WithAsyncMethod_GetMetadataImport<WithAsyncMethod_CreateMetadataImport<WithAsyncMethod_UpdateMetadataImport<WithAsyncMethod_ExportMetadata<WithAsyncMethod_RestoreService<WithAsyncMethod_ListBackups<WithAsyncMethod_GetBackup<WithAsyncMethod_CreateBackup<WithAsyncMethod_DeleteBackup<WithAsyncMethod_QueryMetadata<WithAsyncMethod_MoveTableToDatabase<WithAsyncMethod_AlterMetadataResourceLocation<Service > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListServices() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::ListServicesRequest, ::google::cloud::metastore::v1::ListServicesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::ListServicesRequest* request, ::google::cloud::metastore::v1::ListServicesResponse* response) { return this->ListServices(context, request, response); }));}
    void SetMessageAllocatorFor_ListServices(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::ListServicesRequest, ::google::cloud::metastore::v1::ListServicesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::ListServicesRequest, ::google::cloud::metastore::v1::ListServicesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListServicesRequest* /*request*/, ::google::cloud::metastore::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListServices(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::ListServicesRequest* /*request*/, ::google::cloud::metastore::v1::ListServicesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetService() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::GetServiceRequest, ::google::cloud::metastore::v1::Service>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::GetServiceRequest* request, ::google::cloud::metastore::v1::Service* response) { return this->GetService(context, request, response); }));}
    void SetMessageAllocatorFor_GetService(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::GetServiceRequest, ::google::cloud::metastore::v1::Service>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::GetServiceRequest, ::google::cloud::metastore::v1::Service>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetServiceRequest* /*request*/, ::google::cloud::metastore::v1::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetService(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::GetServiceRequest* /*request*/, ::google::cloud::metastore::v1::Service* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateService() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::CreateServiceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::CreateServiceRequest* request, ::google::longrunning::Operation* response) { return this->CreateService(context, request, response); }));}
    void SetMessageAllocatorFor_CreateService(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::CreateServiceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::CreateServiceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateService(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateService() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::UpdateServiceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::UpdateServiceRequest* request, ::google::longrunning::Operation* response) { return this->UpdateService(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateService(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::UpdateServiceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::UpdateServiceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateService(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteService() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::DeleteServiceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::DeleteServiceRequest* request, ::google::longrunning::Operation* response) { return this->DeleteService(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteService(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::DeleteServiceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::DeleteServiceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteService(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListMetadataImports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListMetadataImports() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::ListMetadataImportsRequest, ::google::cloud::metastore::v1::ListMetadataImportsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::ListMetadataImportsRequest* request, ::google::cloud::metastore::v1::ListMetadataImportsResponse* response) { return this->ListMetadataImports(context, request, response); }));}
    void SetMessageAllocatorFor_ListMetadataImports(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::ListMetadataImportsRequest, ::google::cloud::metastore::v1::ListMetadataImportsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::ListMetadataImportsRequest, ::google::cloud::metastore::v1::ListMetadataImportsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListMetadataImports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListMetadataImports(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListMetadataImportsRequest* /*request*/, ::google::cloud::metastore::v1::ListMetadataImportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListMetadataImports(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::ListMetadataImportsRequest* /*request*/, ::google::cloud::metastore::v1::ListMetadataImportsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetMetadataImport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetMetadataImport() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::GetMetadataImportRequest, ::google::cloud::metastore::v1::MetadataImport>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::GetMetadataImportRequest* request, ::google::cloud::metastore::v1::MetadataImport* response) { return this->GetMetadataImport(context, request, response); }));}
    void SetMessageAllocatorFor_GetMetadataImport(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::GetMetadataImportRequest, ::google::cloud::metastore::v1::MetadataImport>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::GetMetadataImportRequest, ::google::cloud::metastore::v1::MetadataImport>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetMetadataImport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetMetadataImport(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetMetadataImportRequest* /*request*/, ::google::cloud::metastore::v1::MetadataImport* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetMetadataImport(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::GetMetadataImportRequest* /*request*/, ::google::cloud::metastore::v1::MetadataImport* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateMetadataImport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateMetadataImport() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::CreateMetadataImportRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::CreateMetadataImportRequest* request, ::google::longrunning::Operation* response) { return this->CreateMetadataImport(context, request, response); }));}
    void SetMessageAllocatorFor_CreateMetadataImport(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::CreateMetadataImportRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::CreateMetadataImportRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateMetadataImport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateMetadataImport(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateMetadataImportRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateMetadataImport(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateMetadataImportRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateMetadataImport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateMetadataImport() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::UpdateMetadataImportRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest* request, ::google::longrunning::Operation* response) { return this->UpdateMetadataImport(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateMetadataImport(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::UpdateMetadataImportRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::UpdateMetadataImportRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateMetadataImport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateMetadataImport(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateMetadataImport(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ExportMetadata : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ExportMetadata() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::ExportMetadataRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::ExportMetadataRequest* request, ::google::longrunning::Operation* response) { return this->ExportMetadata(context, request, response); }));}
    void SetMessageAllocatorFor_ExportMetadata(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::ExportMetadataRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::ExportMetadataRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ExportMetadata() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportMetadata(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ExportMetadataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ExportMetadata(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::ExportMetadataRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RestoreService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RestoreService() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::RestoreServiceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::RestoreServiceRequest* request, ::google::longrunning::Operation* response) { return this->RestoreService(context, request, response); }));}
    void SetMessageAllocatorFor_RestoreService(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::RestoreServiceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::RestoreServiceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RestoreService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::RestoreServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RestoreService(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::RestoreServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListBackups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListBackups() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::ListBackupsRequest, ::google::cloud::metastore::v1::ListBackupsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::ListBackupsRequest* request, ::google::cloud::metastore::v1::ListBackupsResponse* response) { return this->ListBackups(context, request, response); }));}
    void SetMessageAllocatorFor_ListBackups(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::ListBackupsRequest, ::google::cloud::metastore::v1::ListBackupsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::ListBackupsRequest, ::google::cloud::metastore::v1::ListBackupsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListBackups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackups(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListBackupsRequest* /*request*/, ::google::cloud::metastore::v1::ListBackupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBackups(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::ListBackupsRequest* /*request*/, ::google::cloud::metastore::v1::ListBackupsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetBackup() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::GetBackupRequest, ::google::cloud::metastore::v1::Backup>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::GetBackupRequest* request, ::google::cloud::metastore::v1::Backup* response) { return this->GetBackup(context, request, response); }));}
    void SetMessageAllocatorFor_GetBackup(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::GetBackupRequest, ::google::cloud::metastore::v1::Backup>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::GetBackupRequest, ::google::cloud::metastore::v1::Backup>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetBackupRequest* /*request*/, ::google::cloud::metastore::v1::Backup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::GetBackupRequest* /*request*/, ::google::cloud::metastore::v1::Backup* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateBackup() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::CreateBackupRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::CreateBackupRequest* request, ::google::longrunning::Operation* response) { return this->CreateBackup(context, request, response); }));}
    void SetMessageAllocatorFor_CreateBackup(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::CreateBackupRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::CreateBackupRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteBackup() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::DeleteBackupRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::DeleteBackupRequest* request, ::google::longrunning::Operation* response) { return this->DeleteBackup(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteBackup(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::DeleteBackupRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::DeleteBackupRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_QueryMetadata : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_QueryMetadata() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::QueryMetadataRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::QueryMetadataRequest* request, ::google::longrunning::Operation* response) { return this->QueryMetadata(context, request, response); }));}
    void SetMessageAllocatorFor_QueryMetadata(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::QueryMetadataRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::QueryMetadataRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_QueryMetadata() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status QueryMetadata(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::QueryMetadataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* QueryMetadata(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::QueryMetadataRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_MoveTableToDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_MoveTableToDatabase() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::MoveTableToDatabaseRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest* request, ::google::longrunning::Operation* response) { return this->MoveTableToDatabase(context, request, response); }));}
    void SetMessageAllocatorFor_MoveTableToDatabase(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::MoveTableToDatabaseRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::MoveTableToDatabaseRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_MoveTableToDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveTableToDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MoveTableToDatabase(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AlterMetadataResourceLocation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AlterMetadataResourceLocation() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest* request, ::google::longrunning::Operation* response) { return this->AlterMetadataResourceLocation(context, request, response); }));}
    void SetMessageAllocatorFor_AlterMetadataResourceLocation(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AlterMetadataResourceLocation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AlterMetadataResourceLocation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AlterMetadataResourceLocation(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListServices<WithCallbackMethod_GetService<WithCallbackMethod_CreateService<WithCallbackMethod_UpdateService<WithCallbackMethod_DeleteService<WithCallbackMethod_ListMetadataImports<WithCallbackMethod_GetMetadataImport<WithCallbackMethod_CreateMetadataImport<WithCallbackMethod_UpdateMetadataImport<WithCallbackMethod_ExportMetadata<WithCallbackMethod_RestoreService<WithCallbackMethod_ListBackups<WithCallbackMethod_GetBackup<WithCallbackMethod_CreateBackup<WithCallbackMethod_DeleteBackup<WithCallbackMethod_QueryMetadata<WithCallbackMethod_MoveTableToDatabase<WithCallbackMethod_AlterMetadataResourceLocation<Service > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListServices() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListServicesRequest* /*request*/, ::google::cloud::metastore::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetService() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetServiceRequest* /*request*/, ::google::cloud::metastore::v1::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateService() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateService() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteService() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListMetadataImports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListMetadataImports() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListMetadataImports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListMetadataImports(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListMetadataImportsRequest* /*request*/, ::google::cloud::metastore::v1::ListMetadataImportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetMetadataImport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetMetadataImport() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GetMetadataImport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetMetadataImport(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetMetadataImportRequest* /*request*/, ::google::cloud::metastore::v1::MetadataImport* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateMetadataImport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateMetadataImport() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_CreateMetadataImport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateMetadataImport(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateMetadataImportRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateMetadataImport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateMetadataImport() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_UpdateMetadataImport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateMetadataImport(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ExportMetadata : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ExportMetadata() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_ExportMetadata() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportMetadata(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ExportMetadataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RestoreService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RestoreService() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_RestoreService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::RestoreServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListBackups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListBackups() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_ListBackups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackups(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListBackupsRequest* /*request*/, ::google::cloud::metastore::v1::ListBackupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetBackup() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_GetBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetBackupRequest* /*request*/, ::google::cloud::metastore::v1::Backup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateBackup() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_CreateBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteBackup() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_DeleteBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_QueryMetadata : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_QueryMetadata() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_QueryMetadata() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status QueryMetadata(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::QueryMetadataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_MoveTableToDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_MoveTableToDatabase() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_MoveTableToDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveTableToDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AlterMetadataResourceLocation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AlterMetadataResourceLocation() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_AlterMetadataResourceLocation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AlterMetadataResourceLocation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListServices() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListServicesRequest* /*request*/, ::google::cloud::metastore::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListServices(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetService() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetServiceRequest* /*request*/, ::google::cloud::metastore::v1::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetService(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateService() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateService(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateService() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateService(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteService() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteService(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListMetadataImports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListMetadataImports() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListMetadataImports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListMetadataImports(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListMetadataImportsRequest* /*request*/, ::google::cloud::metastore::v1::ListMetadataImportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListMetadataImports(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetMetadataImport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetMetadataImport() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GetMetadataImport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetMetadataImport(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetMetadataImportRequest* /*request*/, ::google::cloud::metastore::v1::MetadataImport* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetMetadataImport(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateMetadataImport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateMetadataImport() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_CreateMetadataImport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateMetadataImport(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateMetadataImportRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateMetadataImport(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateMetadataImport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateMetadataImport() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_UpdateMetadataImport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateMetadataImport(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateMetadataImport(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ExportMetadata : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ExportMetadata() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_ExportMetadata() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportMetadata(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ExportMetadataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportMetadata(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RestoreService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RestoreService() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_RestoreService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::RestoreServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRestoreService(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListBackups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListBackups() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_ListBackups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackups(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListBackupsRequest* /*request*/, ::google::cloud::metastore::v1::ListBackupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBackups(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetBackup() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_GetBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetBackupRequest* /*request*/, ::google::cloud::metastore::v1::Backup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBackup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateBackup() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_CreateBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateBackup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteBackup() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_DeleteBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteBackup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_QueryMetadata : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_QueryMetadata() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_QueryMetadata() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status QueryMetadata(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::QueryMetadataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestQueryMetadata(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_MoveTableToDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_MoveTableToDatabase() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_MoveTableToDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveTableToDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMoveTableToDatabase(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AlterMetadataResourceLocation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AlterMetadataResourceLocation() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_AlterMetadataResourceLocation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AlterMetadataResourceLocation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAlterMetadataResourceLocation(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListServices() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListServices(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListServicesRequest* /*request*/, ::google::cloud::metastore::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListServices(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetService() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetService(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetServiceRequest* /*request*/, ::google::cloud::metastore::v1::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetService(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateService() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateService(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateService(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateService() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateService(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateService(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteService() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteService(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteService(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListMetadataImports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListMetadataImports() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListMetadataImports(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListMetadataImports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListMetadataImports(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListMetadataImportsRequest* /*request*/, ::google::cloud::metastore::v1::ListMetadataImportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListMetadataImports(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetMetadataImport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetMetadataImport() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetMetadataImport(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetMetadataImport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetMetadataImport(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetMetadataImportRequest* /*request*/, ::google::cloud::metastore::v1::MetadataImport* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetMetadataImport(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateMetadataImport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateMetadataImport() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateMetadataImport(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateMetadataImport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateMetadataImport(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateMetadataImportRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateMetadataImport(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateMetadataImport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateMetadataImport() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateMetadataImport(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateMetadataImport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateMetadataImport(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateMetadataImport(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ExportMetadata : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ExportMetadata() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ExportMetadata(context, request, response); }));
    }
    ~WithRawCallbackMethod_ExportMetadata() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportMetadata(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ExportMetadataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ExportMetadata(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RestoreService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RestoreService() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RestoreService(context, request, response); }));
    }
    ~WithRawCallbackMethod_RestoreService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::RestoreServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RestoreService(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListBackups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListBackups() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListBackups(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListBackups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackups(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListBackupsRequest* /*request*/, ::google::cloud::metastore::v1::ListBackupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBackups(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetBackup() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetBackup(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetBackupRequest* /*request*/, ::google::cloud::metastore::v1::Backup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateBackup() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateBackup(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteBackup() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteBackup(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_QueryMetadata : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_QueryMetadata() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->QueryMetadata(context, request, response); }));
    }
    ~WithRawCallbackMethod_QueryMetadata() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status QueryMetadata(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::QueryMetadataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* QueryMetadata(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_MoveTableToDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_MoveTableToDatabase() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->MoveTableToDatabase(context, request, response); }));
    }
    ~WithRawCallbackMethod_MoveTableToDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveTableToDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MoveTableToDatabase(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AlterMetadataResourceLocation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AlterMetadataResourceLocation() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AlterMetadataResourceLocation(context, request, response); }));
    }
    ~WithRawCallbackMethod_AlterMetadataResourceLocation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AlterMetadataResourceLocation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AlterMetadataResourceLocation(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListServices() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::ListServicesRequest, ::google::cloud::metastore::v1::ListServicesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::ListServicesRequest, ::google::cloud::metastore::v1::ListServicesResponse>* streamer) {
                       return this->StreamedListServices(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListServicesRequest* /*request*/, ::google::cloud::metastore::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListServices(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::ListServicesRequest,::google::cloud::metastore::v1::ListServicesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetService() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::GetServiceRequest, ::google::cloud::metastore::v1::Service>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::GetServiceRequest, ::google::cloud::metastore::v1::Service>* streamer) {
                       return this->StreamedGetService(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetServiceRequest* /*request*/, ::google::cloud::metastore::v1::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetService(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::GetServiceRequest,::google::cloud::metastore::v1::Service>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateService() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::CreateServiceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::CreateServiceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateService(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateService(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::CreateServiceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateService() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::UpdateServiceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::UpdateServiceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateService(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateService(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::UpdateServiceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteService() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::DeleteServiceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::DeleteServiceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteService(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteService(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::DeleteServiceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListMetadataImports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListMetadataImports() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::ListMetadataImportsRequest, ::google::cloud::metastore::v1::ListMetadataImportsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::ListMetadataImportsRequest, ::google::cloud::metastore::v1::ListMetadataImportsResponse>* streamer) {
                       return this->StreamedListMetadataImports(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListMetadataImports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListMetadataImports(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListMetadataImportsRequest* /*request*/, ::google::cloud::metastore::v1::ListMetadataImportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListMetadataImports(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::ListMetadataImportsRequest,::google::cloud::metastore::v1::ListMetadataImportsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetMetadataImport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetMetadataImport() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::GetMetadataImportRequest, ::google::cloud::metastore::v1::MetadataImport>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::GetMetadataImportRequest, ::google::cloud::metastore::v1::MetadataImport>* streamer) {
                       return this->StreamedGetMetadataImport(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetMetadataImport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetMetadataImport(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetMetadataImportRequest* /*request*/, ::google::cloud::metastore::v1::MetadataImport* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetMetadataImport(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::GetMetadataImportRequest,::google::cloud::metastore::v1::MetadataImport>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateMetadataImport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateMetadataImport() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::CreateMetadataImportRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::CreateMetadataImportRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateMetadataImport(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateMetadataImport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateMetadataImport(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateMetadataImportRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateMetadataImport(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::CreateMetadataImportRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateMetadataImport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateMetadataImport() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::UpdateMetadataImportRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::UpdateMetadataImportRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateMetadataImport(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateMetadataImport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateMetadataImport(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateMetadataImportRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateMetadataImport(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::UpdateMetadataImportRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ExportMetadata : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ExportMetadata() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::ExportMetadataRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::ExportMetadataRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedExportMetadata(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ExportMetadata() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ExportMetadata(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ExportMetadataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedExportMetadata(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::ExportMetadataRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RestoreService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RestoreService() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::RestoreServiceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::RestoreServiceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedRestoreService(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RestoreService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RestoreService(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::RestoreServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRestoreService(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::RestoreServiceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListBackups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListBackups() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::ListBackupsRequest, ::google::cloud::metastore::v1::ListBackupsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::ListBackupsRequest, ::google::cloud::metastore::v1::ListBackupsResponse>* streamer) {
                       return this->StreamedListBackups(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListBackups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListBackups(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListBackupsRequest* /*request*/, ::google::cloud::metastore::v1::ListBackupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListBackups(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::ListBackupsRequest,::google::cloud::metastore::v1::ListBackupsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetBackup() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::GetBackupRequest, ::google::cloud::metastore::v1::Backup>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::GetBackupRequest, ::google::cloud::metastore::v1::Backup>* streamer) {
                       return this->StreamedGetBackup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetBackupRequest* /*request*/, ::google::cloud::metastore::v1::Backup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetBackup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::GetBackupRequest,::google::cloud::metastore::v1::Backup>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateBackup() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::CreateBackupRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::CreateBackupRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateBackup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateBackup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::CreateBackupRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteBackup() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::DeleteBackupRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::DeleteBackupRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteBackup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteBackup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::DeleteBackupRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_QueryMetadata : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_QueryMetadata() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::QueryMetadataRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::QueryMetadataRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedQueryMetadata(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_QueryMetadata() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status QueryMetadata(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::QueryMetadataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedQueryMetadata(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::QueryMetadataRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_MoveTableToDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_MoveTableToDatabase() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::MoveTableToDatabaseRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::MoveTableToDatabaseRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedMoveTableToDatabase(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_MoveTableToDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status MoveTableToDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::MoveTableToDatabaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedMoveTableToDatabase(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::MoveTableToDatabaseRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AlterMetadataResourceLocation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AlterMetadataResourceLocation() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedAlterMetadataResourceLocation(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AlterMetadataResourceLocation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AlterMetadataResourceLocation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAlterMetadataResourceLocation(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::AlterMetadataResourceLocationRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListServices<WithStreamedUnaryMethod_GetService<WithStreamedUnaryMethod_CreateService<WithStreamedUnaryMethod_UpdateService<WithStreamedUnaryMethod_DeleteService<WithStreamedUnaryMethod_ListMetadataImports<WithStreamedUnaryMethod_GetMetadataImport<WithStreamedUnaryMethod_CreateMetadataImport<WithStreamedUnaryMethod_UpdateMetadataImport<WithStreamedUnaryMethod_ExportMetadata<WithStreamedUnaryMethod_RestoreService<WithStreamedUnaryMethod_ListBackups<WithStreamedUnaryMethod_GetBackup<WithStreamedUnaryMethod_CreateBackup<WithStreamedUnaryMethod_DeleteBackup<WithStreamedUnaryMethod_QueryMetadata<WithStreamedUnaryMethod_MoveTableToDatabase<WithStreamedUnaryMethod_AlterMetadataResourceLocation<Service > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListServices<WithStreamedUnaryMethod_GetService<WithStreamedUnaryMethod_CreateService<WithStreamedUnaryMethod_UpdateService<WithStreamedUnaryMethod_DeleteService<WithStreamedUnaryMethod_ListMetadataImports<WithStreamedUnaryMethod_GetMetadataImport<WithStreamedUnaryMethod_CreateMetadataImport<WithStreamedUnaryMethod_UpdateMetadataImport<WithStreamedUnaryMethod_ExportMetadata<WithStreamedUnaryMethod_RestoreService<WithStreamedUnaryMethod_ListBackups<WithStreamedUnaryMethod_GetBackup<WithStreamedUnaryMethod_CreateBackup<WithStreamedUnaryMethod_DeleteBackup<WithStreamedUnaryMethod_QueryMetadata<WithStreamedUnaryMethod_MoveTableToDatabase<WithStreamedUnaryMethod_AlterMetadataResourceLocation<Service > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace metastore
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fmetastore_2fv1_2fmetastore_2eproto__INCLUDED
